      SUBROUTINE BPATHN (UAN,FILEN,PATHN)
C***********************************************************************        
C                                                                               
C   NAME- BPATHN                                                                
C                                                                               
C   LANGUAGE- VS FORT     TYPE- SUBROUTINE                                      
C                                                                               
C   VERSION-  1.00  DATE- 09/15/06  PROGRAMMER- SCHREITZ, R.  EC1300
C                                                                               
C   FUNCTION-                                                                   
C                                                                               
C     BUILDS A COMPOSITE PATH NAME FROM AN ANCHOR NAME AND A FILE NAME.
C                                                                               
C   CALLING SEQUENCE PARAMETERS-                                                
C
C     UAN     I*4      UNIT NUMBER FOR ANCHOR
                       INTEGER*4 UAN
C     FILEN   C*30     FILE NAME
                       CHARACTER*30 FILEN
C     PATHN   C*80     PATH NAME
                       CHARACTER*80 PATHN
C                                                                               
C   KEY LOCAL PARAMETERS-                                                       
C                                                                               
C     ANCHOR  C*80     PRIMARY DIRECTORY OR DIRECTORIES IN PATHNAME             
                       CHARACTER*80 ANCHOR                                      
C                                                                               
C***********************************************************************        
C                                                                               
C     READ THE ANCHOR.                                                          
      READ (UAN,2010,ERR=10,IOSTAT=IOS,END=10) ANCHOR
      GO TO 20                                                                  
C                                                                               
C     IF NO ANCHOR IS SPECIFIED, SET THE ANCHOR LENGTH TO ZERO.                 
   10 IF (IOS.EQ.-1) THEN                                                       
      LEN = 0                                                                   
      PRINT 3010                                                                
      GO TO 100                                                                 
      ELSE                                                                      
      PRINT 3910, IOS                                                           
      GO TO 990                                                                 
      END IF                                                                    
C                                                                               
C     IF AN ANCHOR IS SPECIFIED, DETERMINE ITS LENGTH.                          
   20 DO L = 1,80                                                               
      IF (ANCHOR(L:L).EQ.' ') THEN
         LEN = L - 1                                                            
         IF (LEN.EQ.0) THEN                                                     
            PRINT 3010                                                          
         ELSE                                                                   
            PRINT 3020, ANCHOR(01:40)                                           
         END IF                                                                 
         GO TO 100
      END IF                                                                    
      END DO
C
  100 PATHN = ANCHOR(1:LEN)//'/'//FILEN(1:30)
      PRINT 2210, PATHN
      GO TO 990                                                                 
C                                                                               
  910 PRINT 3910, IOS                                                           
C                                                                               
  990 RETURN                                                                    
C                                                                               
 2010 FORMAT (A80)                                                              
 2110 FORMAT (A1)                                                               
 2120 FORMAT (I3)                                                               
 2210 FORMAT (T22,A80)
 3010 FORMAT (T16,'* * * PATHNAME ANCHOR FOR DATABASE FRAMES * * *'/            
     +        T16,'                 NOT REQUESTED'////)                         
 3020 FORMAT (T16,'* * * PATHNAME ANCHOR FOR DATABASE FRAMES * * *'/            
     +        T16,'              (DEFINED ON UNIT 10)'///                       
     +        T22,A40//)                                                        
 3910 FORMAT (' ','ABNORMAL CONDITION ENCOUNTERED READING ANCHOR FILE'/         
     +        ' ','IOSTAT = ',I3)                                               
      END                                                                       
