      SUBROUTINE BSTHB (IRECFGS,IRECLGS,STAT,IOS)
C***********************************************************************
C                                                                       
C   NAME- BSTHB
C                                                                       
C   LANGUAGE- FORTRAN     TYPE- SUBROUTINE                              
C                                                                       
C   VERSION-  2.00  DATE- 08/30/05  PROGRAMMER- SCHREITZ, R.  EC1300
C   VERSION-  2.00  DATE- 08/29/06  PROGRAMMER- SCHREITZ, R.  EC2200
C                   REMOVAL OF FAX/WEFAX PROCESSING, CONVERSION TO AIX,
C                   MODERNIZATION AND/OR SIMPLIFICATION OF LOGIC.
C   VERSION-  2.01  DATE- 05/22/07  PROGRAMMER- SCHREITZ, R.  EC2200
C                   RETRIEVAL OF FRAME END TIME.
C   VERSION-  3.01  DATE- 11/25/08  PROGRAMMER- SCHREITZ, R.  EC2200
C                   RETRIEVAL AND DISPLAY OF IMAGING MODE.
C                                                                       
C   FUNCTION-
C
C       BUILDS THE STATUS HEADER BLOCK FOR AN IMAGER DATABASE FRAME.
C                                                                       
C   CALLING SEQUENCE PARAMETERS-                                        
C
C     IRECFGS           RECORD NUMBER OF FIRST GOOD SCAN
C     IRECLGS           RECORD NUMBER OF LAST GOOD SCAN
C     STAT              LAST VALUE OF STAT: 0 OR 91 OR 92
                        INTEGER*4 STAT
C     IOS               LAST VALUE OF IOSTAT, THE IO STATUS AFTER
C                       OPENING OR ATTEMPTING TO OPEN OR
C                       READING OR ATTEMPTING TO READ
C                       THE GOES 1A AFEP DOCUMENTATION FILE
C
C                                                                       
C   COMMON AREA PARAMETERS-                                             
C
      INCLUDE 'rconst.i'
      INCLUDE 'statushb.i'
      INCLUDE 'vsfio.i'
      INCLUDE 'kdocij.i'
C
C   KEY LOCAL PARAMETERS-                                               
C
C     IDOCR1_C          FIRST RECORD OF THE DOCUMENTATION FILE (HEADER)
                        CHARACTER*8132  IDOCR1_C
C     IDOCR1            FIRST RECORD OF THE DOCUMENTATION FILE (HEADER)
                        INTEGER*2       IDOCR1(4066)
                        EQUIVALENCE    (IDOCR1(1),IDOCR1_C)
C     IDOCRLGS_C        DOCUMENTATION RECORD FOR THE LAST GOOD SCAN
                        CHARACTER*8132  IDOCRLGS_C
C     IDOCRLGS          DOCUMENTATION RECORD FOR THE LAST GOOD SCAN
                        INTEGER*2       IDOCRLGS(4066)
                        EQUIVALENCE    (IDOCRLGS(1),IDOCRLGS_C)
C     NSAT              A BINARY NUMBER SPECIFYING THE SOURCE SATELLITE
C                       14 = GOES-14
C                       15 = GOES-15
                        INTEGER*4 NSAT
C     IT                CDA TIME TAG
                        INTEGER*2 IT(16)
C     IT(01)            YEAR IN 1000S
C     IT(02)            YEAR IN 100S
C     IT(03)            YEAR IN 10S
C     IT(04)            YEAR IN 1S
C     IT(05)            DAY OF YEAR IN 100S
C     IT(06)            DAY OF YEAR IN 10S
C     IT(07)            DAY OF YEAR IN 1S
C     IT(08)            HOURS IN 10S
C     IT(09)            HOURS IN 1S
C     IT(10)            MINUTES IN 10S
C     IT(11)            MINUTES IN 1S
C     IT(12)            SECONDS IN 10S
C     IT(13)            SECONDS IN 1S
C     IT(14)            MSEC IN 100S
C     IT(15)            MSEC IN 10S
C     IT(16)            MSEC IN 1S
C
C     ITCURHB           TIME OF CURRENT HEADER BLOCK IN CDA TIME TAG
C                       FORMAT
                        INTEGER*4 ITCURHB(2)
                        EQUIVALENCE (ITCURHB(1),IDOCRFGS(61))
C     ITCURTB           TIME OF CURRENT TRAILER BLOCK IN CDA TIME TAG
C                       FORMAT
                        INTEGER*4 ITCURTB(2)
                        EQUIVALENCE (ITCURTB(1),IDOCRLGS(65))
C     ITBUF             BUFFER USED IN THE EXTRACTION OF THE 4-BIT
C                       COMPONENTS OF TIME FROM THE CDA TIME TAG
                        INTEGER*4 ITBUF(2)
C     IMODE		CURRENT IMAGING MODE
C                       1 = ROUTINE
C                       2 = RAPID SCAN
C                       3 = SUPER RAPID SCAN
C                       4 = CHECKOUT / SPECIAL SHORT TERM
                        INTEGER*4 IMODE
      DATA KB0H/2772/
      DATA KB0D/2862/
C
C     STATEMENT FUNCTIONS
C
      K_1_8(K_1) = ((K_1 - 1)/8) + 1
      K_1_4(K_1) = ((K_1 - 1)/4) + 1
      K_1_2(K_1) = ((K_1 - 1)/2) + 1
c
      K_2_1(K_2) = ((K_2 - 1)*2) + 1
      K_4_1(K_4) = ((K_4 - 1)*4) + 1
      K_8_1(K_8) = ((K_8 - 1)*8) + 1
C
      IZ4(I) = ((I - 1)/4) + 1    ! BYTE ADDRESS TO 32-BIT WORD ADDRESS
      IZ2(I) = ((I - 1)/2) + 1    ! BYTE ADDRESS TO 16-BIT WORD ADDRESS
      IX8(I) = ((I - 1)*8) + 1    ! BYTE ADDRESS TO  1-BIT WORD ADDRESS

C     RETRIEVE DOCUMENTATION RECORDS FOR FIRST AND LAST GOOD SCANS.         
C
      PRINT '('' IREC - FIRST GOOD SCAN '',I7)', IRECFGS
      READ(UFILE0,2010,REC=IRECFGS,ERR=921,IOSTAT=IOS)IDOCRFGS_C
      CALL DECOTAG (ITCURHB,STHB(213))
C
      PRINT '('' IREC - LAST GOOD SCAN  '',I7)', IRECLGS
      READ(UFILE0,2010,REC=IRECLGS,ERR=922,IOSTAT=IOS)IDOCRLGS_C
      CALL DECOTAG (ITCURTB,STHB(219))
C
C     COPY BLOCK 0 HEADERS AND BLOCK 0 DOCUMENTATION INTO STATUS
C     HEADER BLOCK.
C
      DO I = 1,8132
      STHB_C(KB0H+I:KB0H+I) = IDOCRFGS_C(I:I)
      END DO
C
C     RETRIEVE THE CURRENT IMAGING MODE.
C
      CALL BRPK (STHB,8,KB0D+230,IMODE,32,1,1)
      IF (IMODE.EQ.1) PRINT 3210
      IF (IMODE.EQ.2) PRINT 3220
      IF (IMODE.EQ.3) PRINT 3230
      IF (IMODE.EQ.4) PRINT 3240
C
C     RETRIEVE THE FRAME BOUNDARIES AND THE NUMBER OF THE VISIBLE PIXEL
C     INTERSECTING THE SUBSATELLITE POINT.
C
      KWFPX = KB0D + 157
      KEFPX = KB0D + 159
      KNFLN = KB0D + 161
      KSFLN = KB0D + 163
C
      KGVPX = KB0D + 173
C
      CALL BRPK (STHB,16,K_1_2(KWFPX),IWFPX,32,1,1)
      CALL BRPK (STHB,16,K_1_2(KEFPX),IEFPX,32,1,1)
      CALL BRPK (STHB,16,K_1_2(KNFLN),INFLN,32,1,1)
      CALL BRPK (STHB,16,K_1_2(KSFLN),ISFLN,32,1,1)
C
      CALL BRPK (STHB,16,K_1_2(KGVPX),IGVPX,32,1,1)
C
      PRINT 3310, IWFPX
      PRINT 3320, IEFPX
      PRINT 3330, INFLN
      PRINT 3340, ISFLN
C
      PRINT 3350, IGVPX
C
C     WHERE 1 SI (SAMPLING INCREMENT) IS APPROXIMATELY EQUAL TO 1 KM,
C     CHANGE FROM 1 SI X 1 SI COORDINATES TO 8 SI (N/S) X 4 SI (E/W)
C     COORDINATES.
C
      IWFPX4 = K_1_4(IWFPX)
      IEFPX4 = K_1_4(IEFPX)
      INFLN8 = K_1_8(INFLN)
      ISFLN8 = K_1_8(ISFLN)
C
      INFLN4 = K_1_4(INFLN)
      ISFLN4 = K_1_4(ISFLN)
c
      IGVPX4 = K_1_4(IGVPX)
C
      STHB(227) = IWFPX4
      STHB(228) = IEFPX4
      STHB(225) = INFLN8
      STHB(226) = ISFLN8
C
C     INSERT THE FIRST SCAN AND FIRST PIXEL OF THE IMAGE TO BE STORED
C     RELATIVE TO THE FIRST SCAN AND FIRST PIXEL OF IMAGE PROVIDED.
C
      IIFLN8 = 2
      IIFPX4 = 1
C
C     IF THE FRAME IS A FULL DISK FRAME, DEFINE THE FIRST PIXEL OF
C     THE IMAGE TO BE STORED SO THAT THE EARTH DISK WILL BE CENTERED
C     IN A HYPOTHETICAL FRAME THAT IS 4800 PIXELS WIDE.
C
      IF (IDOCR1_C(8:8).EQ.'F') THEN
      IIFLN8 = 2
      IIFPX4 = IGVPX4 - 2400 - (IWFPX4 - 1)
      END IF
C
      STHB(37) = IIFLN8
      STHB(38) = IIFPX4
C
      STHB(39) = K_8_1(IIFLN8)
      STHB(40) = K_4_1(IIFPX4)
C
      PRINT 3302, (STHB(N),N=37,40)
 3302 FORMAT (T2,'STHB(N),N=37,40',5x,4I5)
C
C     FILL COMMON AREA KDOCIJ AS NECESSARY FOR WRITER ZRWA.
C
      KJADJ(1,1) = K_8_1(INFLN8) - 1 + K_8_1(IIFLN8) - 1
      KIADJ(1,1) = K_4_1(IWFPX4) - 1 + K_4_1(IIFPX4) - 1
C
C     MODIFY AS NECESSARY LATER FOR VISIBLE DATA.
      KFGDBL(1,1) = K_1_4(INFLN) + K_1_4(IIFLN) - 1 ! ?
      KLGDBL(1,1) = K_1_4(ISFLN) + K_1_4(IIFLN) - 1 ! ?
      KFDBE(1,1)  = K_1_4(IWFPX) + K_1_4(IIFPX) - 1 ! ?
      KLDBE(1,1)  = K_1_4(IEFPX) + K_1_4(IIFPX) - 1 ! ?
C
      PRINT 3410, KFGDBL(1,1)
      PRINT 3420, KLGDBL(1,1)
      PRINT 3430, KFDBE(1,1)
      PRINT 3440, KLDBE(1,1)
C
      KDBLINECT(1,1) = KLGDBL(1,1) - KFGDBL(1,1) + 1
      KDBELEMCT(1,1) = KLDBE (1,1) - KFDBE (1,1) + 1
C
C     SPECIFY THE SCALE CONVERSION TABLE.
      MSR(49) = 1
 
      CALL BRPK (IDOCRFGS_C,8,90+1,NSAT,32,1,1)
      PRINT 9110, NSAT
      IF (NSAT.EQ.14.OR.NSAT.EQ.15) THEN

C     COPY IMAGER NADIR COORDINATES FROM NEW POSITION (FOR GOES-14 
C     AND LATER) BACK TO OLD POSITION (FOR GOES-13 AND EARLIER). 

      CALL BRPK (STHB, 8,    KB0D+8033 ,KNS_NAD_CY,32,1,1)
      CALL BRPK (STHB, 8,    KB0D+8034 ,KEW_NAD_CY,32,1,1)
      CALL BRPK (STHB,16,IZ2(KB0D+8035),KNS_NAD_INC,32,1,1)
      CALL BRPK (STHB,16,IZ2(KB0D+8037),KEW_NAD_INC,32,1,1)

      PRINT 9120, KNS_NAD_CY,     KEW_NAD_CY,
     1            KNS_NAD_INC,    KEW_NAD_INC

      DO I = 1,6
      STHB_C(KB0D+6304+I:KB0D+6304+I) = 
     |STHB_C(KB0D+8032+I:KB0D+8032+I)
      END DO    

      CALL BRPK (STHB, 8,    KB0D+6305 ,KNS_NAD_CY,32,1,1)
      CALL BRPK (STHB, 8,    KB0D+6306 ,KEW_NAD_CY,32,1,1)
      CALL BRPK (STHB,16,IZ2(KB0D+6307),KNS_NAD_INC,32,1,1)
      CALL BRPK (STHB,16,IZ2(KB0D+6309),KEW_NAD_INC,32,1,1)

      PRINT 9120, KNS_NAD_CY,     KEW_NAD_CY,
     1            KNS_NAD_INC,    KEW_NAD_INC

 9110 FORMAT (  ' GOES-',I2/) 
 9120 FORMAT (  ' KNS_NAD_CY      KEW_NAD_CY     ',2I10/
     1          ' KNS_NAD_INC     KEW_NAD_INC    ',2I10)

      PRINT 3600
      END IF

      GO TO 990
C
  921 PRINT 3921, IOS
      STAT = 92
      GO TO 990
  922 PRINT 3922, IOS
      STAT = 92
C
  990 RETURN
C
 2010 FORMAT (A8132)
 3010 FORMAT (' ',A44/)
 3020 FORMAT (' ',16I4)
C
 3110 FORMAT (' ','YEAR AND DAY OF YEAR  ',2I8)
 3120 FORMAT (' ','HOUR AND MINUTE       ',2I8)
 3130 FORMAT (' ','SECOND AND MILLISECOND',2I8/)
C
 3210 FORMAT (' ','IMAGING MODE   ROUTINE'/)
 3220 FORMAT (' ','IMAGING MODE   RAPID SCAN'/)
 3230 FORMAT (' ','IMAGING MODE   SUPER RAPID SCAN'/)
 3240 FORMAT (' ','IMAGING MODE   CHECKOUT / ',                               
     |                           'SPECIAL SHORT TERM OPERATIONS'/)
C
 3310 FORMAT (' ','IWFPX                 ', I8)
 3320 FORMAT (' ','IEFPX                 ', I8)
 3330 FORMAT (' ','INFLN                 ', I8)
 3340 FORMAT (' ','ISFLN                 ', I8/)
 3350 FORMAT (' ','IGVPX                 ', I8/)
C
 3410 FORMAT (' ','START LINE            ', I8)
 3420 FORMAT (' ','END LINE              ', I8)
 3430 FORMAT (' ','START SAMPLE          ', I8)
 3440 FORMAT (' ','END SAMPLE            ', I8/)
C
 3590 FORMAT (' ','MINIMUM SUN ANGLE = ',I2,' DEGREES')
 3600 FORMAT (' ')
 3921 FORMAT (' ','BSTHB: M921: READ FAILED       IOSTAT =',I5)
 3922 FORMAT (' ','BSTHB: M922: READ FAILED       IOSTAT =',I5)
C
      END
