      SUBROUTINE DECOTAG (ITIMEIN,ITIMEOUT)
C***********************************************************************
C                                                                       
C   NAME- DECOTAG
C                                                                       
C   LANGUAGE- FORTRAN     TYPE- SUBROUTINE                              
C                                                                       
C   VERSION-  2.01  DATE- 05/22/07  PROGRAMMER- SCHREITZ, R.  EC2200
C                   RETRIEVAL OF FRAME END TIME.
C                                                                       
C   FUNCTION-
C
C       DECODES A CDA TIME TAG.                                          
C                                                                       
C   CALLING SEQUENCE PARAMETERS-                                        
C
C     ITIMEIN           CDA TIME TAG
C                       SEQUENCE OF 16 4-BIT DIGITS
                        INTEGER*4 ITIMEIN(2)
C     ITIMEOUT          SEQUENCE OF 6 16-BIT TIME PARAMETERS:
C                          YEAR
C                          DAY OF YEAR
C                          HOURS
C                          MINUTES
C                          SECONDS
C                          MILLISECONDS
                        INTEGER*2 ITIMEOUT(6)
C
C   LOCAL PARAMETERS:
C
C     IT                DECODED CDA TIME TAG
                        INTEGER*2 IT(16)
C     IT(01)            YEAR IN 1000S
C     IT(02)            YEAR IN 100S
C     IT(03)            YEAR IN 10S
C     IT(04)            YEAR IN 1S
C     IT(05)            DAY OF YEAR IN 100S
C     IT(06)            DAY OF YEAR IN 10S
C     IT(07)            DAY OF YEAR IN 1S
C     IT(08)            HOURS IN 10S
C     IT(09)            HOURS IN 1S
C     IT(10)            MINUTES IN 10S
C     IT(11)            MINUTES IN 1S
C     IT(12)            SECONDS IN 10S
C     IT(13)            SECONDS IN 1S
C     IT(14)            MSEC IN 100S
C     IT(15)            MSEC IN 10S
C     IT(16)            MSEC IN 1S
C
C     ITBUF             BUFFER USED IN THE EXTRACTION OF THE 4-BIT
C                       COMPONENTS OF TIME FROM THE CDA TIME TAG
                        INTEGER*4 ITBUF(2)
C     MASK              MASK USED IN THE EXTRACTION OF THE 4-BIT
C                       COMPONENTS OF TIME FROM THE CDA TIME TAG
                        INTEGER*4 MASK
C***********************************************************************
      DATA MASK/Z000F/
 
      ITBUF(2) = ITIMEIN(2)
      DO K = 16,9,-1
      IT(K) = IAND(MASK,ITBUF(2))
      ITBUF(2) = RSHIFT(ITBUF(2),4)
      END DO
      ITBUF(1) = ITIMEIN(1)
      DO K = 8,1,-1
      IT(K) = IAND(MASK,ITBUF(1))
      ITBUF(1) = RSHIFT(ITBUF(1),4)
      END DO
 
CCCCC PRINT 3010, (IT(K),K=1,16)
      ITIMEOUT(1) = 1000*IT(01) + 100*IT(02) + 10*IT(03) + IT(04)
      ITIMEOUT(2) =               100*IT(05) + 10*IT(06) + IT(07)
      ITIMEOUT(3) =                            10*IT(08) + IT(09)
      ITIMEOUT(4) =                            10*IT(10) + IT(11)
      ITIMEOUT(5) =                            10*IT(12) + IT(13)
      ITIMEOUT(6) =               100*IT(14) + 10*IT(15) + IT(16)
 
      PRINT 3110, ITIMEOUT(1),ITIMEOUT(2)
      PRINT 3120, ITIMEOUT(3),ITIMEOUT(4)
      PRINT 3130, ITIMEOUT(5),ITIMEOUT(6)
 
 3010 FORMAT (' ',16I4)
 
 3110 FORMAT (' ','YEAR AND DAY OF YEAR  ',2I8)
 3120 FORMAT (' ','HOUR AND MINUTE       ',2I8)
 3130 FORMAT (' ','SECOND AND MILLISECOND',2I8/)
C
       END
