C     2005-03-08  Brenda Hardie     Migrated code to AIX.
C
      SUBROUTINE CHKDAT(JDATE,IMGDAT,IHM,IPIC,ICHK)
C
      ICHK=0
C
      IYR=IMGDAT/10000
      IMO=MOD(IMGDAT,10000)/100
      IDA=MOD(IMGDAT,100)
      CALL GETDOY(IMGDAT,IDAYR)
C
      JYR=JDATE/10000
      JMO=MOD(JDATE,10000)/100
      JDA=MOD(JDATE,100)
      CALL GETDOY(JDATE,JDAYR)
C
C
      WRITE(53,777)      IMGDAT,IYR,IMO,IDA,IDAYR
 777  FORMAT(' "CHKDAT", IMGDAT,IYR,IMO,IDA,IDAYR:',T40,5I8)
      WRITE(53,778)      JDATE, JYR,JMO,JDA,JDAYR
 778  FORMAT(' "CHKDAT", JDATE, JYR,JMO,JDA,JDAYR:',T40,5I8)
C
      IF(IPIC.NE.1) THEN
        IF(IDAYR.NE.JDAYR) ICHK=1
        GO TO 250
      ENDIF
C
C...... GET HERE IF WORKING ON 00Z IMAGE
C
      IF(IDAYR.EQ.JDAYR) THEN
        IF(IHM.LE.3) THEN
          GO TO 250
        ELSE
          ICHK=1
          GO TO 250
        ENDIF
      ELSE
        IF(IDAYR.EQ.JDAYR-1) THEN
          GO TO 250
        ELSE
          ICHK=1
        ENDIF
      ENDIF
C
C
 250  RETURN
      END
      SUBROUTINE COMTMP(SATNAM,IVAL,TEMP,ISTAT)
C***********************************************************************
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:  COMTMP        CONVERTER OF DIGITAL VALUES TO T (K)
C   PRGMMR: JIE MENG         ORG: W/NMC23          DATE: 93-07-10
C
C ABSTRACT: COMPUTES EBBT(EQUILIBRIUM BLACK BODY TEMPERATURE) FROM
C   DIGITAL COUNTS.
C
C PROGRAM HISTORY LOG:
C   88-09-02  JOHN JANOWIAK
C   93-03-24  JIE MENG       USE CALIBRATION TABLE FOR METEOSAT 3
C   93-07-10  JIE MENG       COMMON/CALTAB/ITABLE(256)
C   95-01-30  RICHARD SCHREITZ  CHANGED FOR GOES-8.
C   96-05-17  RICHARD SCHREITZ  CHANGED FOR GOES-9 AND GOES-10.
C                               SIMPLIFIED LOGIC.
C   05-02-18  RICHARD SCHREITZ  CHANGED NAME OF COMMON AREA 'CALTAB'
C                               TO 'CALTAB1' TO AVOID CONFLICT AND
C                               PLACED IT IN AN 'INCLUDE' LIBRARY.
C  05-03-08  Brenda Hardie      Migrated code to AIX.
C
C USAGE:    CALL COMTMP(SATNAM,IVAL,TEMP,ISTAT)
C
C   INPUT ARGUMENT LIST:
C     SATNAM  C*11      = 'GOES-7     ' FOR GOES-7
C                       = 'GOES-8     ' FOR GOES-8
C                       = 'GOES-9     ' FOR GOES-9
C                       = 'GOES-10    ' FOR GOES-10
C                       = 'METEOSAT-3 ' FOR METEOSAT-3
C                       = 'METEOSAT-4 ' FOR METEOSAT-4
C                       = 'METEOSAT-5 ' FOR METEOSAT-5
                        CHARACTER*11 SATNAM
C     IVAL    I*4       SENSOR DATA (DIGITAL CODE)
C
C   OUTPUT ARGUMENT LIST:
C     TEMP    R*4       TEMPERATURE IN KELVIN
C     ISTAT   I*4       STATUS FLAG
C                       -1 = IF (IVAL.EQ.255)
C                        0 = ELSE (NORMAL)
C
C REMARKS: THE DIGITAL CODE JUST AFTER CALIBRATION IS RANGED 0 - 254,
C   BUT 0 AND 254 DO NOT CORRESPOND TO UNIQUE TEMPERATURES.
C   THE REFORMATTER SETS FLAG FOR DROPOUT LINES AND ASSIGNS A VALUE
C   255 TO THE DROPOUT LINE.
C
C ATTRIBUTES:
C   LANGUAGE: IBM VS FORTRAN (FORTRAN 77)
C   MACHINE:  HDS 9000
C$$$
C
C COMMON AREA PARAMETERS:
C
CBMH      INCLUDE (CALTAB1)
        INCLUDE (caltab1.i)
C
C***********************************************************************
C
C        COMPUTES TEMPERATURE FROM DIGITAL COUNT - ALGORITHM PROVIDED
C        BY DICK SCHREITZ OF NESDIS.
C
C                                           JANOWIAK  9/2/88
C
      IF (SATNAM(1:4).EQ.'GOES') THEN
C
        ISTAT=0
        IF(IVAL.EQ.0) TEMP=330.25
        IF(IVAL.EQ.255) ISTAT=-1
C
        IF(IVAL.GT.0 .AND. IVAL.LE.176)   TEMP=(660.5-IVAL)/2.
        IF(IVAL.GT.176 .AND. IVAL.LE.254) TEMP=418.5 - IVAL
C
      END IF
C
      IF (SATNAM(1:8).EQ.'METEOSAT') THEN
        TEMP = ITABLE(IVAL) / 10.
      END IF
C
      RETURN
      END
      SUBROUTINE DOW (NYEAR,NMONTH,NDAYOM,NDAYOW)
C***********************************************************************        
C                                                                               
C   NAME- DOW
C                                                                               
C   LANGUAGE- VS FORT     TYPE- SUBROUTINE                                      
C                                                                               
C   VERSION-  1.0   DATE- 06/28/06   PROGRAMMER- SCHREITZ, R.  EC1300           
C                                                                               
C   FUNCTION-                                                                   
C                                                                               
C     GIVEN THE YEAR, MONTH, AND DAY OF MONTH, SUBROUTINE DOW
C     COMPUTES THE CORRESPONDING DAY OF WEEK.                                   
C                                                                               
C   CALLING SEQUENCE PARAMETERS-                                                
C                                                                               
C     NYEAR   I*4  I--  YEAR  (FOUR DIGIT FORMAT) ('1957' ON)                   
C     NMONTH  I*4  I--  MONTH         (1 - 12)                                  
C     NDAYOM  I*4  I--  DAY OF MONTH  (1 - 31)                                  
C     NDAYOW  I*4  --O  DAY OF WEEK   (1 - 7)
C                                                                               
C   KEY LOCAL PARAMETERS-                                                       
C                                                                               
C     NDZM    I*4       TABLE CONTAINING THE NUMBER OF DAYS PER MONTH           
C                       FOR EACH MONTH                                          
                        DIMENSION NDZM(12)                                      
C     JD1957  I*4       DAY COUNT BEGINNING WITH THE FIRST DAY OF               
C                       THE YEAR 1957                                           
C     NY      I*4       YEAR INDEX                                              
C                                                                               
C***********************************************************************        
      DATA NDZM/31,00,31,30,31,30,31,31,30,31,30,31/                            
C                                                                               
C     STATEMENT FUNCTION KDOW
C.......................................................................        
C                                                                               
C     DETERMINE THE DAY OF WEEK (KDOW) GIVEN A DAY COUNT (JD1957)
C     BEGINNING WITH THE FIRST DAY OF THE YEAR 1957.                            
C                                                                               
C     THE DAY OF WEEK FOR THE FIRST DAY OF THE YEAR 1957 (JD1957 = 1)           
C     WAS A TUESDAY.                                                            
C                                                                               
C     WHERE                                                                     
C        SUNDAY    = 0                                                          
C        MONDAY    = 1                                                          
C        TUESDAY   = 2                                                          
C        WEDNESDAY = 3                                                          
C        THURSDAY  = 4                                                          
C        FRIDAY    = 5                                                          
C        SATURDAY  = 6                                                          
C                                                                               
      KDOW(JD1957) = MOD((JD1957+1),7)
C                                                                               
C.......................................................................        
C                                                                               
C     CONVERT YEAR, MONTH, AND DAY OF MONTH TO YEAR AND DAY OF YEAR.            
      CALL DOY (NYEAR,NMONTH,NDAYOM,NDAYOY)                              
C                                                                               
C     COMPLETE THE DAYS PER MONTH TABLE FOR THE SPECIFIED YEAR.                 
C
      NDZM(2) = 28 + LEAPYR(NYEAR)                                              
C                                                                               
C     DETERMINE THE DAY COUNT (JD1957) FOR THE FIRST DAY OF                     
C     THE SPECIFIED YEAR.                                                       
      NY = 1957                                                                 
      JD1957 = 1                                                                
  100 IF (NY.EQ.NYEAR) GO TO 200                                             
      NDZY = 365 + LEAPYR(NY)                                                
      JD1957 = JD1957 + NDZY                                                    
      NY = NY + 1                                                               
      GO TO 100                                                                 
C                                                                               
C     DETERMINE THE DAY COUNT (JD1957) FOR THE SPECIFIED DAY OF                 
C     OF THE SPECIFIED YEAR.                                                    
  200 JD1957 = JD1957 - 1 + NDAYOY                                              
C                                                                               
C     DETERMINE THE DAY OF WEEK.                                                
      NDAYOW = KDOW(JD1957)    
C
      RETURN                                                                    
      END
C***********************************************************************
      SUBROUTINE EXHIST(SATNAM,I,J,NLON,NLAT,ALATS,ALONS,FLAT,FLON,
     1                  PICDAT,IHIST,NCLASS,NPIX,XMEAN,VAR,XPRCP,I254)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:  EXHIST        EXTRACT 24-CLASS HISTOGRAM IN A BOX
C   PRGMMR: JIE MENG         ORG: W/NMC23   DATE: 93-12-05
C
C ABSTRACT: EXTRACTS 24-CLASS HISTOGRAM OF EBBT IN A BOX (I,J).
C   DETERMINES THE PIXEL POINTS ARE JUST INSIDE THE BOX BOUNDARY;
C   COMPUTES TEMPERATURE FROM DIGITAL COUNT;
C   COMPUTES THE TEMPERATURE POPULATION IN THE BOX;
C   COMPUTES THE MEAN, STANDARD DEVIATION, MAX AND MIN OF TEMP.
C
C PROGRAM HISTORY LOG:
C   86-08-01  PHILLIP A. ARKIN -- ORIGINAL AUTHOR
C   88-09-23  JOHN JANOWIAK    -- FIXED MEAN T AND SIGMA OF T.
C   91-07-01  JIE MENG         -- CORRECTED IVAL=PICDAT(JPD,IPD).
C   93-05-08  JIE MENG         -- CORRECTED AN INFINITE LOOP.
C                                 USE R*8 INSTEAD OF R*4 IN DETERMINING
C                                 A POINT INSIDE A BOX.
C   93-08-22  JIE MENG         -- CORRECTED THE THRESHOLD FOR
C                                 HISTOGRAM.  THRESHOLD SHOULD BE IN T
C                                 INSTEAD OF DIGITAL VALUES.
C   93-12-05  JIE MENG         -- MOVED XMAX, XMIN FROM ARGUMENT
C   95-03-01  RICHARD SCHREITZ -- INCREASED PRECISION OF SSUM
C   96-05-17  RICHARD SCHREITZ -- REVISED FOR USE WITH EXPANDED
C                                 SATELLITE NAME FIELD.
C                                 CORRECTED LOGIC ERROR INVOLVING
C                                 ANTICIPATED GVAR DROPOUT INDICATOR.
C                                 (SEE MEMBER H1EXHIST.)
C   05-02-18  RICHARD SCHREITZ -- PLACED COMMON STATEMENT 'BOX' IN
C                                 AN 'INCLUDE' LIBRARY.
C                                 SET ABOX TO REAL*8.
C   05-03-08  Brenda Hardie       Migrated code to AIX.
C   06-08-22  RICHARD SCHREITZ -- CHANGED SUBSCRIPT NAMES, INSERTED
C                                 ADDITIONAL BLOCK IFS AND COMMENTS
C                                 TO IMPROVE CLARITY.
C
C USAGE:   CALL EXHIST(SATNAM,I,J,NLON,NLAT,ALATS,ALONS,FLAT,FLON,
C    1                 PICDAT,IHIST,NCLASS,NPIX,XMEAN,VAR,XPRCP,I254)
C   INPUT ARGUMENT LIST:
C     SATNAM  C*11      SATELLITE NAME
C                       = 'GOES-7     ' FOR GOES-7
C                       = 'GOES-8     ' FOR GOES-8
C                       = 'GOES-9     ' FOR GOES-9
C                       = 'GOES-10    ' FOR GOES-10
C                       = 'METEOSAT-3 ' FOR METEOSAT-3
C                       = 'METEOSAT-4 ' FOR METEOSAT-4
C                       = 'METEOSAT-5 ' FOR METEOSAT-5
                        CHARACTER*11 SATNAM
C     I       I*4       INDEX FOR LONGITUDINAL COORDINATE OF BOX
C     J       I*4       INDEX FOR BOX COORDINATE IN LATITUDE DIRECTION
C     NLON    I*4       NUMBER OF LONGITUDES
C     NLAT    I*4       NUMBER OF LATITUDES
C     ALATS   R*4       ARRAY OF VERTICAL (NORTH - SOUTH) COORDINATES
C                       IN GOES/METEOSAT DATABASE PICTURE
C                       1ST/2ND DIMENSION CORRESPONDS TO LON/LAT
                        REAL*4 ALATS(NLON+1,NLAT+1)
C     ALONS   R*4       ARRAY OF HORIZONTAL (WEST - EAST) COORDINATES
C                       IN GOES/METEOSAT DATABASE PICTURE
C                       1ST/2ND DIMENSION CORRESPONDS TO LON/LAT
                        REAL*4 ALONS(NLON+1,NLAT+1)
C     FLAT    R*4       LATITUDE OF UPPER LEFT CORNER OF 1X1 BOX.       26050000
                        REAL*4 FLAT(NLAT+1)
C     FLON    R*4       LONGITUDE OF UPPER LEFT CORNER OF 1X1 BOX.      26070000
                        REAL*4 FLON(NLON+1)
C     PICDAT  I*2       DIGITAL COUNT BUFFER FOR REQUESTED IMAGE
C                       (M * N * IX BYTES)
C                       M, HORIZONTAL SAMPLE COUNT, OR PIXELS
C                       N, VERTICAL SAMPLE COUNT, OR LINES
C                       IX, WORD SIZE IN BYTES
                        INTEGER*2 PICDAT(M,N)
C     NCLASS  I*4       NUMBER OF CLASSES
C
C   OUTPUT ARGUMENT LIST:
C     IHIST   I*4       TEMPERATURE POPULATION OF 24 CLASSES IN EACH
C                       BOX FOR EACH IMAGE.
                        INTEGER*4 IHIST(NCLASS)
C     NPIX    I*4       NUMBER OF THE PIXELS INSIDE THE BOX
C     XMEAN   R*4       MEAN TEMPERATURE IN EACH BOX OF EACH IMAGE.
C     VAR     R*4       TEMPERATURE VARIANCE IN EACH BOX
C     XPRCP   R*4
C     I254    R*4
C
C   SUBPROGRAMS CALLED:
C     UNIQUE: INBOX, COMTMP
C     INBOX-  CHECKS TO SEE WHETHER A SPECIFIED POINT IS INSIDE THE
C             SPECIFIED BOX (I,J).
C     COMTMP- COMPUTES EBBT(EQUILIBRIUM BLACK BODY TEMPERATURE) FROM
C             PIXEL VALUE
C ATTRIBUTES:
C   LANGUAGE: IBM VS FORTRAN (FORTRAN 77)
C   MACHINE:  HDS 9000
C$$$
C
C COMMON AREA PARAMETERS:
C
      INCLUDE 'box.i'
C
C LOCAL PARAMETERS:
C
C     ITHRSH  I*4       THRESHOLD FOR DIGITAL COUNTS CORRESPONDING TO
C                       ONE FOR 24 TEMPERATURE CLASSES,
C                       270,265,260,255,250,245,240,239,238,237,236,235,
C                       234,233,232,231,230,225,220,215,210,200,190
C                       (KELVIN)
C
                        INTEGER*4 ITHRSH(23)
C
C     TTHRSH  I*4       THRESHOLD FOR 24 TEMPERATURE CLASSES
C                         (SAME AS ABOVE)
C
                        REAL*4    TTHRSH(23)
C
C     ICOUNT  I*4       TOTAL NUMBER OF VALID PIXELS IN EACH BOX
C     IPOINT  I*4       FLAG SIGNALLING THE DETECTION OF A POINT IN
C                       THE BOX
C                       0 -> BOX IS EMPTY
C                       1 -> BOX IS NOT EMPTY
C     JPD     I*4       VERTICAL INDEX FOR PICTURE DATA BUFFER PICDAT
C     IPD     I*4       HORIZONTAL INDEX FOR PICTURE DATA BUFFER PICDAT

C     IN      L*4       LOGICAL FLAG
C                       TRUE = , THE POINT IS INSIDE BOUNDARY
C                       FALSE =, THE POINT IS OUTSIDE BOUNDARY
C
                        LOGICAL*4 IN
C
C     IFIRST  I*4       INDEX, TO SKIP COMPUTING AREA OF THE BOX
C                        0 = AREA OF THE BOX HAS NOT BEEN CALCULATED
C                        1 = AREA OF THE BOX HAS BEEN CALCULATED
C
C     IRLIM   I*4       INDEX, FOR EXCLUDING POINTS OUTSIDE THE BOX.
C                       1ST DIMENSION INDICATES LINES (VERTICAL),
C                       1 IN 2ND : 1ST PIXEL INSIDE THE BOX IN THE LINE
C                       2 IN 2ND : LAST PIXEL INSIDE THE BOX IN THE LINE
C
                        PARAMETER(MAXN=80)
                        INTEGER*4 IRLIM(MAXN,2)
C
C     IVAL    I*2       SENSOR DATA (DIGITAL CODE)
C     ISTAT   I*4       STATUS FLAG
C                       -1 = IF (IVAL.EQ.255)
C                        0 = ELSE (NORMAL)
C     KE      I*4       ERROR FLAG. =0 NO ERROR, OTHERWISE ERROR.
C     TEMP    R*4       TEMPERATURE IN KELVIN
C     PTMP    R*4       TEMPERATURE BUFFER
                        REAL*4 PTMP(10000)
C     SSUM    R*8       SUM OF THE QUADRATURE OF TEMP
                        REAL*8 SSUM
C     A       R*4       NUMBER OF OCCURENCES OF TEMPERATURE LOWER THAN
C                       190 KELVIN IN A 1.0 X 1.0 BOX
C     B       R*4       TOTAL NUMBER OF OCCURENCES OF TEMPERATURES IN
C                       A BOX
C     C       R*4       RATIO OF A OVER B
C     GO      L*4       FLAG SIGNALLING A SPECIFIED (I,J) COORDINATE
                        LOGICAL*4 GO
C
C***********************************************************************
      PARAMETER(IFPRNT=53)
C
      REAL*8 XI(4),YJ(4),XX,YY,ABOX
C
      DATA ITHRSH/120, 129, 139, 149, 159, 169, 178,
     1            179, 180, 181, 182, 183, 184, 185, 186, 187,
     2            188, 193, 198, 203, 208, 218 ,228/
      DATA TTHRSH/270.,265.,260.,255.,250.,245.,240.,
     1            239.,238.,237.,236.,235.,234.,233.,232.,231.,
     1            230.,225.,220.,215.,210.,200.,190./
C
      XI(1) = ALONS(I,J)
      XI(2) = ALONS(I+1,J)
      XI(3) = ALONS(I,J+1)
      XI(4) = ALONS(I+1,J+1)
      YJ(1) = ALATS(I,J)
      YJ(2) = ALATS(I+1,J)
      YJ(3) = ALATS(I,J+1)
      YJ(4) = ALATS(I+1,J+1)
C
      GO = .FALSE.
C     GO = (J.EQ.57).AND.(I.EQ.2)
C
C -----  DETERMINES THE PIXEL POINTS ARE JUST INSIDE BOUNDARY.
C
      DO 10 N1=1,NCLASS
          IHIST(N1)=0
   10 CONTINUE
      IFIRST=0
      IPOINT = 0
      DO 20 JPD=1,N
        IRLIM(JPD,1)=0
        IRLIM(JPD,2)=0
        YY = LMIN + JPD - 1
C
C       LOOK ON LINE JPD FOR THE FIRST POINT IN THE BOX.
   14   DO 15 IPD=1,M
          IN=.FALSE.
          XX = PMIN + IPD - 1
          CALL INBOX(YY,XX,XI,YJ,IFIRST,ABOX,IN)
C
          IF (IN) THEN
            IRLIM(JPD,1)=IPD
            IPOINT = 1
            GO TO 16
          END IF
   15   CONTINUE
        GO TO 20
C
C       LOOK ON LINE JPD FOR THE LAST POINT IN THE BOX.
   16   DO 17 IPD=M,1,-1
          IN=.FALSE.
          XX = PMIN + IPD - 1
          CALL INBOX(YY,XX,XI,YJ,IFIRST,ABOX,IN)
C
          IF (IN) THEN
            IRLIM(JPD,2)=IPD
            GO TO 20
          END IF
   17   CONTINUE
C
        WRITE(IFPRNT,100) I,J
  100   FORMAT(' EXHIST:  SHOULD NEVER GET HERE - ',2I10)
   20 CONTINUE
C
      ICOUNT=0
      SSUM=0.
      NPIX=0
      IT235 =  0
      XMEAN =  0.
      VAR   = -1.
      XPRCP = -1.
      IVAL  =  0
      DO 40 JPD=1,N
        IF (IRLIM(JPD,1).EQ.0) GO TO 40
        IPD1=IRLIM(JPD,1)
        IPD2=IRLIM(JPD,2)
        DO 30 IPD=IPD1,IPD2
C
CJM AN ERROR WAS HERE.  90-12-01, JIE MENG.
CJM           IVAL=PICDAT(I1,I2)
CRS       IVAL=PICDAT(I2,I1)
CRS ERROR CORRECTED BY JIE MENG.
CRS SUBSCRIPT NAMES CHANGED BY RICHARD SCHREITZ.
          IVAL=PICDAT(IPD,JPD)
C
C  PIXEL VALUES OF 0, 254 AND 255 ARE NOT USABLE.
C
          IF (IVAL.EQ.0) THEN
            I0 = I0 + 1
            IF(I0 .LT. 5 .OR. MOD(I0,100) .EQ. 0)
     1      WRITE(IFPRNT,1100)J,I,FLAT(J),FLON(I),JPD,IPD,IVAL,N,M,I0
            GO TO 30
          END IF
C
          IF (IVAL.EQ.254) THEN
            I254 = I254 + 1
C           IF(I254 .LT. 5 .OR. MOD(I254,100) .EQ. 0)
C    1      WRITE(IFPRNT,1200)J,I,FLAT(J),FLON(I),JPD,IPD,IVAL,N,M,I254
            GO TO 30
          END IF
C
C  CONVERT PIXEL VALUE TO BBT.
C
          CALL COMTMP(SATNAM,IVAL,TEMP,ISTAT)
          IF(ISTAT.NE.0) GO TO 30
C
          IF(TEMP .LE. 235.) THEN
          IT235 = IT235 + 1
CCCCC     WRITE (75,9910) J,I,FLAT(J),FLON(I),JPD,IPD,IVAL,TEMP,IT235
C9910     FORMAT  (' ',  'J,I,FLAT(J),FLON(I),JPD,IPD,IVAL,TEMP,IT235:',
CCCCC+           2I4,2F6.0,3I4,F6.1,I4)
          END IF
          XMEAN=XMEAN+TEMP
          NPIX=NPIX+1
          PTMP(NPIX)=TEMP
C
C  UPDATE HISTOGRAM.
C
   22     DO 25 N1=1,NCLASS-1
C           IF (IVAL.GT.ITHRSH(N1)) GO TO 25
            IF (TEMP.LE.TTHRSH(N1)) GO TO 25
            IHIST(N1)=IHIST(N1)+1
            ICOUNT=ICOUNT+1
            GO TO 26
   25     CONTINUE
          IHIST(NCLASS)=IHIST(NCLASS)+1
          ICOUNT=ICOUNT+1
   26     CONTINUE
        IF (GO) 
     1  WRITE (IFPRNT,9920) J,I,FLAT(J),FLON(I),JPD,IPD,IVAL,N,M,NPIX
 9920   FORMAT(' ',        'J,I,FLAT(J),FLON(I),JPD,IPD,IVAL,N,M,NPIX',
     1         2I4,2F6.0,3I4,3I4)
   30   CONTINUE
   40 CONTINUE
CJM
      IF(IPOINT.EQ.0) WRITE(IFPRNT,*)'NO POINT IN THE BOX',
     1                                J,I,N,M
      IF(NPIX.EQ.0) WRITE(IFPRNT,*)'NO VALID PIXEL',J,I,N,M,IVAL,
     1   NPIX,ICOUNT,IPOINT
      IF(NPIX.NE.0) GO TO 50
      XMEAN =  0.
      VAR   = -1.
      GO TO 55
   50 XMEAN=XMEAN/NPIX
C
      DO NP=1,NPIX
      DIFF=PTMP(NP)-XMEAN
      SSUM=SSUM+DIFF*DIFF
      ENDDO
      VAR=SSUM/NPIX
      VAR=(AMAX1(VAR,0.))
      XPRCP = REAL(IT235) / NPIX
   55 A=IHIST(24)
      B=ICOUNT
      C=0.0
C THE NEXT SENTENCE COULD CAUSE AN INFINITE LOOP. JIE MENG, 93-05-04
CJM   IF (B.EQ.0.0) GO TO 40
CJM   C=A/B
      IF(B .NE. 0.0) C=A/B
  900 RETURN
 1100 FORMAT(' !!! IVAL=  0          ',2I4,2F6.0,5I5,I8)
 1200 FORMAT(' !!! IVAL=254 IS WRONG ',2I4,2F6.0,5I5,I8)
      END
      SUBROUTINE GENLBL (IPIC,JDATE8,SATNAM,LSATNAM,IOTNFN)
C***********************************************************************
C
C   NAME- GENLBL
C
C   LANGUAGE- VS FORTRAN  TYPE- SUBROUTINE      COMPUTER- IBM SP
C
C   VERSION- 00.0   DATE- 05/15/06   PROGRAMMER- R. SCHREITZ, EC1300
C   VERSION- 00.0   DATE- 06/14/06   PROGRAMMER- R. SCHREITZ, EC1300
C                                    ELIMINATED TRAILING BLANKS
C
C   FUNCTION- GENERATES LABELS FOR THE 3 HOURLY HISTOGRAM FILES.
C
C   CALLING SEQUENCE PARAMETERS-
C
C     IPIC              INDEX FOR SYNOPTIC ANALYSIS TIME
C                       (1 = 00Z, ETC.)
C                       INTEGER*4 IPIC
C     JDATE8            YEAR, MONTH, DAY (YYYYMMDD) IN INTEGER FORMAT
                        INTEGER*4 JDATE8
C     SATNAM            CHARACTER NAME OF SATELLITE
C                       (E. G. 'GOES-10')
                        CHARACTER*11 SATNAM
C     LSATNAM           LENGTH OF CHARACTER NAME OF SATELLITE
C                       INTEGER*4 LSATNAM
C     IOTNFN            UNIT NUMBER FOR FINAL NAME OF TEMPORARY 
C                       OUTPUT FILE N, N=1,4
                        INTEGER*4 IOTNFN
C
C   KEY LOCAL PARAMETERS-
C
C     ZTIME             SYNOPTIC ANALYSIS TIME (00Z, ETC.)
                        CHARACTER*3 ZTIME(8)
C     LBL               FILE LABEL
C                       (E. G. 'GOES-10.20060512.00Z')
                        CHARACTER*24 LBL
C     LDATE8            YEAR, MONTH, DAY (YYYYMMDD) IN ASCII FORMAT
                        CHARACTER*8 LDATE8
C     FS                FORMAT STATEMENT
                        CHARACTER*7 FS
                        CHARACTER*7 BLANK
C***********************************************************************
      DATA ZTIME/'00Z','03Z','06Z','09Z','12Z','15Z','18Z','21Z'/
      DATA FS/'(A24,$)'/
C
      WRITE (LDATE8,'(I8)') JDATE8
      LBL = SATNAM(1:LSATNAM)//'.'//LDATE8//'.'//ZTIME(IPIC)
      LENLBL = LSATNAM + 13
      WRITE (FS(3:4),3010) LENLBL
      PRINT 3090, FS
      WRITE (IOTNFN,FS) LBL
      RETURN
C
 3010 FORMAT (I2)
 3020 FORMAT (T3,I2)
 3090 FORMAT (' ',A7)
      END
      SUBROUTINE GETBOX(I,J,ALATS,ALONS,PICDAT,KREQ,KFR,IJE,KSTAT)
C***********************************************************************
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:  GETBOX        RETRIEVES ARRAY OF PIXELS
C   PRGMMR: JIE MENG         ORG: W/NMC23   DATE: 93-05-08
C
C ABSTRACT: RETRIEVES AN ARRAY OF PIXELS, WHICH ENVELOPS THE BOX.
C
C PROGRAM HISTORY LOG:
C   86-08-01  PHILLIP A. ARKIN
C   91-07-01  JIE MENG          CHANGED FOR GOES-8.
C   93-05-08  JIE MENG          CHANGED THE COMPUTING OF M,N,
C             PMIN,LMIN,ICLAT AND ICLON.
C   95-01-30  RICHARD SCHREITZ  CHANGED FOR GOES-8 ROUTINE MODE.
C   05-02-18  RICHARD SCHREITZ  REMOVED UNNECESSARY COMMON STATEMENTS.
C                               PLACED REMAINING COMMON STATEMENTS IN
C                               AN 'INCLUDE' LIBRARY.
C                               UPDATED DOCUMENTATION AND NAMES.
C   05-03-08  Brenda Hardie     Migrated to AIX.
C
C USAGE: CALL GETBOX(I,J,ALATS,ALONS,PICDAT,KREQ,KFR,IJE,KSTAT)
C   INPUT ARGUMENT LIST:
C     I        - I*4 INDEX, INDICATING HORIZONTAL COORDINATE OF BOX
C     J        - I*4 INDEX, INDICATING VERTICAL COORDINATE OF BOX
C     ALONS    - R*4 ARRAY OF HORIZONTAL (WEST - EAST) COORDINATES
C                    IN GOES DATABASE PICTURE
C                    1ST/2EN DIMENSION CORRESPONDS TO LON/LAT
C     ALATS    - R*4 ARRAY OF VERTICAL (NORTH - SOUTH) COORDINATES
C                    IN GOES DATABASE PICTURE
C                    1ST/2EN DIMENSION CORRESPONDS TO LON/LAT
C     KREQ     - I*4 POINTER - INDICATES REQUEST   (1 - 8)
C     KFR      - I*4 POINTER - INDICATES FRAME     (1 - 2)
C   OUTPUT ARGUMENT LIST:
C     PICDAT   - I*2 DIGITAL COUNT BUFFER FOR REQUESTED IMAGE
C                    (M * N * IX BYTES)
C                    M, HORIZONTAL SAMPLE COUNT, OR PIXELS
C                    N, VERTICAL SAMPLE COUNT, OR LINES
C                    IX, WORD SIZE IN BYTES,
C     IJE      - I*4 ERROR FLAG IN READING THE IMAGE DATABASE
C                    RETURNED FROM ZREAD
C                    0 = SUCCESSFUL COMLETION
C                    -N = ERROR, THE BOUNDARY OF THE DATA REQUESTED
C                    EXTENDS BEYOND THE BOUNDARY OF THE DATA AVAILABLE
C     KSTAT    - I*4 ERROR FLAG RETURNED FROM ZREAD
C                    0 = SUCCESSFUL COMPLETION
C                    N = ERROR (SEE APPENDIX C - ERROR MESSAGES
C                    IN USER'S GUIDE, GOES MSI DATABASE LOCATOR/READER
C
C   INPUT FILES:
C     GOES/METEOSAT DATABASE PICTURE, WHICH IS READ IN ZREAD
C
C   SUBPROGRAMS CALLED:
C     LIBRARY:
C       LOCATOR/READER: ZREAD
C       ZREAD - READS AN M BY N IMAGE FROM A SELECTED PICTURE IN THE
C       GOES MSI DATABASE PICTURE, WHERE M AND N ARE HORIZONTAL AND
C       VERTICAL SAMPLE COUNTS RESPECTIVELY.
C       SEE THE USER'S GUIDE, GOES MSI DATABASE LOCATOR/READER
C
C REMARKS: KSTAT IS SAME AS VS FORTRAN I/O ERROR MESSAGE.
C
C ATTRIBUTES:
C   LANGUAGE: IBM VS FORTRAN (FORTRAN 77)
C   MACHINE:  HDS 9000
C
C$$$
      INCLUDE 'bbuf.i'
      INCLUDE 'box.i'
C DIMENSION AND LOOP SIZE:
      PARAMETER(NLON=100,NLAT=100)
      PARAMETER(IFPRNT=53)
C     IFPRNT  I*4       UNIT NUMBER OF PRINTOUT
      REAL*4 ALONS(NLON+1, NLAT+1), ALATS(NLON+1, NLAT+1)
      INTEGER*2 PICDAT(M,N)
C
C   LOCAL PARAMETERS-
C
C     CLAT    R*4       AVERAGE LATITUDE OF THE 4 CORNERS OF THE BOX
C     CLON    R*4       AVERAGE LONGITUDE OF THE 4 CORNERS OF THE BOX
C     IOPT    I*4       READ OPTIONS
                        DIMENSION IOPT(4)
C     IX      I*4       NUMBER OF BYTES PER WORD OF PVAL
C                       IF IX < 0 (NOT -1), 10 BITS PER BYTE.
C     PICDATX I*4       BUFFER FOR ARRAY TO BE DISPLAYED
                        INTEGER*4 PICDATX(130,80)
C
C***********************************************************************
      DATA IOPT/4*0/
      DATA IX/2/
C
C  MAKE SURE THAT COORDINATES OF BOX CORNERS ARE AVAILABLE AND WITHIN
C  IMAGE
C
C    FIND MINIMUM AND MAXIMUM LINE AND PIXEL FOR SPECIFIED BOX.
C
      PMAX=AMAX1(ALONS(I,J),ALONS(I+1,J),ALONS(I,J+1),
     1            ALONS(I+1,J+1))
      PMIN=AMIN1(ALONS(I,J),ALONS(I+1,J),ALONS(I,J+1),
     1            ALONS(I+1,J+1))
      LMAX=AMAX1(ALATS(I,J),ALATS(I+1,J),ALATS(I,J+1),
     1            ALATS(I+1,J+1))
      LMIN=AMIN1(ALATS(I,J),ALATS(I+1,J),ALATS(I,J+1),
     1            ALATS(I+1,J+1))
C     PMIN=AINT(PMIN)+1
C     PMAX=AINT(PMAX)
C     LMIN=AINT(LMIN)+1
C     LMAX=AINT(LMAX)
C     M=PMAX-PMIN+1
C     N=LMAX-LMIN+1
CJM 93-05-08
      IMIN = INT(PMIN+0.5)
      IMAX = INT(PMAX+0.5)
      JMIN = INT(LMIN+0.5)
      JMAX = INT(LMAX+0.5)
      M = IMAX-IMIN+1
      N = JMAX-JMIN+1
      ICLON = IMIN + M / 2
      ICLAT = JMIN + N / 2
      PMIN = IMIN
      LMIN = JMIN
      PMAX = IMAX
      LMAX = JMAX
C
      CALL ZREAD(KREQ,KFR,ABUF,PICDAT,M,N,IX,ICLON,ICLAT,IOPT,IJE,KSTAT)
CCCCC PRINT 9910,KREQ,KFR,    (PICDAT(IPD,1),IPD=1,4),
CCCCC+                                    IX,ICLON,ICLAT,     IJE,KSTAT
C9910 FORMAT (' ',2I5,5X,4I5,5X,5I5)
C
C IX IS THE NUMBER OF THE BYTES PER WORD.
C IF IX > 0, PICDAT WILL CONTAIN 8 BIT VALUES,
C IF IX < 0 (EXCEPT -1), PICDAT WILL CONTAIN 10 BIT VALUES
C FOR BOTH GOES7 AND GOES8 IR DATA. GOES7 VIS DATA IS 6 BIT.
C
  50  CONTINUE
C     IF (IJE .LT. 0 .OR. KSTAT .NE. 0) THEN
C       WRITE(IFPRNT,*)'ERROR IN ZREAD  ','IJE= ',IJE,
C    1  'KSTAT= ',KSTAT,' ILAT ',J,' ILON ',I
C     END IF
C
C     CALL SHOWBOX (PICDAT,M,N)
C
      RETURN
      END
      SUBROUTINE GETDAF (IPIC,IHIT,KYMD,KHM,KDDD,
     +                   JDATE8,JDATE,IYR,IDAYR,IHM)
C***********************************************************************
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:  GETDAF        ADJUSTS THE DATE OF 2330Z AND 2300Z DATA
C   PRGMMR: PHIL ARKIN       ORG: W/NMC        DATE: 86-08-01
C
C ABSTRACT: ADJUSTS THE DATE WHENEVER THE 2330Z OR THE 2300Z IMAGE IS
C   PICKED UP TO REPLACE THE MISSING 0000Z IMAGE.
C
C PROGRAM HISTORY LOG:
C   86-08-01  PHIL ARKIN
C   87-12-18  JOHN JANOWIAK      FIXED CODE IN "GETDAF" THAT IS
C     DESIGNED TO HANDLE LEAP YEARS
C   95-03-24  RICHARD SCHREITZ   MODIFIED FOR MULTI SATELLITE USE
C   95-04-18  RICHARD SCHREITZ   MODIFIED FOR COMPUTATION OF JDATE
C   98-12-29  RICHARD SCHREITZ   MODIFIED FOR Y2K COMPLIANCE
C   05-03-08  Brenda Hardie      Migrated to AIX.
C   06-04-03  RICHARD SCHREITZ   REMOVED UNNECESSARY PARAMETERS FROM
C                                THE CALLING SEQUENCE AND SOURCE TEXT.
C   06-05-15  RICHARD SCHREITZ   ADDED COMPUTATION OF THE PARAMETER
C                                JDATE8 AND ADDED THIS PARAMETER TO
C                                THE CALLING SEQUENCE.
C
C USAGE:    CALL GETDAF (IPIC,IHIT,KYMD,KHM,KDDD,JDATE,IYR,IDAYR,IHM,
C                       LEAPYR,NPENYR,IDAY,IFILE)
C   ARGUMENT LIST:
C     IPIC    I*4  I--  POINTER - INDICATES SYNOPTIC INTERVAL (1 - 8)
C     IHIT    I*2  I--  FLAG ARRAY FOR GOOD OR BAD PICTURE,
C                       >= 1 AND <= 6, THERE IS A GOOD PICTURE
C                       = 0 THERE IS NO GOOD PICTURE IN THE 3-HR PERIOD
                        DIMENSION IHIT(8)
C     KYMD    I*4  I--  PICTURE REFERENCE YEAR, MONTH, DAY
                        DIMENSION KYMD(8)
C     KHM     I*4  I--  PICTURE REFERENCE HOUR, MINUTE
                        DIMENSION KHM(8)
C     KDDD    I*4  I--  PICTURE REFERENCE DAY OF YEAR
                        DIMENSION KDDD(8)
C     JDATE8  I*4  -O-  DATE OF THE SYNOPTIC INTERVAL (YYYYMMDD)
C     JDATE   I*4  -O-  DATE OF THE SYNOPTIC INTERVAL (YYMMDD)
C     IYR     I*4  -O-  YEAR OF THE SYNOPTIC INTERVAL
C     IDAYR   I*4  -O-  DAY OF YEAR OF THE SYNOPTIC INTERVAL
C     IHM     I*4  -O-  HOUR AND MINUTE IN HHMM OF THE SELECTED IMAGE
C
C ATTRIBUTES:
C   LANGUAGE: IBM VS FORTRAN (FORTRAN 77)
C   MACHINE:  HDS 9000
C$$$
C   COMMENTS-
C
C***********************************************************************
      PARAMETER (IFPRNT=53)
C
      LEAPYR=0
      IFILE=0
C
C     *** THE FOLLOWING LINES OF CODE ADJUST THE DATE WHENEVER THE  ***
C     *** 2330Z OR THE 2300Z IMAGE IS PICKED UP TO REPLACE THE      ***
C     *** MISSING 0000Z IMAGE. THE DATES OF THE 2330Z AND THE 2300Z ***
C     *** IMAGES WILL HAVE THE PREVIOUS DATE AS THEIR TIME STAMP.   ***
C     *** THEREFORE THEIR DATES MUST BE INCREASED BY ONE IN ORDER   ***
C     *** THAT WE ARE LOOKING AT THE CORRECT FILE AND THE CORRECT   ***
C     *** POSITION IN THE IDATE AND HISTOGRAM ARRAYS                ***
C
      KYY    = KYMD(IPIC) / 10000
      KJJJ   = KDDD(IPIC)
      KHH    = 0
      KDELHH = 0
C
      IHM = KHM(IPIC)
      IF((IPIC.EQ.1) .AND. (IHM.GE.2230)) KDELHH = 24
C
      CALL DELTAH (IYEAR4(KYY),KJJJ,KHH,KDELHH,IYR4,IDAYR,IHR)
      CALL MDOM (IYR4,IDAYR,NMON,NDAYOM)
      JDATE8 = IYR4*10000 + NMON*100 + NDAYOM
      IYR    = IYEAR2(IYR4)
      JDATE  = IYR *10000 + NMON*100 + NDAYOM
C
      RETURN
      END
C     05-03-08  Brenda Hardie     Migrated to AIX.
C
      SUBROUTINE GETDOY(IDATE,IDOY)
      DIMENSION NDAYS (12)
      DATA NDAYS /0,31,59,90,120,151,181,212,243,273,304,334/
C
      IYR=IDATE/10000
      MON=MOD(IDATE/100,100)
      IDA=MOD(IDATE,100)
      IDOY=NDAYS(MON)+IDA
      IF(MOD(IYR,4).EQ.0 .AND. MON.GT.2) IDOY=IDOY+1
      RETURN
      END
      SUBROUTINE GETPIC(SATNAM,ITIME1,ITIME2,IHIT,NFR,RLATL,IERR,
     1                  KYMD,KHM,KDDD)
C***********************************************************************
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:    GETPIC      INITIALIZER OF THE IMAGERY DATA
C   PRGMMR: JIE MENG         ORG: W/NMC23    DATE: 93-12-05
C
C ABSTRACT: INITIALIZES THE REQUESTED PICTURES AND GETS ORBIT AND
C   ATTITUDE INFORMATION IN THE GOES/METEOSAT IMAGE DATABASE.
C
C PROGRAM HISTORY LOG:
C   86-08-01  PHIL ARKIN
C   93-12-05  JIE MENG
C   94-02-21  JIE MENG          TIME CONVERSION FOR METEOSAT 3.
C                               USE SUBROUTINE DELM2 AND W3FS12.
C   95-01-30  RICHARD SCHREITZ  CHANGED FOR GOES 8 ROUTINE MODE.
C   95-02-24  RICHARD SCHREITZ  MODIFIED PRINT STATEMENT.
C   95-04-15  RICHARD SCHREITZ  MODIFIED FOR 15 APR 95 LOCATOR/READER.
C   95-05-03  RICHARD SCHREITZ  MODIFIED TO REDUCE EXECUTION TIME.
C   95-06-02  RICHARD SCHREITZ  MODIFIED ORDER IN CALLING SEQUENCE
C                               AND DIMENSION STATEMENT.
C   96-05-17  RICHARD SCHREITZ  MODIFIED FOR GOES-9 AND GOES-10.
C                               SIMPLIFIED LOGIC.
C                               MODIFIED PRINTOUT.
C   98-07-24  RICHARD SCHREITZ  INSTALLED UPDATED COMMON AREA KDOCIJ.
C   98-07-28  RICHARD SCHREITZ  REVERSED SEARCH ORDER FOR LONGEST
C                               FRAME SET.
C   98-12-29  RICHARD SCHREITZ  MODIFIED FOR Y2K COMPLIANCE.
C   05-02-18  RICHARD SCHREITZ  REMOVED UNNECESSARY COMMON STATEMENT.
C                               PLACED REMAINING COMMON STATEMENTS IN
C                               AN 'INCLUDE' LIBRARY.
C   03-14-05 Brenda Hardie      Migrated code to AIX platform.
C                               Substituted 'CNVTDOY' for 'W3FS12'.
C   03-23-05 Brenda Hardie      Changed parameter KIFID from 12 to 13.
C   04-13-05 Brenda Hardie      Changed 'STATUS' on open statement for
C                               ft14 (IFPCR2) from 'NEW' to 'UNKNOWN'.
C   06-03-29  RICHARD SCHREITZ  CHANGED PARAMETER KIFID FROM 13 TO 15.
C   08-02-12  RICHARD SCHREITZ  CHANGED PARAMETER KIFID FROM 15 TO 17.
C
C USAGE:    CALL GETPIC(SATNAM,ITIME1,ITIME2,IHIT,NFR,RLATL,IERR,
C          1            KYMD,KHM,KDDD)
C
C   INPUT ARGUMENT LIST:
C     SATNAM  C*11      SATELLITE NAME
C                       = 'GOES-7     ' FOR GOES-7
C                       = 'GOES-8     ' FOR GOES-8
C                       = 'GOES-9     ' FOR GOES-9
C                       = 'GOES-10    ' FOR GOES-10
C                       = 'GOES-12    ' FOR GOES-12
C                       = 'METEOSAT-3 ' FOR METEOSAT-3
C                       = 'METEOSAT-4 ' FOR METEOSAT-4
C                       = 'METEOSAT-5 ' FOR METEOSAT-5
                        CHARACTER*11 SATNAM
C     ITIME1            FIRST REQUESTED PICTURE (1-8)
C     ITIME2            LAST REQUESTED PICTURE (1-8)
C
C   OUTPUT ARGUMENT LIST:
C     IHIT              ORDER NUMBER OF THE FIRST GOOD PICTURE IN
C                       3-HR CARD
CRS   NFR               NUMBER OF FRAMES:
CRS                     ELEMENT (K) CONTAINS THE NUMBER OF FRAMES
CRS                     RETRIEVED IN RESPONSE TO REQUEST K.
                        DIMENSION NFR(8)
CRS   RLATL             LATITUDE LIMITS IN DEGREES (NORTH IS POSITIVE):
CRS                     ELEMENTS (1,J,K) AND (2,J,K), RESPECTIVELY,
CRS                     CONTAIN THE NORTHERNMOST AND SOUTHERNMOST
CRS                     LIMITS ASSOCIATED WITH FRAME J OF REQUEST K
                        DIMENSION RLATL(2,2,8)
CRS   IERR              STATUS ARRAY:
CRS                     ELEMENT (J,K) CONTAINS THE STATUS CODE
CRS                     ASSOCIATED WITH FRAME J OF REQUEST K.
CRS                       0 = INITIALIZATION FOR THE REQUESTED PICTURE
CRS                           HAS BEEN SUCCESSFULLY COMPLETED
CRS                     -51 = THE REQUESTED IMAGERY IS NOT IN THE
CRS                           DATABASE
                        DIMENSION IERR(2,8)
CRS
CRS                     FOR GOES-7,     J = 1
CRS                     FOR GOES-8,9,   J = 1 OR 2
CRS                     FOR METEOSAT,   J = 1
CRS
C     KYMD              YYMMDD OF THE IMAGES
C     KHM               HHMM OF THE IMAGES
C     KDDD              DAY-OF-YEAR OF THE IMAGES
C
C   INPUT FILES:
C     IFPCRD   - I*4  PICTURE REQEST FILE
C         THE PICTURE REQUEST INPUTS LOOK LIKE:
C         FOR GOES 7 IR IMAGERY (8 KM RESOLUTION):
C         W0000ZI8 W0030ZI8 W2330ZI8 W0100ZI8 W2300ZI8 W0130ZI8
C         W0300ZI8 W0330ZI8 W0230ZI8 W0400ZI8 W0200ZI8 W0430ZI8
C         FOR METEOSAT 3 IR IMAGERY: (5 KM RESOLUTION):
C         S0000ZI8 S0030ZI8 S2330ZI8 S0100ZI8 S2300ZI8 S0130ZI8
C            ABBCCZDD,ABBCCZDD, ... ,ABBCCZDD
C            A   REQUESTED SATELLITE
C                E = EAST (MET 3 NOW)
C                W = WEST (GOES 7)
C                S = METEOSAT 3 (STANDBY)
C                A = METEOSAT 4
C            BB  REQUESTED REFERENCE HOUR         (00 - 23)
C            CC  REQUESTED REFERENCE MINUTE       (00,15,30,45)
C            DD  REQUESTED SENSOR AND RESOLUTION
C                I8 / IR = INFRARED 8 KM X 8 KM
C                I2      = INFRARED 5 KM X 5 KM
C                V8 / VS = VISIBLE 8 KM X 8 KM
C                V4      = VISIBLE 4 KM X 4 KM
C                V1      = VISIBLE 1 KM X 1KM     (GOES-NEXT)
C            DEFAULT OF THE UNIT KRPL IN ZINIT IS 5, WHICH IS
C            OVERWRITTEN IN GETPIC AS 12 FOR FIRST CALL TO ZINIT
C            AND 14 FOR SECOND CALL TO ZINIT
C
CRS   FT81 - FT88,  GOES/METEOSAT DATABASE PICTURE
CRS   FT91 - FT98   READ IN ZINIT AND ZREAD
CRS                 THE DEFAULT UNIT NUMBERS 81 - 88 AND 91 - 98
CRS                 ARE ASSIGNED INTERNALLY TO PICTURE REQUESTS 1 - 8.
C
C   OUTPUT FILES:
C     IFPCR2   - PICTURE REQUEST CARD
C     IFPRNT   - PRINTOUT
C
C   SUBPROGRAMS CALLED:
C     LIBRARY:
C       NMC/W3LIB - W3FS12
C       LOCATER/READER: ZINIT, DELM2
C       ZINIT - INITIALIZES THE GOES/METEOSAT IMAGE DATABASE
C               LOCATOR/READER:
C               READS AND CHECKS THE PICTURE REQUEST DATA.
C               RETRIEVES PICTURE STATUS INFORMATION.
C               OPENS THE PICTURE DATA SET, AND
C               RETRIEVES ORBIT AND ATTITUDE INFORMATION.
C               (UP TO 8 PICTURES CAN BE RETRIEVED SIMULTANOUSLY)
C
C               ZINIT COMPUTES THE HORIZONTAL SHIFT OF THE CENTER OF
C               THE EARTH DISK RELATIVE TO THE CENTER OF THE DATA BASE
C               COORDINATE USING LEAST SQUARE FIT.  ZINIT DOES NOT
C               SKIP A PICTURE, OF WHICH CENTERING SHIFT CAN NOT BE
C               COMPUTED.  THE SUBROUTINE ZREAD FIGURES IT OUT.
C EXIT STATUS:
C     SEE IERR OR THE USER'S GUIDE, GOES VISSR DATA BASE LOCATOR/READER
C     FOR ERROR MESSAGES.
C
C ATTRIBUTES:
C   LANGUAGE: IBM VS FORTRAN (FORTRAN 77)
C   MACHINE:  HDS 9000
C
C$$$
C
C COMMON AREA PARAMETERS:
C
      INCLUDE 'fdsrnb.i'
      INCLUDE 'req.i'
      INCLUDE 'bbuf.i'
      INCLUDE 'jdoc.i'
      INCLUDE 'kdocij.i'
C
C     INCLUDE KDBASE AND SET KETDMX FOR TEST DATABASE.
C
      INCLUDE 'kdbase.i'
C
C                                                                      <
C
C LOCAL PARAMETERS:
C
CRS   KIFID   I*4       INTERFACE IDENTIFICATION
CRS   LC      I*4       LINE COUNT
                        DIMENSION LC(6)
CRS   IELTM  (I,J)      ELAPSED TIME FOR PICTURES 1 - 8
CRS           I,J       POINTERS
CRS                     I INDICATES FRAME     (1 - 2)
CRS                     J INDICATES REQUEST   (1 - 8)
CRS                     FOR GOES-7,     I = 1
CRS                     FOR GOES-8,9,   I = 1 OR 2
CRS                     FOR METEOSAT,   I = 1
CRS                     (ELEMENT (I,J) CONTAINS THE ELAPSED TIME IN
CRS                     MINUTES FROM THE START TIME OF FRAME (I,J) TO
CRS                     THE CURRENT TIME)
                        INTEGER*4 IELTM(2,8)
C     NPIC    I*4       NUMBER OF PICTURES REQUESTED (1 - 8)
C
C***********************************************************************
      INTEGER*4 IHIT(8),KYMD(8),KHM(8),KDDD(8)
      CHARACTER*8 BADPIC,IMTIME
      CHARACTER*1 COMMA
      CHARACTER*71 CRDIMG
      CHARACTER*71 CRDIM2
      LOGICAL     EXS,OPN
      CHARACTER*10 ACC
      CHARACTER*23 fileName
      CHARACTER*7 IFPCARD_DDNAME/'IFPCARD'/
      PARAMETER(KIFID=18)
      PARAMETER(IFPRNT=53)
      PARAMETER(IFPCRD=12,IFPCR2=14)
C
      DATA COMMA/','/
      DATA BADPIC/'00000000'/
C
C     
      DO 10 I=1,71
         CRDIMG(I:I) = '0'
   10   CONTINUE
      DO 20 I=1,7
         IPO9 = 9*I
         CRDIMG(IPO9:IPO9) = COMMA
   20   CONTINUE
C
      ITLIM = KETDMX * 24 * 60
      KRPL = IFPCRD
C
      DO 30 ICARD = 1, 8
   30    IHIT(ICARD) = 0
C
      DO 120 IMGCRD = 1, 8
C
        IF(IMGCRD .LT. ITIME1 .OR. IMGCRD .GT. ITIME2) THEN
          READ(KRPL,*)
          GO TO 120
        END IF
C
        CALL ZINIT(KIFID,ABUF,NPIC,NFR,RLATL,IELTM,IERR)
CRS
CRS   FIND THE FRAME SET IN THE SEQUENCE OF SIX FRAME SETS WHICH
CRS   OFFERS THE LARGEST TOTAL LINE COUNT.
CRS
      DO 60 KPIC = 1,6
      LC(KPIC) = 0
      DO 50 KFR = 1,2
CRS
CRS   CHECK THE STATUS OF THE FRAME.
      IF (IERR(KFR,KPIC).LT.0) GO TO 60
CRS
CRS   CHECK THE AGE OF THE FIRST FRAME OF THE FRAME SET.
      IF (KFR.EQ.1) THEN
         KET = IELTM(1,KPIC)
         IF (KET.LE.0.OR.KET.GE.ITLIM) GO TO 60
      END IF
CRS
CRS   INCREMENT LINE COUNT.
      LC(KPIC) = LC(KPIC) + KDBLINECT(KFR,KPIC)
   50 CONTINUE
   60 CONTINUE
CRS
CRS   FIND THE LARGEST TOTAL LINE COUNT.
      LCMAX = 0
      IMGHIT = 0
CRS   THE FOLLOWING STATEMENT WAS REPLACED ON 98-07-28:
CRS   DO 70 KPIC = 6,1,-1
      DO 70 KPIC = 1,6
      IF (LC(KPIC).LE.LCMAX) GO TO 70
      LCMAX = LC(KPIC)
      IMGHIT = KPIC
   70 CONTINUE
CRS
      IF (LCMAX.GT.0) THEN
         IHIT(IMGCRD) = IMGHIT
         IMTIME = REQ(IMGHIT)(1:8)
      ELSE
         IMTIME = BADPIC
         IMGTIM = (IMGCRD - 1) * 3
         WRITE (IFPRNT,210) IMGTIM
      END IF
C
          JPOS = (IMGCRD - 1) * 9
          ISTART = JPOS + 1
          IEND   = JPOS + 8
          CRDIMG(ISTART:IEND) = IMTIME
C
  120   CONTINUE
      WRITE(IFPRNT,220) CRDIMG
C
      CLOSE (UNIT=IFPCRD)
C
      OPEN (UNIT=IFPCR2,FILE=fileName,STATUS='UNKNOWN',FORM='FORMATTED',
     1 IOSTAT=IOS)
      WRITE(IFPCR2,230,IOSTAT=IOS) CRDIMG
      IF(IOS .NE. 0) PRINT *,' WRITING TO UNIT ',IFPCR2,' IS FAILED'
      IF(IOS .EQ. 0) PRINT *,' FILE UNIT ',IFPCR2,' IS WRITTEN ',IOS
      KRPL  = IFPCR2
      REWIND IFPCR2
C
CRS   CLEAR DATA ARRAYS IN COMMON AREAS JDOC AND KDOCIJ.
      CALL ZCLEAR
C
      CALL ZINIT(KIFID,ABUF,NPIC,NFR,RLATL,IELTM,IERR)
      PRINT 240, IERR
C     CLOSE (UNIT=IFPCR2)
C
      DO 130 IMGCRD = ITIME1, ITIME2
CRS   THE FOLLOWING STATEMENT WAS CHANGED ON 98-10-21:
        KYMD(IMGCRD) = 10000 * IYEAR2(NYEAR(1,IMGCRD)) +
     1                 100 * NMON(1,IMGCRD) +
     2                 NDAYOM(1,IMGCRD)
        KHM(IMGCRD) = 100 * NHOUR(1,IMGCRD) + NMIN(1,IMGCRD)
        KDDD(IMGCRD) = NDAYOY(1,IMGCRD)
CRS   THE FOLLOWING STATEMENT WAS CHANGED ON 98-10-21:
        IYR = IYEAR2(NYEAR(1,IMGCRD))
        IDOY = NDAYOY(1,IMGCRD)
        IHH = NHOUR(1,IMGCRD)
        IMM = NMIN(1,IMGCRD)
        K2YY = IYR
        K2DDD = IDOY
        K2HH = IHH
        K2MM = IMM
        IF(SATNAM(1:10).EQ.'METEOSAT-3')THEN
          PRINT *,SATNAM
CRS   THE FOLLOWING STATEMENT WAS CHANGED ON 98-12-29:
          CALL DELM2(0,IYEAR4(IYR),IDOY,IHH,IMM,-30,
     &                 K2YYYY,K2DDD,K2HH,K2MM)
CRS   THE FOLLOWING STATEMENT WAS INSERTED ON 98-12-29:
          K2YY = IYEAR2(K2YYYY)
          KHM(IMGCRD) = K2HH * 100 + K2MM
CBMH      REPLACED: CALL W3FS12(K2YY,K2DDD,JMO,JDA)
          CALL CNVTDOY(K2YY,K2DDD,JMO,JDA)
          KYMD(IMGCRD) = K2YY * 10000 + JMO * 100 + JDA
          KDDD(IMGCRD) = K2DDD
        END IF
 130  CONTINUE
      MPIC = ITIME2 - ITIME1 + 1
C
      WRITE(IFPRNT,200,IOSTAT=IOS) MPIC,
     1                            (KYMD     (   KJ),        KJ=1,8),
     2                            (KHM      (   KJ),        KJ=1,8),
     3                           ((IELTM    (KI,KJ),KI=1,2),KJ=1,8),
     4                           ((IERR     (KI,KJ),KI=1,2),KJ=1,8),
     5                           ((KISF     (KI,KJ),KI=1,2),KJ=1,8),
     6                           ((KFGDBL   (KI,KJ),KI=1,2),KJ=1,8),
     7                           ((KLGDBL   (KI,KJ),KI=1,2),KJ=1,8),
     8                           ((KDBLINECT(KI,KJ),KI=1,2),KJ=1,8),
     9                           ((KDBDROPCT(KI,KJ),KI=1,2),KJ=1,8)
      IF(IOS .NE. 0)PRINT *,' PRINT 200 FAILED IN GETPIC'
      RETURN
C
  200 FORMAT(1X,'NUMBER OF IMAGES      ',      I7/
     1       1X,'YEAR-MONTH-DAY        ',      I7,7I12/
     2       1X,'BEGINNING HOUR-MINUTE ',      I7,7I12/
     3       1X,'ELAPSED TIME OF IMAGE ',2X,8(2I5,2X)/
     4       1X,'ERROR FLAG            ',2X,8(2I5,2X)/
     5       1X,'FLAG FOR HORIZ SHIFT  ',2X,8(2I5,2X)/
     6       1X,'FIRST LINE            ',2X,8(2I5,2X)/
     7       1X,'LAST LINE             ',2X,8(2I5,2X)/
     8       1X,'TOTAL LINES           ',2X,8(2I5,2X)/
     9       1X,'DROP OUT LINES        ',2X,8(2I5,2X)/)
  210 FORMAT('***WARNING:  ',I2,'Z IMAGE COULD NOT BE RECOVERED')
  220 FORMAT(1X,A71)
  230 FORMAT(A71)
  240 FORMAT(1X,'IERR AFTER ZINIT'/(1X,2I10))
      END
      PROGRAM GMHIST
C***********************************************************************        
C$$$  MAIN PROGRAM DOCUMENTATION BLOCK                                          
C                .      .    .                                       .          
C MAIN PROGRAM:  GMHIST      GEOSTATIONARY SATELLITE IR HISTOGRAM               
C   PRGMMR: JIE MENG         ORG: W/NMC23      DATE: 93-12-05                   
C                                                                               
C ABSTRACT: DERIVES EBBT (EQUILIBRIUM BLACK BODY TEMPERATURE) HISTOGRAM         
C   OF 24 TEMPERATURE CLASSES FROM GEOSTATIONARY SATELLITE IR IMAGERY,          
C   WITHIN 1.0 DEGREES LAT/LON BOX FROM 50 DEGREES NORTH TO 50 DEGREES          
C   SOUTH AND LONGITUDINALY 50 DEGREES ON EITHER SIDE OF THE                    
C   SUBSATELLITE POINT.                                                         
C   ALSO, ARCHIVES MEANS AND SPATIAL VARIANCES OF TEMPERATURE WITHIN            
C   EACH 1.0 X 1.0 BOX, FOR EACH DAY, FOR EACH IMAGE.                           
C   THE PROGRAM WAS CALLED GOESPENT, WHICH ARCHIVES GOES DATA IN                
C   PENTAD FORMAT FOR GPCP.                                                     
C                                                                               
C PROGRAM HISTORY LOG:                                                          
C   86-08-01  PHILLIP A. ARKIN, W/NMC                                           
C                                                                               
C   87-11-02  JOHN JANOWIAK     CHG'D LOGIC THAT ASSIGNED STOP CODE             
C     CHG USES NMC DATE FILE RATHER THAN DATE ASSIGNED TO IMAGE IN              
C     NESDIS FILE (WHICH MAY BE OLD)                                            
C   87-12-07  JOHN JANOWIAK     FIXED PROBLEM ASSOCIATED WITH                   
C     MODIFICATION ON 11/2/87.  STOP CODES AT END OF "MAIN" WERE BASED          
C     ON "IDAY" PRIOR TO  12/7/87 CHG.  NOW BASED ON "NMCDA" AS                 
C     ORIGINALLY INTENDED.                                                      
C   87-12-18  JOHN JANOWAIK     FIXED CODE IN "GETDAF" THAT IS                  
C     DESIGNED TO HANDLE LEAP YEARS                                             
C   88-01-15  DIANA D           CODE MADE FORTRAN77 COMPATIBLE I/O              
C     CHG'D FROM "DEFINE FILE" TO "DIRECT"                                      
C   88-03-02  JOHN JANOWIAK     CHG MADE FOR LEAP YEAR.                         
C     FILE NOT LARGE ENOUGH TO HOLD DAILY STATISTICS FOR 6TH DAY OF             
C     SO LEAP YEAR DAY STATS NOT SAVED                                          
C   88-9-23   JOHN JANOWAIK     MEAN T & SIGMA OF TEMP FIXED.                   
C     PRIOR TO THIS CHG, MEAN & SIGMAOF DIGITAL COUNTS SAVED. THIS              
C     CHG WAS MADE OPERATIONALLY ON 9/23/88 (BEG'G OF PENT 8754).               
C   89-02-02  JOHN JANOWIAK     DUE TO GOES-W FAILURE (1/21/89)                 
C     GOES-E MOVED TO CENCVG 100W. MANEUVER COMPLETE ON 2/21/89.                
C     CENCVG(2) CHG'D TO 260. ON 2/2/89 (MID-MANEUVER POINT).                   
C   89-06-18 JOHN JANOWIAK      CHGS TO "ABUF" & "IDOC" DUE TO                  
C     NESDIS CHGS TO "AAA" MODE DATA NOTE CHGS OF DATE INFO IN "IDOC"           
C                                                                               
C   93-12-05  JIE MENG          MANY CHANGES HAVE BEEN MADE.                    
C     SUBROUTINE MCALTB IS USED FOR METEOSAT CALIBRATION.                       
C     SOME CORRECTIONS IN THE SUBROUTINES EXHIST AND INBOX.                     
C     HISTOGRAM THRESHOLD IS SET FOR TEMPERATURE INSTEAD OF DIGITAL             
C     COUNTS.                                                                   
C     NUMBER OF MACROBLOCKS TO RETRIEVE AT A TIME IS INCREASED TO 3             
C     FROM 1, SO THAT THE CPU DECREASED FOR MORE THAN 10 TIMES.                 
C     CHANGES FOR HIGHER EFFICIENCY AND QUALITY.                                
C                                                                               
C   93-12-29  JIE MENG          METEOSAT 3 TIME OFFSET IN FILE                  
C     METEOSAT 3 DATA SETS INGESTED IN NESDIS HAVE TIME OFFSET OF               
C     30 MIN COMPARED TO GOES.  FOR EXAMPLE, 0030Z MET3 IMAGE IS THE            
C     IAMGE ENDING AT 0030Z AND SCANED FROM S TO N.  0030Z GOES IMAGE           
C     IS THE IMAGE STARTING AT 0030Z AND SCANED FROM N TO S.                    
C     THERE IS 2400Z, BUT NO 0000Z IN MET3 DATA SETS.                           
C     CHANGES ARE MADE TO GET 0003Z MET3 WITH 0000Z IN THE PICTURE              
C     REQUEST CARD.                                                             
C     TO USE THE NEW LOCATOR/READER MODULE 'V#ZLR', THE FOLLOWING               
C     CHANGES HAVE BEEN MADE.                                                   
C     (1) REPLACE COMMON AREA 'BLOCK' WITH COMMON AREA 'PFORM'.                 
C     (2) REPLACE VARIABLE 'NBZBUF' WITH 'NPMZBU'.                              
C     (3) REPLACE OLD COMMON AREA 'KDOCIJ' WITH NEW 'KDOCIJ'                    
C        (A NEW VARIABLE 'KDBSAM' HAS BEEN ADDED.)                              
C     (4) REPLACE OLD COMMON AREA 'RPIC' WITH NEW COMMON AREA 'RPIC'.           
C        (A NEW VARIABLE 'ICOV' HAS BEEN ADDED.)                                
C     (5) INCLUDE A NEW COMMON AREA 'MOFF', AND SET MOFF=30 FOR                 
C         METEOSAT 3 BEFORE CALLING 'ZINIT'.                                    
C                                                                               
CRS   COMMON AREAS ARE IN NSS.PSAMVSDM.GEOVIDEO.COMMON                          
C                                                                               
C   94-02-21 JIE MENG                                                           
C     1). TO USE THE UPDATED MODULE OF LOCATOR/READER, WHICH USES               
C         NEW FORTRAN COMPILER ON HDS, CHANGED                                  
C         NPMZPI TO NPMZPIC, NPMZBU TO NPMZBUF IN COMMON/PFORM,                 
C         KDBSAM TO KDBSAMP IN COMMON/KDOCIJ.                                   
C     2). TO CONVERT THE IMAGE DATE-TIME FROM METEOSAT CONVENTION TO            
C         GOES CONVENTION, SUBROUTINE GETPIC IS UPDATED, USING                  
C         DELM2 IN LOCATOR/READER LIB AND W3FS12.                               
C                                                                               
C   95-01-25  RICHARD SCHREITZ  CHANGED FOR GOES-8 ROUTINE MODE AND             
C     USE WITH VERSION 10 OF THE GOES/METEOSAT IMAGE DATABASE                   
C     LOCATOR/READER                                                            
C   95-02-02  RICHARD SCHREITZ  MODIFIED OPTIMIZATION                           
C   95-02-24  RICHARD SCHREITZ  MODIFIED OPTIMIZATION                           
C   95-03-01  RICHARD SCHREITZ  MODIFIED SIZE OF GOES-8 DATA ARRAY              
C   95-03-01  RICHARD SCHREITZ  MODIFIED DIAGNOSTICS                            
C   95-03-22  RICHARD SCHREITZ  MODIFIED ERROR PROCESSING                       
C   95-04-07  RICHARD SCHREITZ  MODIFIED COMPUTATION OF JDATE                   
C   95-05-03  RICHARD SCHREITZ  MODIFIED TO REDUCE EXECUTION TIME               
C   95-05-05  RICHARD SCHREITZ  MODIFIED COMPUTATION OF NUMBER OF               
C                               EMPTY BOXES                                     
C   95-06-02  RICHARD SCHREITZ  MODIFIED CALL TO SUBROUTINE GETPIC              
C   96-05-17  RICHARD SCHREITZ  MODIFIED FOR GOES-9 AND GOES-10                 
C                                                                               
C   96-06-21  JOHN JANOWIAK     MODIFIED FOR 1 DEG X 1 DEG, 24 CLASSES           
C   98-07-24  RICHARD SCHREITZ  INSTALLED UPDATED COMMON AREA KDOCIJ            
C   98-07-27  RICHARD SCHREITZ  INSTALLED UPDATED COMMON AREA SAT               
C   98-07-28  RICHARD SCHREITZ  REVERSED SEARCH ORDER FOR LONGEST               
C                               FRAME SET                                       
C   98-12-29  JOEL SELEKOF      MODIFIED FOR Y2K COMPLIANCE                     
C 1999-04-27  JOEL SELEKOF      CCR 1276 - MODIFIED SUBROUTINE MKFTP            
C                               SO THE CRAY DESTINATION FILE NAME HAS           
C                               2-DIG SATELLITE # AND 4-DIG YEAR.               
C                               ALSO, SET KIFID=12 FOR THE NEW                  
C                               LOCATOR/READER (DA990405).                      
C 2005-02-18  RICHARD SCHREITZ  REMOVED UNNECESSARY COMMON STATEMENT.
C                               PLACED REMAINING COMMON STATEMENTS IN           
C                               AN 'INCLUDE' LIBRARY.                           
C                               RESET UPPER LIMIT OF PHYSICAL FORMAT            
C                               TABLE FROM 60 TO 72.                            
C                               UPDATED NAMES:                                  
C                               IPIC > KREQ, IFR > KFR, IREC > KREC.            
C                               INITIALIZED COMPILER-FLAGGED VARIABLES          
C                               TO ZERO.                                        
C                               CHANGED PRINT STATEMEMT FORMAT.                 
C 2005-03-08  Brenda Hardie     Migrated code to AIX.                           
C                               Commented call to subroutine MKFTP.             
C                               Substituted function "ltime_" for DATIMX        
C                               Added ddnames, open statements and I/O           
C                               error processing.                               
C 2005-04-13  Brenda Hardie     Replaced unformatted sequential write           
C                               statements with unformatted direct write        
C                               statements for the temporary files ft61,        
C                               ft62, ft63, ft64. (IOTMP_1 - IOTMP_4).          
C                               Commented rewind of temporary files.            
C 2005-05-31  Brenda Hardie     Added error checking for "WRITE" to             
C                               IOTMP_1 - IOTMP_4 (ft61 - ft64).                
C                               Removed "rewind" of IO_TEMP (ft61-ft64)         
C                               for ftp of temporary files (ft61-ft64).         
C                               ADDED call to exit_ to return exit              
C                               status.                                         
C                               Replaced statement STOP 1 with RETURN so        
C                               message would not be written to STDERR          
C                               (unit 2).                                       
C                               Added subroutine "op_msg" to output a           
C                               message to the operator when I/O errors         
C                               that require user intervention occur.           
C                               Added system routine "exit_" to return a        
C                               non_zero return code to the system if           
C                               there is a serious error that requires          
C                               user intervention.                              
C 2005-10-10  Brenda Hardie     Removed subroutine "op_msg" to output a         
C                               message to the operator. "op_msg" will          
C                               be called from the run script to output         
C                               messages that require user intervention         
C                               to the operator.
C 2006-04-03  RICHARD SCHREITZ  REMOVED UNNECESSARY PARAMETERS FROM
C                               THE SUBROUTINE GETDAF CALLING SEQUENCE.
C                               DISCONTINUED USE OF SUBROUTINE CHKDAT.
C                               REMOVED UNNECESSARY STATUS PARAMETER
C                               NSTAT.
C 2006-05-15  RICHARD SCHREITZ  ADDED SUBROUTINE GENLBL TO GENERATE
C                               LABELS FOR THE FOUR HISTOGRAM FILES
C                               TO BE PRODUCED AND ADDED FOUR FILES TO
C                               CONTAIN THE LABELS.
C                               ADDED PARAMETER JDATE8 TO THE SUB-
C                               ROUTINE GETDAF CALLING SEQUENCE.
C 2006-05-17  RICHARD SCHREITZ  ADDED SUBROUTINE OPENALL TO REMOVE
C                               PROCESSING ASSOCIATED WITH FILE
C                               OPENING FROM THE MAIN PROGRAM.
C 2006-06-14  RICHARD SCHREITZ  ELIMINATED TRAILING BLANKS IN THE
C                               LABELS GENERATED BY SUBROUTINE GENLBL.
C                               ADDED THE PARAMETER LSATNAM TO THE
C                               READID AND GENLBL CALLING SEQUENCES.
C 2006-08-24  RICHARD SCHREITZ  MODIFIED EQUATION FOR EMPTY BOX COUNT.
C 2008-02-12  RICHARD SCHREITZ  SET KIFID=17 FOR NEW LOCATOR/READER   
C                               (lrrrv1701d20080208_f77_32)
C
C USAGE:
C
C   INPUT FILES:
C
C     IFRNID FT10 RUN ID
C     IFINPT FT11 SUBSATELLITE POINT, SATELLITE NAME, ETC.
C                 IN JCL (FT05 IS USED IN LOCATER/READER)
C     IFPCRD FT12 IMAGE REQUEST CARD
C     IFPCR2 FT14 IMAGE REQUEST CARD
C
CRS               GOES/METEOSAT IMAGER DATABASE FRAMES READ BY
CRS               LOCATOR/READER SUBROUTINES ZINIT AND ZREAD:
CRS
CRS          FT81-FT88 (FT8N IS FOR FRAME 1 OF A 1-2 FRAME SEQUENCE)
CRS                    (MIGHT BE FULL DISK, N HEM, OR S HEM)
CRS          FT91-FT98 (FT9N IS FOR FRAME 2 OF A 2 FRAME SEQUENCE)
CRS                    (S HEM)
CRS
CRS               UNIT NUMBERS 81-88 AND 91-98 ARE THE DEFAULT
CRS               ASSIGNMENTS MADE BY THE LOCATOR/READER FOR
CRS               PICTURE REQUESTS 1-8.
C
C   OUTPUT FILES:
C
C     IFPRNT FT53 PRINTOUT (FT06 IS USED IN LOCATOR/READER)
C     IOMAIN FT58 WEEKLY ROTATING OUTPUT FILE
C     IOTMP1 FT61 TEMPORARY OUTPUT FILE FOR DDS (1ST SELECTED IMAGE)
C     IOTMP2 FT62 TEMPORARY OUTPUT FILE FOR DDS (2ND SELECTED IMAGE)
C     IOTMP3 FT63 TEMPORARY OUTPUT FILE FOR DDS (3RD SELECTED IMAGE)
C     IOTMP4 FT64 TEMPORARY OUTPUT FILE FOR DDS (4TH SELECTED IMAGE)
C     IOT1FN FT71 FINAL NAME FOR 1ST TEMPORARY OUTPUT FILE
C     IOT2FN FT72 FINAL NAME FOR 2ND TEMPORARY OUTPUT FILE
C     IOT3FN FT73 FINAL NAME FOR 3RD TEMPORARY OUTPUT FILE
C     IOT4FN FT74 FINAL NAME FOR 4TH TEMPORARY OUTPUT FILE
C
C       RECORD 1     : DATE, SATELLITE ID & SUB-SAT POINT
C                      R*4, SINGLE WORD -- CENTRAL LONGITUDE                    
C                                                                               
C              2 -  NCLASS: HISTOGRAMS                                          
C              NCLASS+1   : MEAN TEMPERATURE IN GRID BOX                        
C              NCLASS+2   : SPATIAL SIGMA OF IR BRIGHTNESS TEMPS IN GRID        
C                                                                               
C    (IFPINF  FT16  ORBIT AND ATTITUDE INFORMATION AND PICTURE                  
C                   CENTERING INFORMATION (WRITTEN BY GOES DATABASE             
C                   LOCATOR/READER  - NORMALLY DUMMIED OUT,                     
C                   OCCASIONALLY USEFUL IN PROBLEM ANALYSIS))                   
C                                                                               
C   SUBPROGRAMS CALLED:                                                         
C     UNIQUE:  - COMTMP EXHIST GETBOX GETDAF GETPIC INBOX                       
C                READID UPDREC MCALTB (BINARY FVAL) CHKDAT                      
C                MNFRAME ZLLIJ ltime_ op_msg                                    
C                                                                               
C     LIBRARY:                                                                  
C       LOCATOR/READER -  ZINIT  ZLLIJ  ZREAD AND SUPPORT ROUTINES.
C                         BRPK   DELM2                                          
C   EXIT STATUS:                                                                
C     COND =  99 - ABNORMAL EXIT                                                
C     COND =  999 - TOO MANY IMAGES ARE MISSING, RESUBMIT PLEASE !
C
C ATTRIBUTES:                                                                   
C   LANGUAGE: VS FORTRAN 77                                                     
C             IBM ASSEMBLY IN LOCATOR/READER ROUTINES                           
C   MACHINE:  HDS 9000                                                          
C                                                                               
C$$$                                                                            
C NOTES:                                                                        
C   1. TO INCREASE ABUF TO 3 MACROBLOCKS, INCLUDE COMMON/BLOCK                  
C      IN THE ROUTINES CALLING ZINIT, ZLLIJ, ZIJLL AND ZREAD;                   
C      INCREASING THE BUFFER FROM 1 TO 3 MACROBLOCKS REDUCED THE                
C      I/O TIME BY MORE THAN 10 TIMES.                                          
CRS    SET NPMZBUF(KSENRES),KSENRES=1,60 = 7.                                   
C   2. SINGLE PRECISION IS NOT ENOUGH TO DETERMINE WHETHER A PIXEL              
C      POINT IS IN A BOX.  USE R*8 IN INBOX. INBOX IS REWRITTEN.                
C      GOOD PIXELS EVEN ENTIRE BOX COULD BE EXCLUDED BY USING R*4.              
C   3. THERE WAS AN INFINITE LOOP IN EXHIST IN CASE OF EMPTY BOX.               
C   4. IN PICDAT(M,N), 1ST SUBSCRIPT IS HORIZONTAL, 2ND IS VERTICAL.            
C      IVAL=PICDAT(I2,I1), NOT (I1,I2) IN EXHIST.                               
C   5. CAREFUL CONSIDERATION IS NEEDED TO SET LOGIC FOR VARIOUS                 
C      VALUES OF ERROR FLAGS SO THAT USEFUL PIXELS ARE NOT                      
C      EXCLUDED AND BAD PIXEL VALUES ARE NOT INCLUDED.                          
C      IN CASE OF SHORT PICTURE, ERROR FLAG KSTAT CAN HAVE A                    
C      FAKE ERROR VALUE, E.G. 232, FOR A GOOD LINE.                             
C   6. PIXEL VALUE 254 IS SUPPOSED TO BE FOR SPACE OUTSIDE THE EARTH.           
C      254 APEARS FOR NORMAL EARTH LOCATION ONCE IN A WHILE.                    
C      THAT IS A SERIOUS PROBLEM TO BE FIXED BY THE PROVIDER OF THE             
C      GOES DATABASE.   IF 254 OCCURS, RELIABILITY OF THE OTHER                 
C      PIXELS IN THE SCAN LINE AND EVEN THE ADJACENT LINES IS                   
C      QUESTIONABLE.                                                            
C   7. TO USE TEST DATA SET, INCLUDE KDBASE AND SET KETDMX=7 OR SO              
C      FOR REAL TIME NESDIS DATABASE, KDBASE=1, FOR NMC DB KDBASE=2.            
C      FOR TEST DATABASE:                                                       
C        GOES7 BY NESDIS: KDBASE=1, TST.VGE.D93200.S1431.T1340...               
C        METEO BY NESDIS:       =1, MET.IR22.M3.D93200.T1430, TEST              
C        METEO BY NMC:          =2, NMC.TEST.M4IR22.T1430, OFF LINE             
C                                   NMC.PROD.M4IR22.T1430, OPERATIONAL          
C      IT SHOULD BE CONSISTENT WITH NSS.GEAGVSSW.SMSGOES.DATA(DSN#SK)            
C                              OR   NWS.WD20.JM.OPRGPI(DSN#SK)                   
C**                                                                             
C                                                                               
C COMMON AREA PARAMETERS:                                                       
C                                                                               
CRS   THE COMMON AREAS ASSOCIATED WITH THE LOCATOR/READER ARE IN                
CRS   THE LIBRARY 'NSS.PSAMVSDM.GEOVIDEO.COMMON'.                               
C                                                                               
      INCLUDE 'ifiles.i'
      INCLUDE 'req.i'
      INCLUDE 'pos.i'
      INCLUDE 'sat.i'                                                           
      INCLUDE 'pform.i'
      INCLUDE 'box.i'
C                                                                               
C LOCAL PARAMETERS:                                                             
C                                                                               
C                       DIMENSIONS FOR VARIABLY DIMENSIONED ARRAYS              
                        PARAMETER(NLON=100,NLAT=100,NCLASS=24)                  
                        PARAMETER(MAXM=130,MAXN=80)                             
                        PARAMETER(NIMG=8,NCARD=8)                               
C                                                                               
C     ALATS   R*4       ARRAY OF VERTICAL (NORTH - SOUTH) COORDINATES           
C                       IN GOES DATABASE PICTURE                                
C                       1ST/2ND DIMENSION CORRESPONDS TO LONG/LAT               
                        REAL*4 ALATS(NLON+1, NLAT+1)                            
C     ALATMIN R*4       MINIMUM VALUE OF ALATS(I,J) IN LATITUDE BAND J          
                        REAL*4 ALATMIN(NLAT+1)                                  
C     ALONS   R*4       ARRAY OF HORIZONTAL (WEST - EAST) COORDINATES           
C                       IN GOES DATABASE PICTURE                                
C                       1ST/2ND DIMENSION CORRESPONDS TO LONG/LAT               
                        REAL*4 ALONS(NLON+1, NLAT+1)                            
C     BLON    R*4       LONGITUDE IN DEGREES (EAST IS POSITIVE)
C     CENCVG  R*4       CENTRAL LONGITUDE FOR THE DATA ARCHIVED
C     FLAT    R*4       LATITUDE OF UPPER LEFT CORNER OF 1X1 BOX.               
                        REAL*4 FLAT(NLAT+1)                                     
C     FLON    R*4       LONGITUDE OF UPPER LEFT CORNER OF 1X1 BOX.              
                        REAL*4 FLON(NLON+1)                                     
C     IDAT    I*4       MISSING DATA FLAG IN EACH 1X1 DEGREE AREA               
C                       = 0  IF NO IMAGE DATA IN THE 1/2 HOUR                   
C                       = 1  IF THERE IS DATA IN THE 1/2 HOUR                   
                        INTEGER*4 IDAT(NLON,NLAT)                               
C     IDATA   I*4       HISTOGRAM DATA                                          
C                       TEMPERATURE POPULATION OF 16 CLASSES ACCUMULATED        
C                       OVER THE ACTIVE PENTAD FOR EACH 1.0 X 1.0 BOX.          
C                       1ST/2ND DIMENSION OF THE ARRAY CORRESPONDS TO           
C                       LONGITUDE/LATITUDE, 3RD TO 24 CLASSES.                  
                        INTEGER*2 IDATA(NLON,NLAT,NCLASS+2)                     
C     IDAY    I*4       DAY OF PENTAD, 1 - 6, 6 ON FEB. 29 IN LEAP YR           
CRS   IERR              STATUS ARRAY                                            
CRS                     ELEMENT (J,K) CONTAINS THE STATUS CODE                  
CRS                     ASSOCIATED WITH FRAME J OF REQUEST K.                   
CRS                       0 = INITIALIZATION FOR THE REQUESTED PICTURE          
CRS                           HAS BEEN SUCCESSFULLY COMPLETED                   
CRS                     -51 = THE REQUESTED IMAGERY IS NOT IN THE               
CRS                           DATABASE                                          
                        DIMENSION IERR(2,8)                                     
CRS                                                                             
CRS                     FOR GOES-7,        J = 1                                
CRS                     FOR GOES-8,9,10,   J = 1 OR 2                           
CRS                     FOR METEOSAT,      J = 1                                
CRS                                                                             
C     IFLG    I*4       FLAG FOR ARCHIVING HISTORY                              
C                       0 = THE OLD DATA HAS BEEN ARCHIVED                      
C                       1 = THE DATA HAS NOT BEEN ARCHIVED                      
C     IGMT    I*4       STARTING TIME ( Z ) OF THE SELECTED PICTURE             
C     IHIST   I*4       TEMPERATURE POPULATION OF 24 CLASSES IN EACH            
C                       BOX OF EACH IMAGE.                                      
                        INTEGER*4 IHIST(NCLASS)                                 
C     IHIT    I*2       FLAG ARRAY FOR GOOD OR BAD PICTURE                      
C                       >= 1 AND <= 6, THERE IS A GOOD PICTURE                             
C                       = 0, THERE IS NO GOOD PICTURE IN THE 3-HR PERIOD        
                        INTEGER*4 IHIT(8)
C     IOTNFN  I*4       FINAL NAME FOR NTH TEMPORARY OUTPUT FILE (N=1,4)
                        INTEGER*4 IOTNFN(4)
CJS   INOW    I*4       BUFFER FOR DATE AND TIME DATA                           
                        INTEGER*4 INOW(14)                                      
C     JTIME   I*4       IMAGE REQUEST TIME (STARTING HHMM)                      
                        INTEGER*4 JTIME(NCARD)                                  
C     IJE     I*4       ERROR FLAG IN READING THE IMAGE DATABASE                
C                       RETURNED FROM ZREAD IN GETBOX                           
C                        0 = SUCCESSFUL COMLETION                               
C                       -N = ERROR, THE BOUNDARY OF THE DATA REQUESTED          
C                            EXTENDS BEYOND THE BOUNDARY OF THE DATA            
C                            AVAILABLE                                          
C     KE      I*4       ERROR FLAG RETURNED FROM ZLLIJ                          
C                        0 = SUCCESSFUL COMPLETION                              
C                       -N = ERROR                                              
C     KREC    I*4       RECORD NUMBER TO WRITE (???)                            
C     KYMD    I*4       PICTURE STARTING YR, MO, DAY                            
                        INTEGER*4 KYMD(NIMG)                                    
C     KHM     I*4       PICTURE STARTING HOUR AND MINUTE                        
                        INTEGER*4 KHM(NIMG)                                     
C     KDDD    I*4       DAY-OF-YEAR OF THE SELECTED IMAGE                       
                        INTEGER*4 KDDD(NIMG)
C     LSATNAM I*4       LENGTH OF SATELLITE NAME
                        INTEGER*4 LSATNAM
			                                                                             
CRS   NFR               NUMBER OF FRAMES                                        
CRS                     ELEMENT (K) CONTAINS THE NUMBER OF FRAMES               
CRS                     RETRIEVED IN RESPONSE TO REQUEST K.                     
                        DIMENSION NFR(8)                                        
C     PICDAT  I*2       DIGITAL COUNT BUFFER FOR REQUESTED IMAGE                
C                       (M * N * IX BYTES)                                      
C                       M, HORIZONTAL SAMPLE COUNT, OR PIXELS                   
C                       N, VERTICAL SAMPLE COUNT, OR LINES                      
C                       IX, WORD SIZE IN BYTES,                                 
CRS                                                                             
C IR RESOLUTION: GOES-7 = 8KM, GOES-8 = 4KM, METEOSAT = 5KM                     
C                                                                               
                        INTEGER*2 PICDAT(MAXM,MAXN)                             
C FOR GOES-7, 1.0 BOX:  INTEGER*2 PICDAT(50,50)                                 
C FOR GOES-8, 1.0 BOX:  INTEGER*2 PICDAT(130,80)                                
C                                                                               
CRS   GOES-8 THROUGH GOES-10 ARE FUNCTIONALLY IDENTICAL.                        
CRS   METEOSAT-3 THROUGH METEOSAT-5 ARE FUNCTIONALLY IDENTICAL.                 
C                                                                               
CRS   RLATL             LATITUDE LIMITS IN DEGREES (NORTH IS POSITIVE)          
CRS                     ELEMENTS (1,J,K) AND (2,J,K), RESPECTIVELY,             
CRS                     CONTAIN THE NORTHERNMOST AND SOUTHERNMOST               
CRS                     LIMITS ASSOCIATED WITH FRAME J OF REQUEST K             
                        DIMENSION RLATL(2,2,8)                                  
C     SATNAM  C*11      SATELLITE NAME
C                       = 'GOES-7     ' FOR GOES-7                              
C                       = 'GOES-8     ' FOR GOES-8                              
C                       = 'GOES-9     ' FOR GOES-9                              
C                       = 'GOES-10    ' FOR GOES-10                             
C                       = 'METEOSAT-3 ' FOR METEOSAT-3                          
C                       = 'METEOSAT-4 ' FOR METEOSAT-4                          
C                       = 'METEOSAT-5 ' FOR METEOSAT-5                          
                        CHARACTER*11 SATNAM
C     XMEAN   R*4       MEAN TEMPERATURE IN EACH BOX OF EACH IMAGE.             
C     XPRCP   R*4       PRECIPITATION INDEX                                     
C     VAR     R*4       TEMPERATURE VARIANCE IN EACH BOX OF EACH IMAGE          
C                                                                               
C***********************************************************************        
C***  DDNAMES                                                                   
      CHARACTER*1023 fileName                                                   
      CHARACTER*6 IFPRNT_DDNAME/'IFPRNT'/                                      
      CHARACTER*6 IFRNID_DDNAME/'IFRNID'/                                      
      CHARACTER*6 IFINPT_DDNAME/'IFINPT'/                                      
      CHARACTER*6 IFPCRD_DDNAME/'IFPCRD'/                                      
      CHARACTER*6 IFPCR2_DDNAME/'IFPCR2'/                                      
      CHARACTER*6 IOMAIN_DDNAME/'IOMAIN'/                                      
      CHARACTER*6 IOTMP1_DDNAME/'IOTMP1'/
      CHARACTER*6 IOTMP2_DDNAME/'IOTMP2'/                                      
      CHARACTER*6 IOTMP3_DDNAME/'IOTMP3'/                                      
      CHARACTER*6 IOTMP4_DDNAME/'IOTMP4'/
      CHARACTER*6 IOT1FN_DDNAME/'IOT1FN'/
      CHARACTER*6 IOT2FN_DDNAME/'IOT2FN'/
      CHARACTER*6 IOT3FN_DDNAME/'IOT3FN'/
      CHARACTER*6 IOT4FN_DDNAME/'IOT4FN'/

      INTEGER*4   ERRCOD,RETCOD/0/,IOERR                                       
      INTEGER*4   RECNUM/1/                                                    
C
      DATA BLON/0.0/,KREC,IOS/0,0/                                      
C
      CALL OPENALL(RETCOD)
      IF (RETCOD.NE.0) GO TO 900
C
C ---
      WRITE(IFPRNT,1100)                                                        
C                                                                               
      CALL READID(SATNAM,LSATNAM,CENCVG,ITIME1,ITIME2,JTIME,
     +            KPOS,KSAT,IOS)
      ICNCVG=(CENCVG-360.)*100.
      IF(IOS .NE. 0) GO TO 900                                                  
C                                                                               
C --- GET THE PICTURE INFORMATION                                               
C                                                                               
      CALL GETPIC(SATNAM,ITIME1,ITIME2,IHIT,NFR,RLATL,IERR,                     
     1            KYMD,KHM,KDDD)                                                
C                                                                               
C                                                                               
C --- MAIN LOOP OVER THE REQUESTED PICTURES                                     
C                                                                               
      DO 500 KREQ = ITIME1, ITIME2                                              
      IMGDAT=KYMD(KREQ)                                                         
C                                                                               
         DO KK=1,NCLASS+2                                                       
            DO JJ=1,NLAT                                                        
               DO II=1,NLON                                                     
               IDATA(II,JJ,KK)=0                                                
               ENDDO                                                            
            ENDDO                                                               
         ENDDO                                                                  
C                                                                               
        ISUM = 0                                                                
        PP = 0.                                                                 
        IEMPTY = 0                                                              
        NPRCP = 0                                                               
        I254 = 0                                                                
        IF(IHIT(KREQ) .EQ. 0) THEN                                              
          WRITE(IFPRNT,1130) ! KREQ,KYMD(KREQ),KHM(KREQ)                           
          GO TO 500                                                             
        END IF                                                                  
C                                                                               
C ----- GENERATE CALIBRATION TABLE USING IDOC IN THE HEADER FOR MET3            
C                                                                               
        IF(SATNAM(1:3).EQ.'MET')THEN                                            
          CALL MCALTB(KREQ,IECAL)                                               
          IF(IECAL .NE. 0) GO TO 500                                            
        END IF                                                                  
C                                                                               
C ----- SUBROUTINE GETDAF (1) ADJUSTS THE DATE WHEN THE INGEST CYCLE            
C       SELECTED FOR THE 00Z ANALYSIS BEGINS DURING THE PREVIOUS DAY            
C       (E. G. 2345Z, 2330Z, 2315Z, 2300Z, . . . ) AND (2) BUILDS
C       JDATE8 (YYYYMMDD) AND JDATE (YYMMDD).
C                                                                               
        CALL GETDAF(KREQ,IHIT,KYMD,KHM,KDDD,JDATE8,JDATE,IYR,IDAYR,IHM)
C                                                                               
C -----------------------------------------------                               
C                                                                               
        WRITE(IFPRNT,*)' '                                                      
        WRITE(IFPRNT,*)'----- PROCESSING IMAGE ',KREQ,JDATE,IHM,'Z',            
     &                  IDAYR,IDAY                                              
C                                                                               
          DO 290 KFR = 1,NFR(KREQ)                                              
            DO 50 J = 1,NLAT+1                                                  
            DO 40 I = 1,NLON+1                                                  
            ALONS(I,J)=-99999.                                                  
            ALATS(I,J)=-99999.                                                  
   40       CONTINUE                                                            
   50       CONTINUE                                                            
          IF (IERR(KFR,KREQ).NE.0) GO TO 290                                    
          DO 100 J = 1, NLAT+1                                                  
            BLAT=50.-J+1.                                                       
            IF (BLAT.GT.RLATL(1,KFR,KREQ) .OR.                                  
     1          BLAT.LT.RLATL(2,KFR,KREQ)) GO TO 100                            
            FLAT(J) = BLAT                                                      
            ALATMIN(J) = 5000.                                                  
            DO 80 I = 1, NLON+1                                                 
              BLON=(CENCVG-50.)+I-1.                                            
              IF (BLON.GT.180.) BLON=BLON-360.                                  
              FLON(I) = BLON                                                    
C                                                                               
              ALONS(I,J)=-99999.                                                
              ALATS(I,J)=-99999.                                                
C                                                                               
C -----       CONVERT LAT/LON TO IMAGE COORDINATES                              
              CALL ZLLIJ(KREQ,KFR,BLAT,BLON,ALONS(I,J),ALATS(I,J),KE)           
C                                                                               
              IF (KE.EQ.0) GO TO 70                                             
              ALONS(I,J)=-99999.                                                
              ALATS(I,J)=-99999.                                                
CCC           WRITE(IFPRNT,*)   'KE .NE. 0 IN ZLLIJ'                            
CCC           WRITE(IFPRNT,1140)'KREQ,KFR,J,I,BLAT,BLON,KE:       ',            
CCC  1                           KREQ,KFR,J,I,BLAT,BLON,KE                      
              GO TO 80                                                          
  70          IF (ALATS(I,J).GT.0.0.AND.ALATS(I,J).LT.ALATMIN(J))               
     1        ALATMIN(J) = ALATS(I,J)                                           
C                                                                               
  80        CONTINUE                                                            
 100      CONTINUE                                                              
C                                                                               
          DO 110 KSENRES = 1,72                                                 
          NPMZBUF(KSENRES) = 7                                                  
 110      CONTINUE                                                              
C                                                                               
          DO 250 J = 1, NLAT                                                    
          DO 240 I = 1, NLON                                                    
C                                                                               
            DO 220 JTEST = J,J+1                                                
            DO 210 ITEST = I,I+1                                                
            IF (ALATS(ITEST,JTEST) .EQ. -99999.0 .OR.                           
     1          ALONS(ITEST,JTEST) .EQ. -99999.0)                               
     2      THEN                                                                
              IEMPTY = IEMPTY + 1                                               
              GO TO 240                                                         
            END IF                                                              
  210       CONTINUE                                                            
  220       CONTINUE                                                            
C                                                                               
C -----     RETRIEVE ARRAY OF PIXELS (PICDAT) FOR EACH BOX                      
C                                                                               
            CALL GETBOX(I,J,ALATS,ALONS,PICDAT,KREQ,KFR,IJE,KSTAT)              
C                                                                               
            IF(KSTAT .NE. 0) THEN                                               
              IF(KSTAT .NE. 218 .AND. KSTAT .NE. 232) THEN                      
              WRITE(IFPRNT,*)   'ABNORMAL CONDITION IN ZREAD'                   
              WRITE(IFPRNT,1140)'KREQ,KFR,J,I,BLAT,BLON,IJE,KSTAT:',            
     1                           KREQ,KFR,J,I,BLAT,BLON,IJE,KSTAT,              
     2                          'ICLAT,ICLON,N,M:',                             
     3                           ICLAT,ICLON,N,M                                
              END IF                                                            
              IEMPTY = IEMPTY + NLON - I + 1                                    
              GO TO 250                                                         
            END IF                                                              
C                                                                               
            IF (IAND(-IJE,8).GT.0) THEN                                         
              WRITE(IFPRNT,*)'!!!   (I,J) ERROR 8   TOO FAR SOUTH   !!!'        
              WRITE(IFPRNT,1140)'KREQ,KFR,J,I,BLAT,BLON,IJE:      ',            
     1                           KREQ,KFR,J,I,BLAT,BLON,IJE                     
              IEMPTY = IEMPTY + 1                                               
              GO TO 240                                                         
            END IF                                                              
C                                                                               
            IF (IAND(-IJE,4).GT.0) THEN                                         
              WRITE(IFPRNT,*)'!!!   (I,J) ERROR 4   TOO FAR NORTH   !!!'        
              WRITE(IFPRNT,1140)'KREQ,KFR,J,I,BLAT,BLON,IJE:      ',            
     1                           KREQ,KFR,J,I,BLAT,BLON,IJE                     
              IEMPTY = IEMPTY + 1                                               
              GO TO 240                                                         
            END IF                                                              
C                                                                               
            IF (IAND(-IJE,2).GT.0) THEN                                         
              WRITE(IFPRNT,*)'!!!   (I,J) ERROR 2   TOO FAR EAST   !!!'         
              WRITE(IFPRNT,1140)'KREQ,KFR,J,I,BLAT,BLON,IJE:      ',            
     1                           KREQ,KFR,J,I,BLAT,BLON,IJE                     
              IEMPTY = IEMPTY + 1                                               
              GO TO 240                                                         
            END IF                                                              
C                                                                               
            IF (IAND(-IJE,1).GT.0) THEN                                         
              WRITE(IFPRNT,*)'!!!   (I,J) ERROR 1   TOO FAR WEST   !!!'         
              WRITE(IFPRNT,1140)'KREQ,KFR,J,I,BLAT,BLON,IJE:      ',            
     1                           KREQ,KFR,J,I,BLAT,BLON,IJE                     
              IEMPTY = IEMPTY + 1                                               
              GO TO 240                                                         
            END IF                                                              
C                                                                               
C -----     CONVERT PIXEL VALUES TO T AND COMPUTE HISTOGRAM                     
C                                                                               
            CALL EXHIST(SATNAM,I,J,NLON,NLAT,ALATS,ALONS,FLAT,FLON,             
     1             PICDAT,IHIST,NCLASS,NPIX,XMEAN,VAR,XPRCP,I254)               
            IF(NPIX .LE. 50) THEN                                               
              IEMPTY = IEMPTY + 1                                               
              GO TO 240                                                         
            END IF                                                              
            IF(XPRCP .GT. 0.) NPRCP = NPRCP + 1                                 
            CALL UPDREC(I,J,IDATA,IHIST,NLON,NLAT,NCLASS,KREQ,XMEAN,VAR)        
C                                                                               
 240      CONTINUE                                                              
 250      CONTINUE                                                              
 290      CONTINUE                                                              
 300      CONTINUE                                                              
C                                                                               
        N0 = NLAT * NLON
CRS                                                                             
        IEMPTY = IEMPTY - (NFR(KREQ) - 1) * N0                                  
CRS     THIS TECHNIQUE FOR DETERMINING THE NUMBER OF EMPTY BOXES IS             
CRS     ONLY VALID IF THE SCANNING PROCESS NEVER FILLS THE SAME BOX             
CRS     TWICE.  BECAUSE OF THE SIZE OF THE BOXES REQUESTED IN THIS              
CRS     APPLICATION (2.5 DEGREES BY 2.5 DEGREES) AND THE SMALL                  
CRS     OVERLAP BETWEEN THE TWO FRAMES PROVIDED IN THE TWO-FRAME MODE           
CRS     (20 4 KM LINES), IT IS NOT POSSIBLE TO FILL THE SAME BOX TWICE.         
C                                                                               
        NB = IEMPTY                                                             
        N1 = NPRCP
        PE = REAL(IEMPTY) / N0 * 100
        P0 = REAL(N1) / N0 * 100
        IF(NB .NE. N0)PP = REAL(N1) / (N0 - NB) * 100
        IF(NB .EQ. N0)PP = 0.                                                   
        WRITE(IFPRNT,1110)IEMPTY,PE
        WRITE(IFPRNT,1120)N1,P0,PP                                              
        WRITE(IFPRNT,*)'NO. OF 254''S ',I254                                    
C                                                                               
C                                                                               
C --- OUTPUT RESULTS -------                                                    
C                                                                               
      READ (POS(KPOS)(22:27),'(F6.1)') SSLON                                    
      PRINT '(F6.1)', SSLON                                                     
      ISLON=SSLON*100.                                                          
      IY=JDATE8/10000                                                           
      IM=MOD(JDATE8/100,100)                                                    
      ID=MOD(JDATE8,100)
      CALL DOW(IY,IM,ID,IDOW)
C
C     CONVERT FROM SUNDAY = 0 TABLE TO SUNDAY = 1 TABLE
      IDOW = IDOW + 1
      CALL MNFRAME(KREQ,IHM,IDOW,IOMAIN,IMGDAT,ICNCVG,ISLON,IDATA,
     1             NLON,NLAT,NCLASS)                                            
      KTIME=KREQ                                                                
      IF(KTIME.GT.4) KTIME=KTIME-4                                              
      IOTEMP=60+KTIME                                                          
      WRITE(IOTEMP, REC=RECNUM, IOSTAT=IOERR)                                  
     1 IMGDAT,IHM,ICNCVG,ISLON,IDATA                                            
      IF (IOERR .NE. 0) THEN                                                   
        RETCOD = -30
        WRITE(IFPRNT,*) 'ERROR WRITING IMAGE FILE'
        WRITE(IFPRNT,*) 'IOSTAT=',IOERR
        GO TO 900
      END IF                                                                    
                                                                                
        IF(IHIT(KREQ) .NE. 0) ISUM = ISUM + 1                                   
 500  CONTINUE                                                                  
C
      DO N = 1,4
      IF (N.EQ.1) IOTNFN(1) = IOT1FN
      IF (N.EQ.2) IOTNFN(2) = IOT2FN
      IF (N.EQ.3) IOTNFN(3) = IOT3FN
      IF (N.EQ.4) IOTNFN(4) = IOT4FN
      END DO
C
      DO I = ITIME1,ITIME2
      N = I
      IF (N.GT.4) N = N - 4
      IF (IHIT(I).NE.0) THEN
      CALL GENLBL (I,JDATE8,SATNAM,LSATNAM,IOTNFN(N))
      END IF
      END DO
C
      GO TO 910                                                                 
C                                                                               
 900  WRITE(IFPRNT,*)' ***** PROBLEMS ENCOUNTERED ***** '                       
      WRITE(IFPRNT,*)' ( SEE DIAGNOSTIC PRINTS ABOVE ) '                        
                                                                                
 910  WRITE(IFPRNT,*)' *** JOB RAN TO PLANNED EXIT  ***'
                                                                                
C --- SEND RETURN CODE TO RUN SCRIPT.                                           
      CALL exit_(RETCOD)                                                        
      RETURN                                                                    
C                                                                               
 1100 FORMAT(' '/11X,'WELCOME TO THE GEOSTATIONARY SATELLITE ',
     1     'HISTOGRAM PROGRAM' //
     2  1X,'THIS PROGRAM GENERATES TEMPERATURE HISTOGRAMS ',
     3     'FOR 1 DEGREE LAT/LON BOXES IN'/
     4  1X,'AN AREA THAT SPANS 100 DEGREES OF LATITUDE AND ',
     5     '100 DEGREES OF LONGITUDE AND'/
     6  1X,'IS CENTERED ON THE NOMINAL SUBSATELLITE POINT.'/)
 1110 FORMAT(' NO. OF EMPTY BOXES           ',I8,5X,F5.1,' %')                  
 1120 FORMAT(' NO. OF BOXES WITH T <= 235 K ',I8,5X,F5.1,' %',F7.1,' %')        
 1130 FORMAT(' !!!!! THE ENTIRE 3 HOUR PICTURE SEQUENCE IS MISSING')            
 1140 FORMAT(' ',A33,1X,2I3,2I5,2F8.1,2I4,3X,A16,4I5)                           
 1160 FORMAT(2I6,4X,8I6)                                                        
 1170 FORMAT(' ----- HISTOGRAM WAS ALREADY ARCHIVED FOR: ',2I6,'Z')             
 1180 FORMAT(///10X,' IDATES:',6I10)
      END                                                                       
      SUBROUTINE INBOX(YY,XX,X,Y,IFIRST,ABOX,IO)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:  INBOX         CHECKS TO SEE IF A POINT IS INSIDE A BOX
C   PRGMMR: JIE MENG         ORG: W/NMC23        DATE: 93-05-08
C
C ABSTRAC: CHECKS TO SEE WHETHER A SPECIFIED POINT IS INSIDE THE BOX.
C
C PROGRAM HISTORY LOG:
C   86-08-01  PHILIP A. ARKIN
C   93-05-08  JIE MENG         USE R*8 INSTEAD OF R*4 TO COMPUTE AREA
C   05-03-08  Brenda Hardie    Migrated code to AIX.
C
C USAGE:     CALL INBOX(YY,XX,X,Y,IFIRST,ABOX,IO)
C   INPUT ARGUMENT LIST:
C     XX       - R*8 WEST-EAST IMAGE COORDINATE OF THE POINT
C     YY       - R*8 NORTH-SOUTH IMAGE COORDINATE OF THE POINT
C     X        - R*8 W - E IMAGE COORDINATES OF CORNERS OF THE BOX
C     Y        - R*8 N - S IMAGE COORDINATES OF CORNERS OF THE BOX
C     IFIRST   - I*4 INDEX TO SKIP CALCULATING THE AREA OF THE BOX
C                    0 = FIRST CALCULATION FOR THE BOX (I,J)
C                    1 = ELSE
C
C   OUTPUT ARGUMENT LIST:
C     IO       - L*4 LOGICAL FLAG
C                    TRUE  = IF THE POINT (I1,I2) IS INSIDE BOX
C                    FALSE = IF THE POINT IS OUTSIDE THE BOX
C     IFIRST   - I*4 INDEX TO SKIP CALCULATING THE AREA OF THE BOX
C                    0 = FIRST CALCULATION FOR THE BOX (I,J)
C                    1 = ELSE
C     ABOX           AREA OF THE BOX, CALCULATED AT THE FIRST CALL
C
C REMARKS: IF THE POINT IS OUTSIDE OF THE BOX, SUM OF THE AREAS OF 4
C   TRIANGLES, WHICH HAVE ONE COMMON CORNER AT THE POINT, ARE LARGER
C   THAN THE AREA OF THE BOX.
C
C ATTRIBUTES:
C   LANGUAGE: IBM VS FORTRAN (FORTRAN 77)
C   MACHINE:  HDS 9000
C$$$
C
C LOCAL PARAMETERS:
C     ABOX    R*8       AREA OF THE BOX (I,J)
C     ABOX1   R*8       AREA OF THE TRIANGLE, ONE PART OF THE BOX
C     ABOX2   R*8       AREA OF THE TRIANGLE, ANOTHER PART OF THE BOX
C     AT1     R*8       AREA OF THE TRIANGLE WITH ONE CORNER AT THE
C                       POINT AND OTHERS ON TWO CORNERS OF THE BOX.
C     AT2     R*8       AREA OF THE TRIANGLE WITH ONE CORNER AT THE
C                       POINT AND OTHERS ON TWO CORNERS OF THE BOX.
C     AT3     R*8       AREA OF THE TRIANGLE WITH ONE CORNER AT THE
C                       POINT AND OTHERS ON TWO CORNERS OF THE BOX.
C     AT4     R*8       AREA OF THE TRIANGLE WITH ONE CORNER AT THE
C                       POINT AND OTHERS ON TWO CORNERS OF THE BOX.
C     ATS     R*8       SUM OF THE AREAS OF THE FOUR TRIANGLES
C     A       R*8       RATIO OF ATS OVER ABOX
C
      LOGICAL*4 IO
      REAL*8  X(4),Y(4),XX,YY
      REAL*8  ABOX,ABOX1,ABOX2,AT1,AT2,AT3,AT4,ATS,A
C
      IF (IFIRST.EQ.1) GO TO 10
      IFIRST=1
C
C     CALCULATE THE AREA OF THE BOX FOR THE FIRST TIME IN THE BOX
      ABOX1 = X(1) * Y(2) - X(1) * Y(3) + X(2) * Y(3) - X(2) * Y(1) +
     1        X(3) * Y(1) - X(3) * Y(2)
      ABOX2 = X(2) * Y(4) - X(2) * Y(3) + X(4) * Y(3) - X(4) * Y(2) +
     1        X(3) * Y(2) - X(3) * Y(4)
      ABOX = 0.5 * (ABS(ABOX1) + ABS(ABOX2))
      IF(ABOX.EQ.0.) WRITE(*,*) '(INBOX) X,Y:',X,Y
C
   10 CONTINUE
C
C     CALCULATE THE AREA OF FOUR TRIANGLES
      AT1 = XX * Y(3) - XX * Y(1) + X(3) * Y(1) - X(3) * YY +
     1       X(1) * YY - X(1) * Y(3)
      AT2 = XX * Y(4) - XX * Y(3) + X(4) * Y(3) - X(4) * YY +
     1       X(3) * YY - X(3) * Y(4)
      AT3 = XX * Y(2) - XX * Y(4) + X(2) * Y(4) - X(2) * YY +
     1       X(4) * YY - X(4) * Y(2)
      AT4 = XX * Y(1) - XX * Y(2) + X(1) * Y(2) - X(1) * YY +
     1       X(2) * YY - X(2) * Y(1)
      ATS = 0.5 * (ABS(AT1) + ABS(AT2) + ABS(AT3) + ABS(AT4))
      A = ATS / ABOX
C
C     IF SUM OF THE 4 TRIANGLES IS LARGER THAN THE BOX, THE POINT
C     IS OUTSIDE OF THE BOX.
      IF (A.GT.1.001) GO TO 20
      IO=.TRUE.
      RETURN
   20 IO=.FALSE.
      RETURN
      END
      SUBROUTINE MCALTB(IPIC,IERR)
C***********************************************************************
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:  MCALTB        GENERATES METEOSAT CALIBRATION TABLE
C   PRGMMR: JIE MENG         ORG: NMC23       DATE:93-08-30
C
C ABSTRACT: GENERATES METEOSAT CALIBRATION TABLE BY RETRIEVING THE
C   MIEC CALIBRATION COEFFICIENT AND SPACE COUNT AND USING CUBIC
C   SPLINE INTERPOLATION, GIVEN TEMPERATURE-RADIANCE CONVERSION TABLE.
C   THE TEMPERATURE/RADIANCE CONVERSION TABLE IS BASED ON THE SPECTRAL
C   REPONSE TABLE WITH PLANK FUNCTION WEIGHTED WITH THE FILTER FUNCTION
C   (90K) FOR THE METEOSAT-4.
C
C   THE MIEC(METEOROLOGICAL INFORMATION EXTRACTION CENTRE) ABSOLUTE
C   CALIBRATION METHOD IS BASED ON A COMPARISON OF METEOSAT SEA SURFACE
C   TEMPERATURE AND SST OBSERVATIONS FROM NMC.
C
C PROGRAM HISTORY LOG:
C   93-08-30  JIE MENG   BASED ON THE MCIDAS CALIBRATION ROUTINES.
C   95-01-30  RICHARD SCHREITZ  REVISED FOR USE WITH VERSION 10 OF
C                               THE GOES/METEOSAT IMAGER DATABASE
C                               LOCATOR/READER.
C   96-05-17  RICHARD SCHREITZ  SIMPLIFIED LOGIC.
C   05-02-18  RICHARD SCHREITZ  CHANGED NAME OF COMMON AREA 'CALTAB'
C                               TO 'CALTAB1' TO AVOID CONFLICT.
C                               PLACED ALL COMMON STATEMENTS IN
C                               AN 'INCLUDE' LIBRARY.
C   05-03-04 Brenda Hardie      Migrated source to AIX. 
C   05-03-09 Brenda Hardie      Substituted 'TRANSFER' function for
C                               Amdahl system subroutine 'XMOVEX'.
C
C USAGE:    CALL MCALTB(IPIC,IERR)
C
C   INPUT ARGUMENT LIST:
C     IPIC              PICTURE NUMBER
C
C   OUTPUT ARGUMENT LIST:
C     IERR              ERROR FLAG, = 1 IF CALIBRATION PARAMETERS = 0.
C
C   SUBPROGRAMS CALLED:
C     UNIQUE -   BINARY FVAL CSPLIN 
C     FUNCTION - TRANSFER
C     LIBRARY -
C       LOCATOR/READER: BRPK
C
C REMARKS: THE TEMPERATURE/RADIANCE TABLE USED HERE IS CONSISTANT WITH
C   THE TABLE IN THE "ANNEXE TO THE METEOSAT-4 CALIBRATION REPORT"
C   BY THE EUROPEAN SPACE OPERATIONS CENTER IN JULY 1989.
C   FOLLOW ANY UPDATE.
C
C   CURRENTLY, METEOSAT-3 DATA BASE IS INGESTED AND BUILT BY NESDIS,
C   WITH KDBASE=1.  CALIBRATION PARAMETERS ARE RETRIEVED FROM THE
C   INTERPRETATION BLOCK INCORPORATED IN THE NESDIS DATA BASE HEADER.
C   METEOSAT-4 DATA BASE IS BUILT BY NMC FROM MCIDAS FORMAT, WITH
C   KDBASE=2.  CALIBRATION PARAMETERS ARE RETRIEVED FROM THE MCIDAS
C   AREA DIRECTORY INCORPORATED IN THE NESDIS DATA BASE HEADER.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN
C   MACHINE:  AIX
C
C$$$
C     FUNCTION KBXCAL(CALB,IDIR,NVAL,IBAND,IBUF)
C
C COMMON AREA PARAMETERS:
C
      INCLUDE 'idoc.i'
      INCLUDE 'jdoc.i'
      INCLUDE 'kdbase.i'
      INCLUDE 'caltab1.i'
C                                                                      <
C
C***********************************************************************
      PARAMETER(IFPRNT=53)
      PARAMETER (NB=5,NUM=34)
      CHARACTER*4 CITYP,COTYP
      EQUIVALENCE (CITYP,IITYP)
      CHARACTER*2 CSATID,CYEAR,CDOY,CHRMN
      REAL*4 XTEMP(NUM),XRAD(NUM),COEF(4,NUM),XCAL(2),YCAL(2)
      INTEGER*2 LYEAR,LDOY,LHRMN
      INTEGER IDIR(64)
      INTEGER IRAD(NUM,8),GRYSCL
C
      DATA COTYP/'TEMP'/
C
C IBAND=8 FOR IR, 10 FOR WV, ELSE FOR VIS
C
      DATA IBAND /8/
      DATA YCAL/.04,.008/
C
C---RADIANCES VALUES FOR 165K TO 330K BY 5 DEGREES
C---  11 MU   FOLLOWED BY  6 MU (REPEAT FOR M3 SATELLITE)
C--- FOLLOWED BY M4
C
      DATA ITEMP/165/,INC/5/
C
C   RADIANCE IS IN WM(**-2)SR(**-1), TEMPERATURE IS IN K.
C
      DATA ((IRAD(I,J),I=1,NUM),J=1,4)/
     *0217,0271,0335,0409,0494,0591,0700,0823,0959,1111,1277,1459,
     *1658,1873,2106,2356,2623,2910,3214,3537,3879,4239,4619,5017,
     *5435,5872,6327,6802,7296,7808,8339,8889,9457,10043,
     *0012,0017,0025,0035,0049,0066,0089,0117,0153,0196,0250,0315,
     *0392,0484,0592,0719,0866,1035,1229,1450,1701,1983,2299,2651,
     *3043,3477,3954,4479,5052,5677,6357,7093,7889,8745,
     *0230,0287,0354,0432,0521,0622,0737,0865,1008,1167,1341,1531,
     *1739,1963,2206,2467,2746,3044,3362,3698,4054,4429,4825,5239,
     *5674,6128,6602,7096,7609,8141,8693,9264,9854,10463,
     *0014,0021,0030,0043,0059,0080,0107,0141,0183,0235,0298,0375,
     *0467,0575,0703,0852,1024,1223,1451,1709,2002,2331,2700,3111,
     *3567,4071,4626,5235,5900,6625,7411,8263,9183,10172/
      DATA ((IRAD(I,J),I=1,NUM),J=5,6)/
     *0300,0475,0587,0717,0867,1037,1230,1446,1687,1954,2248,2570,
     *2921,3302,3713,4155,4630,5136,5676,6248,6854,7494,8167,8875,
     *9616,10392,11201,12045,12922,13833,14777,15755,16765,17809,
     *0007,0015,0022,0031,0043,0060,0081,0107,0141,0183,0235,0299,
     *0375,0466,0574,0702,0850,1023,1221,1449,1707,2000,2330,2700,
     *3113,3571,4078,4636,5250,5921,6653,7448,8310,9241/
      DATA ((IRAD(I,J),I=1,NUM),J=7,8)/
     *0368,0478,0590,0721,0871,1042,1236,1453,1695,1963,2258,2582,
     *2934,3317,3730,4175,4651,5160,5702,6277,6886,7529,8206,8917,
     *9662,10441,11255,12103,12895,13900,14850,15853,16848,17897,
     *0010,0018,0026,0037,0052,0072,0098,0130,0172,0223,0286,0363,
     *0457,0568,0700,0856,1038,1248,1492,1770,2087,2447,2851,3305,
     *3812,4375,4999,5686,6441,7268,8169,9150,10212,11362/
C
      DATA IP2/88224/,NEWCAL/89128/
      DATA M3/Z0000D4F3/,M4/Z0000D4F4/,M5/Z0000D4F5/
      DATA ITYPE/-641604032/ IDIR/64*0/
C --- ITYPE: TYPE IN WHICH THE DIGITAL DATA ARE STORED. "RAW" HERE.
C
C METEOSAT 3 DATA BASE IS BUILT BY NESDIS. THE CALIBRATION PARAMETERS
C NEED TO BE EXTRACTED FROM THE HEADER RECORD.
      IERR = 0
C
        LDOY = NDAYOY(1,IPIC)
        LHRMN = NHOUR(1,IPIC) * 100 + NMIN(1,IPIC)
C        CALL XMOVEX(CSATID,IDOC1(3385,1,IPIC),2)
        CSATID=TRANSFER(IDOC1(3385,1,IPIC),CSATID)
        IF(CSATID .EQ. 'M3') THEN
          IDIR(21) = M3
        ELSE IF(CSATID .EQ. 'M4') THEN
          IDIR(21) = M4
        ELSE IF(CSATID .EQ. 'M5') THEN
          IDIR(21) = M5
        END IF
C       WRITE(IFPRNT,*)CSATID
      IF(KDBASE .EQ. 1) THEN
        IDIR(53) = ITYPE
C        CALL XMOVEX(LYEAR,IDOC1(3387,1,IPIC),2)
        LYEAR=TRANSFER(IDOC1(3387,1,IPIC),LYEAR) 
        JYEAR = LYEAR
C        CALL XMOVEX(LDOY,IDOC1(3389,1,IPIC),2)
        LDOY=TRANSFER(IDOC1(3389,1,IPIC),LDOY) 
C        CALL XMOVEX(LHRMN,IDOC1(3391,1,IPIC),2)
        LHRMN=TRANSFER(IDOC1(3391,1,IPIC),LHRMN)
        IDIR(4) = MOD(JYEAR,100) * 1000 + LDOY
CRS   THE FOLLOWING STATEMENT WAS CHANGED ON 98-10-21:
        IF (MOD(JYEAR,100) .NE. IYEAR2(NYEAR(1,IPIC)) .OR.
     1      LDOY           .NE. NDAYOY(1,IPIC))
     2    PRINT *, 'WRONG DATE TIME !!!',JYEAR,IYEAR2(NYEAR(1,IPIC)),
     3    LDOY,NDAYOY(1,IPIC)
        IREF = 3433
C ---   CONVERT MEIC ABSOLUTE CALIBRATION VALUE FROM ASCII TO BINARY
        CALL BINARY (IDOC1(IREF+51,1,IPIC),5,2,ICALIR)
        IDIR(22) = ICALIR
        CALIR = ICALIR/100000.0
C
C ---   RETRIEVE IR SPACE COUNT, CONVERTING ASCII TO BINARY
        CALL BINARY (IDOC1(IREF+56,1,IPIC),3,2,IRSPC)
        IDIR(23) = IRSPC
        RIRSPC = IRSPC/10.0
C
      ELSE IF(KDBASE .EQ. 2) THEN
        DO 20 I = 1, 64
          II = 711 + I - 1
          IDIR(I) = IDOC4(II,1,IPIC)
C         PRINT *,I,II,IDOC4(II,1,IPIC),IPIC
 20     CONTINUE
      END IF
      JTYPE=0
      IITYP = IDIR(53)
      IF(CITYP.EQ.'RAW '.AND.COTYP.EQ.'RAD ') JTYPE=1
      IF(CITYP.EQ.'RAW '.AND.COTYP.EQ.'TEMP') JTYPE=2
      IF(CITYP.EQ.'RAW '.AND.COTYP.EQ.'BRIT') JTYPE=3
C
      XCO=5.0
C     ICAL=0
C     IF(IBAND.EQ.8) ICAL=1
C     IF(IBAND.EQ.10) ICAL=2
      ICAL = 1
C
C---  IF NOT BAND 8 OR 10...MUST BE VISIBLE
C
C     IF(ICAL.EQ.0) GO TO 150
C
C---  WHICH SATELLITE?? P2 OPERATION 11 AUG 1988 (88224)
C
      IOFF=0
      IF(IDIR(4).GE.IP2) IOFF=2
C
C--- CHECK FOR NEWCAL
C
C     IF(IDIR(22) .EQ. 0.0 .OR. IDIR(23) .EQ. 0.0)THEN
      IF(IDIR(22) .EQ. 0.0) THEN
        PRINT *,' WRONG !!, CALIBRATION COEF  ',IDIR(22),' ',IDIR(23)
        IERR = 1
        GO TO 900
      END IF
      IF(IDIR(4).GE.NEWCAL) THEN
        B=IDIR(22)/100000.
        XCO=IDIR(23)/10.
        IF(IDIR(21).EQ.M3) IOFF=2
        IF(IDIR(21).EQ.M4) IOFF=4
        IF(IDIR(21).EQ.M5) IOFF=6
      ELSE IF(IDIR(21).EQ.0) THEN
        A=YCAL(ICAL)
        B=1.0
        B=B*A
      ELSE
        BBC=IDIR(21)/100.
        XCAL(1)=IDIR(22)/1000000.
        XCAL(2)=IDIR(23)/1000000.
        IF(IDIR(23).LT.5000) XCAL(2)=IDIR(23)/100000.
        B=121./BBC
        A=XCAL(ICAL)
        B=B*A
      ENDIF
      WRITE(IFPRNT,2100) B,XCO
C
C---CALCULATE RADIANCE VALUES FROM RAW
C
      DO 30 I=0,255
        E=B*(I-XCO)
        IE=MAX0(0,NINT(E*1000.))
        ITABLE(I+1)=IE
30    CONTINUE
      IF(JTYPE.EQ.1) GO TO 150
C
C---CONVERT RADIANCE VALUES TO TEMPERATURE
C
      DO 40 I=1,NUM
        XTEMP(I)=10.*(ITEMP+(I-1)*INC)
        XRAD(I)=IRAD(I,ICAL+IOFF)
40    CONTINUE
      CALL CSPLIN(NUM,XRAD,XTEMP,COEF)
      DO 60 I=1,256
        ITABLE(I)=NINT(FVAL(NUM,REAL(ITABLE(I)),XRAD,COEF))
60    CONTINUE
C
C     IF(JTYPE.EQ.2) GO TO 150
C
150   CONTINUE
      KBXCAL=0
 2100 FORMAT (' CALIBRATION COEF.= ',F8.4,'   SPACE COUNTS = ',F8.4)
  900 CONTINUE
      RETURN
      END
      SUBROUTINE MNFRAME(ITIME,IHM,IDOW,IO_MAIN,IMGDAT,ICNCVG,ISLON,
     1             IDATA,NLON,NLAT,NCLASS)
C*********************************************************************
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:  MNFRAME     WRITES DATA TO WEEKLY ROTATING FILE
C   PRGMMR: JOHN JANOWIAK ORG:NCEP/CPC      DATE:96-06-26
C
C ABSTRACT: WRITES DATA TO WEEKLY ROTATING FILE
C
C PROGRAM HISTORY LOG:
C   96-06-26  JOHN JANOWIAK
C   05-03-08  Brenda Hardie     Migrated code to AIX.
C   05-05-25  Brenda Hardie     Added array INITDATA to zero 19995 bytes
C                               of header records and added INITDATA to
C                               first "WRITE" statement.
C
C USAGE     CALL MNFRAME(ITIME,IHM,IDOW,IO_MAIN,IMGDAT,ISUBST,
C                        IDATA,NLON,NLAT,NCLASS)
C     ITIME   - 1-8, WHERE 1=00Z, 2=03Z, ..., 8=21Z
C     IHM     - HOUR & MINUTE OF IMAGE
C     IDOW    - DAY OF WEEK
C     IO_MAIN - FORTRAN DATA SET REF. NUMBER ASSIGNED TO OUTPUT FILE
C
C     IMGDAT   - YEAR,MONTH, DAY
C     CENCVG  - SUB-SATELLITE POINT
C     IDATA   - ARRAY OF OUTPUT DATA
C     NLON    - # LONGITUDES IN IDATA ARRAY
C     NLAT    - # LATITUDES IN IDATA ARRAY
C     NCLASS  - # HISTOGRAM CLASSES IN IDATA ARRAY
C
C
C   OUTPUT ARGUMENT LIST:
C     NONE
C
C   SUBPROGRAMS CALLED:
C     LIBRARY -
C       NONE CALLED
C ATTRIBUTES:
C   LANGUAGE: FORTRAN-VS
C   MACHINE:  HDS 9000
C
C$$$
C
C        WRITES OUT DATA TO 1-WEEK ROTATING FILE.  EACH IMAGE OCCUPIES
C        27 RECORDS:  REC 1 = DATE, SAT NAME & CENCVG POINT
C                     REC 2 - 25 = 24 HISTOGRAM CLASSES
C                     REC 26 = MEAN TEMPERATURE
C                     REC 27 = SPATIAL STD DEVIATION
C
C******************************************************
C
C
      INTEGER*2 IDATA(NLON,NLAT,NCLASS+2)
      INTEGER*4 INITDATA(4995)   !initialize remainder of record to
C                                 zeroes
C
C
      IOFFST=(IDOW-1)*8*27
      IREC=IOFFST+(ITIME-1)*27 + 1
      JTIME=(ITIME-1)*3
      WRITE(IO_MAIN,REC=IREC) IMGDAT,IHM,JTIME,ICNCVG,ISLON,INITDATA
      WRITE(53,*) 'IREC,IMGDAT,IHM,ICNCVG,ISLON:',IREC,IMGDAT,IHM,
     1                ICNCVG,ISLON
      DO K=1,NCLASS+2
      IREC=IOFFST+(ITIME-1)*27 + 1 + K
      WRITE(IO_MAIN,REC=IREC) ((IDATA(I,J,K),I=1,NLON),J=1,NLAT)
      ENDDO
C
      RETURN
      END
      SUBROUTINE OPENALL(RETCOD)
C***********************************************************************
C$$$  SUBPROGRAM DOCUMENTATION BLOCK                                            
C                .      .    .                                       .          
C SUBPROGRAM:  OPENALL       OPENS ALL REQUIRED FILES
C   PRGMMR: RICHARD SCHREITZ ORG: E/SP22       DATE: 06-05-17
C                                                                               
C ABSTRACT: OPENS ALL FILES REQUIRED BY PROGRAM
C                                                                               
C PROGRAM HISTORY LOG:
C
C 2005-04-13  Brenda Hardie     Replaced unformatted sequential write
C                               statements with unformatted direct write        
C                               statements for the temporary files ft61,        
C                               ft62, ft63, ft64. (IOTMP_1 - IOTMP_4).          
C                               Commented rewind of temporary files.            
C 2005-05-31  Brenda Hardie     Added error checking for "WRITE" to             
C                               IOTMP_1 - IOTMP_4 (ft61 - ft64).                
C                               Removed "rewind" of IO_TEMP (ft61-ft64)         
C                               for ftp of temporary files (ft61-ft64).
C 2006-05-17  RICHARD SCHREITZ  THIS SUBPROGRAM PERFORMS A SET OF
C                               FUNCTIONS PREVIOUSLY PERFORMED IN
C                               IN THE MAIN PROGRAM USING ESSENTIALLY
C                               THE SAME INSTRUCTIONS, RECONFIGURED TO
C                               CONFORM TO A NEW TEMPLATE FOR LOGICAL
C                               AND PHYSICAL COMPACTNESS.
C                               THE SUBPROGRAM PROCESSES FOUR
C                               ADDITIONAL FILES.
C
C USAGE:    CALL OPENALL(RETCOD)
C                                                                               
C   ARGUMENT LIST:
C     RETCOD            RETURN CODE
C                       INTEGER*4 RETCOD
C
C   INPUT FILES:
C     IFRNID FT10 RUN ID (E. G. 00Z WEST)
C     IFINPT FT11 SELECTED TIME INTERVAL, SUBSATELLITE POINT, ETC.
C     IFPCRD FT12 IMAGE REQUEST CARD
C     IFPCR2 FT14 IMAGE REQUEST CARD
C
C   OUTPUT FILES:
C     IFPRNT FT53 PRINTOUT (FT06 IS USED IN LOCATOR/READER)
C     IOMAIN FT58 WEEKLY ROTATING OUTPUT FILE
C     IOTMP1 FT61 TEMPORARY OUTPUT FILE FOR DDS (1ST SELECTED IMAGE)
C     IOTMP2 FT62 TEMPORARY OUTPUT FILE FOR DDS (2ND SELECTED IMAGE)
C     IOTMP3 FT63 TEMPORARY OUTPUT FILE FOR DDS (3RD SELECTED IMAGE)
C     IOTMP4 FT64 TEMPORARY OUTPUT FILE FOR DDS (4TH SELECTED IMAGE)
C     IOT1FN FT71 FINAL NAME FOR 1ST TEMPORARY OUTPUT FILE
C     IOT2FN FT72 FINAL NAME FOR 2ND TEMPORARY OUTPUT FILE
C     IOT3FN FT73 FINAL NAME FOR 3RD TEMPORARY OUTPUT FILE
C     IOT4FN FT74 FINAL NAME FOR 4TH TEMPORARY OUTPUT FILE
C
C    (IFPINF FT16 ORBIT AND ATTITUDE INFORMATION AND PICTURE
C                 CENTERING INFORMATION (WRITTEN BY GOES DATABASE
C                 LOCATOR/READER  - NORMALLY DUMMIED OUT,
C                 OCCASIONALLY USEFUL IN PROBLEM ANALYSIS))
C
C ATTRIBUTES:                                                                   
C   LANGUAGE: IBM VS FORTRAN (FORTRAN 77)                                       
C   MACHINE:  HDS 9000                                                          
C$$$                                                                            
C                                                                               
C COMMON AREA PARAMETERS:                                                       
C                                                                               
      INCLUDE 'ifiles.i'
C                                                                               
C LOCAL PARAMETERS:                                                             
C                                                                               
      CHARACTER*1023 fileName                                                   
      CHARACTER*6 IFRNID_DDNAME/'IFRNID'/                                      
      CHARACTER*6 IFINPT_DDNAME/'IFINPT'/                                      
      CHARACTER*6 IFPCRD_DDNAME/'IFPCRD'/                                      
      CHARACTER*6 IFPCR2_DDNAME/'IFPCR2'/
      CHARACTER*6 IFPRNT_DDNAME/'IFPRNT'/
      CHARACTER*6 IOMAIN_DDNAME/'IOMAIN'/                                      
      CHARACTER*6 IOTMP1_DDNAME/'IOTMP1'/
      CHARACTER*6 IOTMP2_DDNAME/'IOTMP2'/                                      
      CHARACTER*6 IOTMP3_DDNAME/'IOTMP3'/                                      
      CHARACTER*6 IOTMP4_DDNAME/'IOTMP4'/
      CHARACTER*6 IOT1FN_DDNAME/'IOT1FN'/
      CHARACTER*6 IOT2FN_DDNAME/'IOT2FN'/
      CHARACTER*6 IOT3FN_DDNAME/'IOT3FN'/
      CHARACTER*6 IOT4FN_DDNAME/'IOT4FN'/

      INTEGER*4   ERRCOD,IOERR
C
C***********************************************************************
C
      IFRNID=10
      IFINPT=11
      IFPCRD=12
      IFPCR2=14
      IFPRNT=53
      IOMAIN=58
      IOTMP1=61
      IOTMP2=62
      IOTMP3=63
      IOTMP4=64
      IOT1FN=71
      IOT2FN=72
      IOT3FN=73
      IOT4FN=74
C
C     THE PRINT FILE IS OPENED FIRST TO ALLOW PRINTING OF SUBSEQUENT            
C     ERROR MESSAGES.                                                           
C                                                                               
C ---
      CALL getFileName(IFPRNT_DDNAME, fileName, ERRCOD)
      IF (ERRCOD .LT. 0) THEN                                                   
          RETCOD = -1
          WRITE(6,*) 'ERROR GETTING PROCESSING RESULTS FILE NAME'
          WRITE(6,*) 'ERRCOD=',ERRCOD
          GO TO 990
      END IF                                                                    
      OPEN(UNIT=IFPRNT,FILE=fileName,IOSTAT=IOERR,ACCESS='SEQUENTIAL',          
     1 STATUS='UNKNOWN', ACTION='WRITE')                                        
      IF (IOERR .NE. 0) THEN                                                    
          RETCOD = -2
          WRITE(6,*) 'ERROR OPENING PROCESSING RESULTS FILE'
          WRITE(6,*) 'IOSTAT=',IOERR
          GO TO 990
      END IF                                                                    
C ---                                                                           
      CALL getFileName(IFRNID_DDNAME, fileName, ERRCOD)                         
      IF (ERRCOD .LT. 0) THEN                                                   
          RETCOD = -3
          WRITE(IFPRNT,*) 'ERROR GETTING RUN ID FILE NAME'
          WRITE(IFPRNT,*) 'ERRCOD=',ERRCOD
          GO TO 990                                                             
      END IF                                                                    
      OPEN(UNIT=IFRNID,FILE=fileName,IOSTAT=IOERR,ACCESS='SEQUENTIAL',          
     1 STATUS='UNKNOWN', ACTION='READWRITE')                                    
      IF (IOERR .NE. 0) THEN                                                    
          RETCOD = -4
          WRITE(IFPRNT,*) 'ERROR OPENING SATELLITE POSITION FILE'
          WRITE(IFPRNT,*) 'IOSTAT=',IOERR
          GO TO 990                                                             
      END IF                                                                    
C ---                                                                           
      CALL getFileName(IFINPT_DDNAME, fileName, ERRCOD)                         
      IF (ERRCOD .LT. 0) THEN                                                   
          RETCOD = -5
          WRITE(IFPRNT,*) 'ERROR GETTING RUN SUMMARY FILE NAME'
          WRITE(IFPRNT,*) 'ERRCOD=',ERRCOD
          GO TO 990                                                             
      END IF                                                                    
      OPEN(UNIT=IFINPT,FILE=fileName,IOSTAT=IOERR,ACCESS='SEQUENTIAL',          
     1 STATUS='OLD', ACTION='READ')                                             
      IF (IOERR .NE. 0) THEN                                                    
          RETCOD = -6
          WRITE(IFPRNT,*) 'ERROR OPENING RUN SUMMARY FILE'
          WRITE(IFPRNT,*) 'IOSTAT=',IOERR
          GO TO 990                                                             
      END IF                                                                    
C ---                                                                           
      CALL getFileName(IFPCRD_DDNAME, fileName, ERRCOD)                         
      IF (ERRCOD .LT. 0) THEN                                                   
          RETCOD = -7
          WRITE(IFPRNT,*) 'ERROR GETTING REQUEST CARD1 INFORMATION NAME'
          WRITE(IFPRNT,*) 'ERRCOD=',ERRCOD
          GO TO 990                                                             
      END IF                                                                    
      OPEN(UNIT=IFPCRD,FILE=fileName,IOSTAT=IOERR,ACCESS='SEQUENTIAL',          
     1 STATUS='OLD', ACTION='READ')                                             
      IF (IOERR .NE. 0) THEN                                                    
          RETCOD = -8
          WRITE(IFPRNT,*) 'ERROR OPENING REQUEST CARD1 INFORMATION FILE'
          WRITE(IFPRNT,*) 'IOSTAT=',IOERR
          GO TO 990                                                             
      END IF
C ---                                                                           
      CALL getFileName(IFPCR2_DDNAME, fileName, ERRCOD)                         
      IF (ERRCOD .LT. 0) THEN                                                   
          RETCOD = -9
          WRITE(IFPRNT,*) 'ERROR GETTING REQUEST CARD2 INFORMATION NAME'
          WRITE(IFPRNT,*) 'ERRCOD=',ERRCOD
          GO TO 990                                                             
      END IF                                                                    
      OPEN(UNIT=IFPCR2,FILE=fileName,IOSTAT=IOERR,ACCESS='SEQUENTIAL',          
     1 STATUS='UNKNOWN', ACTION='READWRITE')                                    
      IF ( IOERR .NE. 0) THEN                                                   
          RETCOD = -10
          WRITE(IFPRNT,*) 'ERROR OPENING REQUEST CARD2 INFORMATION FILE'
          WRITE(IFPRNT,*) 'IOSTAT=',IOERR
          GO TO 990                                                             
      END IF                                                                    
C ---                                                                           
      CALL getFileName(IOMAIN_DDNAME, fileName, ERRCOD)                         
      IF (ERRCOD .LT. 0) THEN                                                   
          RETCOD = -11
          WRITE(IFPRNT,*) 'ERROR GETTING sEVEN-DAY OUTPUT FILE NAME'
          WRITE(IFPRNT,*) 'ERRCOD=',ERRCOD
          GO TO 990                                                             
      END IF                                                                    
      OPEN (UNIT=IOMAIN,FILE=fileName,STATUS='OLD',FORM='UNFORMATTED',
     1     RECL=20000,ACCESS='DIRECT',ACTION='READWRITE',IOSTAT=IOERR)          
      IF (IOERR .NE. 0) THEN                                                    
          RETCOD = -12
          WRITE(IFPRNT,*) 'ERROR OPENING SEVEN-DAY OUTPUT FILE'
          PRINT *,'IOSTAT=',IOERR
          GO TO 990                                                             
      END IF                                                                    
C ---                                                                           
      CALL getFileName(IOTMP1_DDNAME, fileName, ERRCOD)                         
      IF (ERRCOD .LT. 0) THEN                                                   
          RETCOD = -13
          WRITE(IFPRNT,*) 'ERROR GETTING FIRST IMAGE FILE NAME'
          WRITE(IFPRNT,*) 'ERRCOD=',ERRCOD
          GO TO 990                                                             
      END IF                                                                    
      OPEN(UNIT=IOTMP1,FILE=fileName,IOSTAT=IOERR,ACCESS='DIRECT',
     1  FORM='UNFORMATTED',STATUS='UNKNOWN',RECL=520016)                        
      IF (IOERR .NE. 0) THEN                                                    
          RETCOD = -14
          WRITE(IFPRNT,*) 'ERROR OPENING FIRST IMAGE FILE'
          WRITE(IFPRNT,*) 'IOSTAT=',IOERR
          GO TO 990                                                             
      END IF                                                                    
C ---                                                                           
      CALL getFileName(IOTMP2_DDNAME, fileName, ERRCOD)                         
      IF (ERRCOD .LT. 0) THEN                                                   
          RETCOD = -15
          WRITE(IFPRNT,*) 'ERROR GETTING SECOND IMAGE FILE NAME'
          WRITE(IFPRNT,*) 'ERRCOD=',ERRCOD
          GO TO 990                                                             
      END IF                                                                    
      OPEN(UNIT=IOTMP2,FILE=fileName,IOSTAT=IOERR,ACCESS='DIRECT',
     1 FORM='UNFORMATTED',STATUS='UNKNOWN',RECL=520016)                         
      IF (IOERR .NE. 0) THEN                                                    
          RETCOD = -16
          WRITE(IFPRNT,*) 'ERROR OPENING SECOND IMAGE FILE'
          WRITE(IFPRNT,*) 'IOSTAT=',IOERR
          GO TO 990                                                             
      END IF                                                                    
C ---                                                                           
      CALL getFileName(IOTMP3_DDNAME, fileName, ERRCOD)                         
      IF (ERRCOD .LT. 0) THEN                                                   
          RETCOD = -17
          WRITE(IFPRNT,*) 'ERROR GETTING THIRD IMAGE FILE NAME'
          WRITE(IFPRNT,*) 'ERRCOD=',ERRCOD
          GO TO 990                                                             
      END IF                                                                    
      OPEN(UNIT=IOTMP3,FILE=fileName,IOSTAT=IOERR,ACCESS='DIRECT',
     1 FORM='UNFORMATTED',STATUS='UNKNOWN',RECL=520016)                         
      IF (IOERR .NE. 0) THEN                                                    
          RETCOD = -18
          WRITE(IFPRNT,*) 'ERROR OPENING THIRD IMAGE FILE'
          WRITE(IFPRNT,*) 'IOSTAT=',IOERR
          GO TO 990                                                             
      END IF                                                                    
C ---                                                                           
      CALL getFileName(IOTMP4_DDNAME, fileName, ERRCOD)                         
      IF (ERRCOD .LT. 0) THEN                                                   
          RETCOD = -19
          WRITE(IFPRNT,*) 'ERROR GETTING FOURTH IMAGE FILE NAME'
          WRITE(IFPRNT,*) 'ERRCOD=',ERRCOD
          GO TO 990                                                             
      END IF                                                                    
      OPEN(UNIT=IOTMP4,FILE=fileName,IOSTAT=IOERR,ACCESS='DIRECT',
     1 FORM='UNFORMATTED',STATUS='UNKNOWN',RECL=520016)                         
      IF (IOERR .NE. 0) THEN                                                    
          RETCOD = -20
          WRITE(IFPRNT,*) 'ERROR OPENING FOURTH IMAGE FILE'
          WRITE(IFPRNT,*) 'IOSTAT=',IOERR
          GO TO 990                                                             
      END IF                                                                    
C ---
      CALL getFileName(IOT1FN_DDNAME, fileName, ERRCOD)
      IF (ERRCOD .LT. 0) THEN                                                   
          RETCOD = -21
          WRITE(IFPRNT,*) 'ERROR GETTING FILE NAME FOR IMAGE 1 LABEL'
          WRITE(IFPRNT,*) 'ERRCOD=',ERRCOD
          GO TO 990                                                             
      END IF                                                                    
      OPEN(UNIT=IOT1FN,FILE=fileName,IOSTAT=IOERR,
     1 ACCESS='SEQUENTIAL',STATUS='UNKNOWN', ACTION='WRITE')
      IF (IOERR .NE. 0) THEN                                                    
          RETCOD = -22
          WRITE(IFPRNT,*) 'ERROR OPENING FILE FOR IMAGE 1 LABEL'
          WRITE(IFPRNT,*) 'IOSTAT=',IOERR
          GO TO 990
      END IF                                                                    
C ---                                                                           
      CALL getFileName(IOT2FN_DDNAME, fileName, ERRCOD)
      IF (ERRCOD .LT. 0) THEN                                                   
          RETCOD = -23
          WRITE(IFPRNT,*) 'ERROR GETTING FILE NAME FOR IMAGE 2 LABEL'
          WRITE(IFPRNT,*) 'ERRCOD=',ERRCOD
          GO TO 990                                                             
      END IF                                                                    
      OPEN(UNIT=IOT2FN,FILE=fileName,IOSTAT=IOERR,
     1 ACCESS='SEQUENTIAL',STATUS='UNKNOWN', ACTION='WRITE')
      IF (IOERR .NE. 0) THEN                                                    
          RETCOD = -24
          WRITE(IFPRNT,*) 'IOSTAT=',IOERR
          WRITE(IFPRNT,*) 'ERROR OPENING FILE FOR IMAGE 2 LABEL'
          GO TO 990                                                             
      END IF                                                                    
C ---                                                                           
      CALL getFileName(IOT3FN_DDNAME, fileName, ERRCOD)
      IF (ERRCOD .LT. 0) THEN                                                   
          RETCOD = -25
          WRITE(IFPRNT,*) 'ERRCOD=',ERRCOD
          WRITE(IFPRNT,*) 'ERROR GETTING FILE NAME FOR IMAGE 3 LABEL'
          GO TO 990                                                             
      END IF                                                                    
      OPEN(UNIT=IOT3FN,FILE=fileName,IOSTAT=IOERR,
     1 ACCESS='SEQUENTIAL',STATUS='UNKNOWN', ACTION='WRITE')
      IF (IOERR .NE. 0) THEN                                                    
          RETCOD = -26
          WRITE(IFPRNT,*) 'IOSTAT=',IOERR
          WRITE(IFPRNT,*) 'ERROR OPENING FILE FOR IMAGE 3 LABEL'
          GO TO 990                                                             
      END IF                                                                    
C ---                                                                           
      CALL getFileName(IOT4FN_DDNAME, fileName, ERRCOD)
      IF (ERRCOD .LT. 0) THEN                                                   
          RETCOD = -27
          WRITE(IFPRNT,*) 'ERRCOD=',ERRCOD
          WRITE(IFPRNT,*) 'ERROR GETTING FILE NAME FOR IMAGE 4 LABEL'
          GO TO 990                                                             
      END IF                                                                    
      OPEN(UNIT=IOT4FN,FILE=fileName,IOSTAT=IOERR,
     1 ACCESS='SEQUENTIAL',STATUS='UNKNOWN', ACTION='WRITE')
      IF (IOERR .NE. 0) THEN                                                    
          RETCOD = -28
          WRITE(IFPRNT,*) 'IOSTAT=',IOERR
          WRITE(IFPRNT,*) 'ERROR OPENING FILE FOR IMAGE 4 LABEL'
          GO TO 990                                                             
      END IF
C ---
C
  990 RETURN
C                                                                               
      END                                                                       
      SUBROUTINE READID(SATNAM,LSATNAM,CENCVG,ITIME1,ITIME2,JTIME,
     +                  KPOS,KSAT,IOS)
C***********************************************************************
C$$$  SUBPROGRAM DOCUMENTATION BLOCK                                            
C                .      .    .                                       .          
C SUBPROGRAM:  READID        PICTURE REQUEST CARD READER                        
C   PRGMMR: JIE MENG         ORG: W/NMC23      DATE: 93-12-05                   
C                                                                               
C ABSTRACT: READS PICTURE REQUEST CARDS                                         
C                                                                               
C PROGRAM HISTORY LOG:                                                          
C   93-12-05  JIE MENG                                                          
C   95-02-02  RICHARD SCHREITZ  MODIFIED OPTIMIZATION                           
C   96-05-17  RICHARD SCHREITZ  MODIFIED FOR GOES-9 AND GOES-10                 
C   05-02-18  RICHARD SCHREITZ  PLACED ALL COMMON STATEMENTS IN                 
C                               AN 'INCLUDE' LIBRARY.                           
C   05-03-08  BRENDA HARDIE     PORTED CODE TO AIX.                             
C   06-03-27  RICHARD SCHREITZ  MODIFIED FOR USE WITH A GENERIC SCRIPT
C                               (00Z/12Z, EAST/WEST) AND V 15.04 OF
C                               THE LOCATOR/READER.              
C                                                                               
C USAGE:    CALL READID(SATNAM,CENCVG,ITIME1,ITIME2,JTIME,IOS)                  
C                                                                               
C   ARGUMENT LIST:                                                              
C     SATNAM  C*11 -O-  SATELLITE NAME                                          
C                       'GOES-7      ', . . . , 'METEOSAT-3  ', . . . .         
                        CHARACTER*11 SATNAM
C     LSATNAM I*4  -O-  LENGTH OF SATELLITE NAME
C     CENCVG  R*4  -O-  CENTRAL LONGITUDE OF SATELLITE VIEW                     
C     ITIME1  I*4  -O-                                                          
C     ITIME2  I*4  -O-                                                          
C     JTIME   I*4  -O-  IMAGE REQUEST TIMES                                     
                        INTEGER*4 JTIME(8)                                      
C     KPOS    I*4  -O-  SATELLITE POSITION INDEX IN ARRAY POS
C     KSAT    I*4  -O-  SATELLITE INDEX IN ARRAY SAT
C     IOS     I*4  -O-  READ STATUS
C                                                                               
C   INPUT FILES:                                                                
C     IFPCRD  - PICTURE REQUEST CARDS                                           
C               W0000ZI8,W0030ZI8,W0100ZI8,W0130ZI8,W0200ZI8,W0230ZI8           
C               SEE LOCATOR/READER USER'S GUIDE FOR EXPLANATION OF              
C               FORMAT                                                          
C               USE W FOR WEST, E FOR EAST, . . . .                             
C               USE I8 FOR GOES-7                                               
C               USE I4 FOR GOES-8 THROUGH GOES-10                               
C               USE I2 FOR METEOSAT                                             
C ATTRIBUTES:                                                                   
C   LANGUAGE: IBM VS FORTRAN (FORTRAN 77)                                       
C   MACHINE:  HDS 9000                                                          
C$$$                                                                            
C                                                                               
C COMMON AREA PARAMETERS:                                                       
C
      INCLUDE 'vsfio.i'
      INCLUDE 'pos.i'                                                           
      INCLUDE 'sat.i'
      INCLUDE 'moff.i'
      INCLUDE 'kdbase.i'                                                        
      INCLUDE 'inputf.i'
      INCLUDE 'lztime.i'                                                        
C                                                                               
C LOCAL PARAMETERS:
C
C     SP      C*1       SATELLITE POSITION (FROM COMMAND LINE)
C                       'W', 'E', . . . .                                       
                        CHARACTER*1 SP
C     SATID   C*1       SATELLITE POSITION (FROM INPUT REQUEST)                
C                       'W', 'E', . . . .                                       
                        CHARACTER*1 SATID                                       
C     SATCOD  C*4       SATELLITE CODE                                          
C                       'G07 ', . . . , 'M03 ', . . . .                         
                        CHARACTER*4 SATCOD                                      
C     IETDMX  I*4       MAXIMUM ALLOWABLE ELAPSED TIME IN DAYS                  
C                                                                               
C***********************************************************************        
      PARAMETER(NCARD=8)                                                        
      PARAMETER(IFPRNT=53)
      PARAMETER(IFRNID=10,IFINPT=11,IFPCRD=12)
      CHARACTER*9 PICIDR(8)
      CHARACTER*4 CTIME                                                         
C                                                                               
      READ (IFRNID,'(4X,A1)') SP
C                                                                               
C READ SATELLITE ASSIGNMENT TABLE. (FILL COMMON AREA POS.)
C
      KUN=80
      OPEN (UNIT=KUN,IOSTAT=IOS,STATUS='OLD',ACTION='READ')
      CALL ZRSCT
      READ(IFINPT,1100,IOSTAT=IOS) ITIME1,ITIME2,                               
     1           CENCVG,IETDMX                                                  
      IF(IOS .NE. 0)THEN                                                        
        WRITE(IFPRNT,*)'READ ERROR IN INPUT CARD'                               
        GO TO 900                                                               
      END IF                                                                    
      WRITE(IFPRNT,1100) ITIME1,ITIME2,                                         
     1           CENCVG,IETDMX                                                  
C
C     TO ALLOW RETRIEVAL OF FRAMES MORE THAN ONE DAY OLD, IETDMX CAN BE
C     SET TO A VALUE GREATER THAN ONE . . .
      KETDMX = IETDMX
      IF(KETDMX .LT. 1) KETDMX = 1
C
C     OR THE 'READ SYSTEM CLOCK' FLAG CAN BE SET TO ZERO AND VALUES
C     INSERTED FOR THE TIME IN THE COMMON ARRAY LZTIME.
      KRSCF = 1
      KZYYYY = 2006
      KZDDD = 219 
      KZHH = 12
      IMM = 0
      ISS = 0
C
      ALON1 = CENCVG - 50.                                                      
      ALON2 = CENCVG + 50.                                                      
      IF(ALON1 .GT. 180.) ALON1 = ALON1 - 360.                                  
      IF(ALON2 .GT. 180.) ALON2 = ALON2 - 360.                                  
C                                                                               
      JTIME1=(ITIME1-1)*3                                                       
      JTIME2=(ITIME2-1)*3                                                       
C                                                                               
C RETRIEVE 8 POTENTIALLY GOOD PICTURES (EVERY 3-HR PERIOD) TO BE USED.
C                                                                               
      DO 120 IMGCRD = 1, 8                                                      
        IF(IMGCRD .LT. ITIME1 .OR. IMGCRD .GT. ITIME2) THEN                     
          READ(IFPCRD,*)                                                        
          GO TO 120                                                             
        END IF                                                                  
        READ(IFPCRD,1110,IOSTAT=IOS)(PICIDR(I),I=1, 6)                          
        IF(IOS .NE. 0)THEN                                                      
          WRITE(IFPRNT,*)'READ ERROR IN PICTURE REQUEST CARD',IFPCRD            
          GO TO 900                                                             
        END IF                                                                  
        WRITE(IFPRNT,1120)(PICIDR(I),I=1,6)                                     
          CTIME = PICIDR(1)(2:5)                                                
          READ(CTIME,FMT=1130)JHHMM                                             
          JTIME(IMGCRD) = JHHMM                                                 
        IF(IMGCRD .EQ. ITIME1)THEN                                              
C                                                                               
C TEST FOR MATCH BETWEEN COMMAND LINE SAT ID AND REQUESTED SAT ID.
C                                                                               
          SATID = PICIDR(1)(1:1)
          IF (SP .NE. SATID) THEN
          WRITE(IFPRNT,'(2X,A1)') SP,SATID
          CALL exit_(-30)
          END IF
C                                                                               
C FIND FULL SATELLITE NAME AND LENGTH OF FULL SATELLITE NAME.
C
          DO 20 KP = 1,10
          IF (SATID.EQ.POS(KP)(1:1)) THEN
          SATCOD = POS(KP)(39:42)
          KPOS = KP
          DO 10 KS = 1,16
          IF (SATCOD.EQ.SAT(KS)(01:04)) THEN
          SATNAM  = SAT(KS)(05:15)
          LSATNAM = ISATFP(2,KS) - ISATFP(1,KS) + 1
          KSAT = KS
          GO TO 40                                                              
          END IF                                                                
   10     CONTINUE                                                              
          END IF                                                                
   20     CONTINUE                                                              
C                                                                               
   40     CONTINUE                                                              
C                                                                               
          IF (SATNAM(1:4).EQ.'GOES')                      MOFF =  0             
          IF (SATNAM(1:8).EQ.'METEOSAT'.AND.SATID.EQ.'-') MOFF = 30             
          IF (SATNAM(1:8).EQ.'METEOSAT'.AND.SATID.EQ.'-') MOFF =  0             
C                                                                               
        END IF                                                                  
  120 CONTINUE                                                                  
      REWIND IFPCRD                                                             
      PRINT 1140,SATNAM,JTIME1,JTIME2
      WRITE(IFPRNT,1150)SATNAM,CENCVG,ALON1,ALON2,KETDMX                        
  900 RETURN                                                                    
 1100 FORMAT(2I2,1X,F6.1,1X,I4)                                                 
 1110 FORMAT(6(A8,1X))                                                          
 1120 FORMAT(' ',6(A8,1X))                                                      
 1130 FORMAT(I4)                                                                
 1140 FORMAT(' THIS RUN PROCESSES ',A4,' IMAGES BETWEEN ',I4,                   
     1       'Z AND ',I4,'Z'//)                                                 
 1150 FORMAT(' SAT: ',A12,2X,'CENCVG: ',F5.1,                                   
     1        2X,'FROM ',F6.1,' TO ',F6.1,2X,' KETDMX= ',I3)
 3910 FORMAT(' CONFLICT BETWEEN COMMAND LINE SATELLITE ID (',A1,')'/,
     1       ' AND REQUESTED SATELLITE ID (',A1,')')
      END                                                                       
      SUBROUTINE SHOWBOX (PICDAT,M,N)
C***********************************************************************00010000
C                                                                       00020000
C   NAME-                                                               00030000
C                                                                       00040000
C   LANGUAGE- VS FORT     TYPE- SUBROUTINE                              00050000
C                                                                       00060000
C   VERSION-  0.00  DATE- 02/18/05  PROGRAMMER- SCHREITZ, R.  EC1300    00070002
C             1.0   DATE- 05-03-08  Brenda Hardie 
C                                   Migrated to AIX.   
C                                                                       00090000
C   FUNCTION-                                                           00100000
C                                                                       00110000
C     WRITES PICDATX, A 130 X 80 ARRAY ENCLOSING A 1 DEG BY 1 DEG
C     BOX IN THE SATELLITE IMAGERY.  THE DIMENSIONS M (M <= 130) AND
C     N (N <= 80) ARE THE DIMENSIONS OF A PICDAT, AN ARRAY OF SMALLER
C     OR EQUAL SIZE WHICH ALSO CONTAINS THE BOX.  THE BOX WILL VERY
C     CLOSELY RESEMBLE A PARALLELOGRAM.
C                                                                       00120000
C   CALLING SEQUENCE PARAMETERS-                                        00130000
C                                                                       00140000
C     PICDAT            SEE FUNCTION
                        INTEGER*2 PICDAT(M,N)
C     M                 SEE FUNCTION
C     N                 SEE FUNCTION
C                                                                       00180000
C   KEY LOCAL PARAMETERS-                                               00190000
C                                                                       00200000
C     PICDATX           SEE FUNCTION
                        INTEGER*4 PICDATX(130,80)
C     ISAMP             SAMPLE INDEX
C     ILINE             LINE INDEX
C                                                                       00210000
C***********************************************************************00220000
C
      DO ILINE = 1,80
      DO ISAMP = 1,130
      PICDATX(ISAMP,ILINE) = 0
      END DO
      END DO
C
      DO ILINE = 1,N
      DO ISAMP = 1,M
      PICDATX(ISAMP,ILINE) = PICDAT(ISAMP,ILINE)
      END DO
      END DO
C
      DO ILINE = 1,80
      DO ISAMP = 1,130
      PICDATX(ISAMP,ILINE) = PICDAT(ISAMP,ILINE)
      END DO
      WRITE (77) (PICDATX(ISAMP,ILINE),ISAMP=1,130)
      END DO
C
      RETURN
      END
      SUBROUTINE UPDREC(I,J,IDATA,IHIST,NLON,NLAT,NCLASS,ITIME,XMEAN,
     1                  VAR)
C***********************************************************************
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:  UPDREC        UPDATES THE HISTOGRAM
C   PRGMMR: PHIL ARKIN       ORG: W/NMC        DATE: 86-08-01
C           Brenda Hardie    Migrated to AIX.  DATE: 05-03-08
C
C ABSTRACT: UPDATES HISTOGRAN FOR THIS PENTAD AND TIME OF DAY FOR
C   SPECIFIED BOX.
C
C PROGRAM HISTORY LOG:
C   86-08-01  PHIL ARKIN
C
C USAGE:    CALL UPDREC(I,J,IDATA,IHIST,NCLASS,ITIME,XMEAN,VAR)
C   INPUT ARGUMENT LIST:
C     I       I*4       POINTER, CORRESPONDING TO LONGITUDE
C     J       I*4       POINTER, CORRESPONDING TO LATITUDE
C     ITIME   I*4       POINTER, INDICATES PICTURE (1 - 8)
C                       TEMPERATURE POPULATION OF 24 CLASSES ACCUMULATED
C                       OVER THE ACTIVE PENTAD FOR EACH 1 X 1 BOX.
C                       1ST/2ND DIMENSION OF THE ARRAY CORRESPONDS TO
C                       LONGITUDE/LATITUDE, 3RD TO 16 CLASSES.
C     IHIST   I*4       TEMPERATURE POPULATION OF 24 CLASSES IN EACH
C                       BOX OF EACH IMAGE.
C     XMEAN   R*4       MEAN TEMPERATURE IN EACH BOX OF EACH IMAGE.
C     VAR     R*4       TEMPERATURE VARIANCE IN EACH BOX OF EACH IMAGE.
C
C   OUTPUT ARGUMENT LIST:
C     IDATA   I*4       HISTOGRAM DATA
C     STAT    R*4       STATISTICS, INCLUDING MEAN AND VARIANCE
C                       3RD ELEMENTS: 1	IS MEAN TEMPERATURE
C                                     2 IS SPATIAL VARIANCE
C                       1ST/2ND DIMENSION CORRESPONDS TO LONGITUDE/
C                       LATITUDE FOR EACH BOX IN ONE OF THE 4 SECTIONS
C ATTRIBUTES:
C   LANGUAGE: IBM VS FORTRAN (FORTRAN 77)
C   MACHINE:  HDS 9000
C$$$
C   LOCAL PARAMETERS-
C
C     KMEAN   I*4       POINTER, EQUAL TO ITIME, 1 - 8
C     KVAR    I*4       POINTER, FOR THE POSITION OF VAR IN STAT
C     I1      I*4       DO VARIABLE, 1 - 16
C
      INTEGER*2 IDATA(NLON,NLAT,NCLASS+2)
      INTEGER*4 IHIST(NCLASS)
      
      DO 10 I1=1,NCLASS
      IDATA(I,J,I1)=IDATA(I,J,I1)+IHIST(I1)
   10 CONTINUE
C
C        NOW STORE MEANS & VARIANCES
C
      KMEAN=ITIME
      KVAR=ITIME+8
      IDATA(I,J,NCLASS+1)=XMEAN*10.
      IDATA(I,J,NCLASS+2)=VAR*10.
C
      RETURN
      END
      SUBROUTINE ZCLEAR
C***********************************************************************
C
C   NAME- ZCLEAR
C
C   LANGUAGE- VS FORTRAN  TYPE- SUBROUTINE      COMPUTER- HDS 9000
C
C   VERSION- 11.0   DATE- 05/21/96   PROGRAMMER- R. SCHREITZ, EC1300
C   VERSION- 11.2   DATE- 07/24/98   PROGRAMMER- R. SCHREITZ, EC1300
C                   INSTALLED UPDATED COMMON AREA KDOCIJ
C   VERSION- NN.N   DATE- 02/18/05   PROGRAMMER- R. SCHREITZ, EC1300
C                   PLACED ALL COMMON STATEMENTS IN AN 'INCLUDE'
C                   LIBRARY.
C   VERSION- 11.3   DATE- 05-03-08   PROGRAMMER- Brenda Hardie  
C                   Migrated to AIX.
C
C   FUNCTION- CLEARS ARRAYS IN COMMON AREAS JDOC AND KDOCIJ.
C
C   COMMON AREA PARAMETERS-
C
      INCLUDE 'jdoc.i'
      INCLUDE 'kdocij.i'
C                                                                      >
C***********************************************************************
      DO 120 KJ = 1,8
      DO 110 KI = 1,2
      NYEAR    (KI,KJ) = 0
      NDAYOY   (KI,KJ) = 0
      NMON     (KI,KJ) = 0
      NDAYOM   (KI,KJ) = 0
      NHOUR    (KI,KJ) = 0
      NMIN     (KI,KJ) = 0
      NSEC     (KI,KJ) = 0
      NMLSEC   (KI,KJ) = 0
      KISF     (KI,KJ) = 0
      KJSF     (KI,KJ) = 0
      KIADJ    (KI,KJ) = 0
      KJADJ    (KI,KJ) = 0
      KFDBE    (KI,KJ) = 0
      KLDBE    (KI,KJ) = 0
      KFGDBL   (KI,KJ) = 0
      KLGDBL   (KI,KJ) = 0
      KDBLINECT(KI,KJ) = 0
      KDBDROPCT(KI,KJ) = 0
      KDBELEMCT(KI,KJ) = 0
  110 CONTINUE
  120 CONTINUE
      RETURN
      END
