      SUBROUTINE RINIT (FNAME,IR0_FGS,IR0_LGS,                            
     |                        IRX_FGS,IRX_LGS,LRX,IOFFSET,RUNSTAT,IOS)     
C***********************************************************************
C                                                                       
C   NAME- RINIT                                    
C                                                                       
C   LANGUAGE- FORTRAN     TYPE- SUBROUTINE                              
C                                                                       
C   VERSION-  3.00  DATE- 01/24/08  PROGRAMMER- SCHREITZ, R.  EC1300        
C   VERSION-  4.01  DATE- 04/06/10  PROGRAMMER- SCHREITZ, R.  EC1300        
C                   REVISION TO ACCOMMODATE PARTIAL FRAMES.
C   VERSION-  4.03  DATE- 04/27/11  PROGRAMMER-  R. SCHREITZ  EC2200
C                   REVISION TO PROCESS CHANNELS 2,3,5,6 WITHOUT
C                   ENHANCEMENT.
C                                                                       
C   FUNCTION-                                                           
C                                                                       
C     SYNCHRONIZES THE DOCUMENTATION AND DATA FILES IF NECESSARY USING
C     INFORMATION IN THEIR RESPECTIVE HEADER RECORDS TO COMPUTE
C     IOFFSET.
C                                                                       
C   CALLING SEQUENCE PARAMETERS-                                        
C                                                                       
C     FNAME             FRAME NAME AS READ FROM THE AFEP DATA FILE
C                       HEADER
                        CHARACTER*44 FNAME
C     IR0_FGS I*4  -O-  RECORD NUMBER OF THE FIRST GOOD SCAN IN
C                       THE AFEP BLOCK 0 DOCUMENTATION FILE
C     IR0_LGS I*4  -O-  RECORD NUMBER OF THE LAST GOOD SCAN IN
C                       THE AFEP BLOCK 0 DOCUMENTATION FILE
C     IRX_FGS I*4  -O-  RECORD NUMBER OF THE FIRST GOOD SCAN IN
C                       THE AFEP BLOCK x DATA FILE
C     IRX_LGS I*4  -O-  RECORD NUMBER OF THE LAST GOOD SCAN IN
C                       THE AFEP BLOCK X DATA FILE
C     LRX     I*4  -O-  DATA FILE RECORD LENGTH
C
C     THERE MAY BE INSTANCES IN WHICH SYNCHRONIZATION IS LOST BETWEEN
C     THE DOCUMENTATION AND DATA FILES PRODUCED BY THE AFEP;
C     RECORD N IN THE DOCUMENTATION FILE AND RECORD N IN THE DATA FILE
C     EACH CONTAIN, RESPECTIVELY, THE DOCUMENTATION AND THE DATA FOR
C     ONE SCAN, BUT NOT NECESSARILY THE SAME SCAN.
C
C     IOFFSET I*4  -O-  RELATIVE SCAN COUNT OF THE FIRST GOOD SCAN
C                       IN THE DATA FILE MINUS                      
C                       RELATIVE SCAN COUNT OF THE FIRST GOOD SCAN
C                       IN THE DOCUMENTATION FILE,
C                       WHERE EACH OF THESE NUMBERS IS RETRIEVED FROM
C                       THE CORRESPONDING FILE HEADER
C     RUNSTAT I*4  -O-  RUN STATUS
                        INTEGER*4 RUNSTAT
C                        =  0 => NORMAL RETURN
C                        = 99 => ERROR CONDITION - TERMINATE RUN
C     IOS     I*4  -O-  IO STATUS
C                        =  0 => NORMAL RETURN
C                       ~=  0    SEE IBM MANUAL
C                                                
C   COMMON AREA PARAMETERS-                                             
C                                                                       
      INCLUDE 'rconst.i'
C
C   KEY LOCAL PARAMETERS-                                               
C
C     IS0_FGS I*4       RELATIVE SCAN coUNT OF THE FIRST GOOD SCAN IN  
C                       THE AFEP BLOCK 0 DOCUMENTATION FILE
C     IS0_LGS I*4       RELATIVE SCAN coUNT OF THE LAST GOOD SCAN IN
C                       THE AFEP BLOCK 0 DOCUMENTATION FILE
C     ISX_FGS I*4       RELATIVE SCAN coUNT OF THE FIRST GOOD SCAN IN
C                       THE AFEP BLOCK x DATA FILE
C     ISX_LGS I*4       RELATIVE SCAN coUNT OF THE LAST GOOD SCAN IN
C                       THE AFEP BLOCK X DATA FILE
C
C***********************************************************************
 
      CHARACTER*3 CHAN
      CHARACTER*8 FM0,FMX

      CHARACTER*100 BUF0_0
      INTEGER*2 IBUF0_0(50)
      EQUIVALENCE (IBUF0_0(1),BUF0_0(1:1))

      CHARACTER*100 BUFX_0
      INTEGER*2 IBUFX_0(50)
      EQUIVALENCE (IBUFX_0(1),BUFX_0(1:1))

      DATA CHAN/'   '/

C***********************************************************************

      RUNSTAT = 0

C     READ THE DOCUMENTATION FILE HEADER RECORD.

      OPEN(UFILE0,STATUS='OLD',ACCESS='DIRECT',FORM='UNFORMATTED',
     *   RECL=8132,ACTION='READ',ERR=910,IOSTAT=IOS)
      READ(UFILE0,REC=1,ERR=920,IOSTAT=IOS) IBUF0_0
      CLOSE(UFILE0)
 
      PRINT 3010, BUF0_0(01:44)
      IF (BUF0_0(08:08).EQ.'R') BUF0_0(08:08) = 'N'
      IF (BUF0_0(08:08).EQ.'U') BUF0_0(08:08) = 'N'
      PRINT 3010, BUF0_0(01:44)

      IRECL0 = IBUF0_0(44)
      PRINT '('' UNIT ='',I3,3x,'' RECL ='',I11)', UFILE0,IRECL0
      IR0_FGS = IBUF0_0(34)
      IS0_FGS = IBUF0_0(33)
      IR0_LGS = IBUF0_0(42)
      IS0_LGS = IBUF0_0(41)
      PRINT '('' IR0_FGS, IS0_FGS, IR0_LGS, IS0_LGS :'',4I8/)',
     |           IR0_FGS, IS0_FGS, IR0_LGS, IS0_LGS

C     READ THE (SENSOR) DATA FILE HEADER RECORD.

C     INQUIRE ABOUT THE SENSOR FILE'S TRUE RECORD LENGTH.  THEN
C     CLOSE UP THE FILE AND REPORT THE RESULTS.
      OPEN(UFILEX,STATUS='OLD',ACTION='READ',ERR=930,IOSTAT=IOS)
      INQUIRE(UFILEX,RECL=LRX)
      CLOSE(UFILEX)
      OPEN(UFILEX,STATUS='OLD',ACCESS='DIRECT',FORM='UNFORMATTED',
     *   RECL=LRX,ACTION='READ',ERR=930,IOSTAT=IOS)
      READ(UFILEX,REC=1,ERR=940,IOSTAT=IOS) IBUFX_0
      CLOSE(UFILEX)

      PRINT 3010, BUFX_0(01:44)
      IF (BUFX_0(08:08).EQ.'R') BUFX_0(08:08) = 'N'
      IF (BUFX_0(08:08).EQ.'U') BUFX_0(08:08) = 'N'
      PRINT 3010, BUFX_0(01:44)
 
      IF      (BUFX_0(05:06).EQ.'IR') THEN
 
      LRX = IBUFX_0(44)
      PRINT '('' UNIT ='',I3,3x,'' RECL ='',I11)', UFILEX,LRX
      IRX_FGS = IBUFX_0(34)
      ISX_FGS = IBUFX_0(33)
      IRX_LGS = IBUFX_0(42)
      ISX_LGS = IBUFX_0(41)
 
C     ELSE IF (BUFX_0(05:07).EQ.'V4K') THEN
C
C              BUFX_0(05:07)  = 'IR4'
C
C     LRX = 8412        
C     PRINT '('' UNIT ='',I3,3x,'' RECL ='',I11)', UFILEX,LRX
C     IRX_FGS = IBUF0_0(34)
C     ISX_FGS = IBUF0_0(33)
C     IRX_LGS = IBUF0_0(42)
C     ISX_LGS = IBUF0_0(41)
 
      END IF

      PRINT '('' IRX_FGS, ISX_FGS, IRX_LGS, ISX_LGS :'',4I8/)',
     |           IRX_FGS, ISX_FGS, IRX_LGS, ISX_LGS

      IOFFSET = ISX_FGS - IS0_FGS
      CHAN = BUFX_0(5:6)
      IF (CHAN(1:2).NE.'IR') RUNSTAT = 99

      FNAME = BUFX_0(01:44)
      GO TO 990

  910 PRINT 3910, IOS
      RUNSTAT = 91
      GO TO 990
  920 PRINT 3920, IOS
      RUNSTAT = 92
      GO TO 990
  930 PRINT 3930, IOS
      RUNSTAT = 93
      GO TO 990
  940 PRINT 3940, IOS
      RUNSTAT = 94

  990 RETURN

 3010 FORMAT (' ',A44)

 3310 FORMAT (' RINIT: MATCH ',I5.5)
 3320 FORMAT (' RINIT: DOCUMENTATION RECORD ',I5.5,' AND',
     |        ' DATA RECORD ',I5.5,' DO NOT MATCH.'/
     |        '       RELATIVE SCAN COUNT IN DOCUMENTATION RECORD = ',
     |                I5.5/
     |        '       RELATIVE SCAN COUNT IN DATA RECORD          = ',
     |                I5.5/)
 3910 FORMAT (' RINIT: ABNORMAL CONDITION ENCOUNTERED OPENING DOC',
     |        ' FILE',3x,'IOSTATUS = ',I3.3)
 3920 FORMAT (' RINIT: ABNORMAL CONDITION ENCOUNTERED READING DOC',
     |        ' FILE',3x,'IOSTATUS = ',I3.3)
 3930 FORMAT (' RINIT: ABNORMAL CONDITION ENCOUNTERED OPENING DATA',
     |        ' FILE',3x,'IOSTATUS = ',I3.3)
 3940 FORMAT (' RINIT: ABNORMAL CONDITION ENCOUNTERED READING DATA',
     |        ' FILE',3x,'IOSTATUS = ',I3.3)

      END
