      SUBROUTINE RSCT(STATUS,IOS)
C***********************************************************************
C   NAME- RSCT
C
C   LANGUAGE- VS FORTRAN  TYPE- SUBROUTINE
C   VERSION-  0.00  DATE- AUG 87     PROGRAMMER- ROBERTS, MICHELLE
C                                                E/SP12
C   VERSION-  0.00  DATE- JUL 93     PROGRAMMER- SUKDEE  STORAASLI
C   VERSION-  2.00  DATE- 01/21/05   PROGRAMMER- SCHREITZ,R  EC1300
C                   ELIMINATED PROCESSING NO LONGER REQUIRED.
C                   (PREVIOUS NAME: RFINIT)
C   VERSION-  2.00  DATE- 08/29/06  PROGRAMMER- SCHREITZ, R.  EC2200
C                   REMOVAL OF FAX/WEFAX PROCESSING, CONVERSION TO AIX,
C                   MODERNIZATION AND/OR SIMPLIFICATION OF LOGIC.

C
C   FUNCTION-
C
C     READS THE SCALE CONVERSION TABLE.
C
C   FILES-
C
C     SCALE CONVERSION TABLES
C
C   CALLING SEQUENCE PARAMETERS-
C
C     STATUS          SUBROUTINE RETURN STATUS
C                                =  0  OK
C                                = 95  ABORT VASDR (OPEN ERROR)
C                                = 96  ABORT VASDR (READ ERROR)
                      INTEGER*4 STATUS
                      CHARACTER*2 IVAL
C
C***********************************************************************
C   COMMON AREA PARAMETERS-
C
      INCLUDE'rconst.i'
      INCLUDE'statushb.i'
      INCLUDE'sctable.i'
C
C   LOCAL PARAMETERS-
C
C   CALLING MODULE- VASDR
C
C   SUBPROGRAMS CALLED- SCTERR,RMSGLG
C
C   RESTRICTIONS- NONE
C
C   ATTRIBUTES-
C
C   COMMENTS-
C
C***********************************************************************
C
      STATUS = 0
C
C     OPEN SCALE CONVERSION TABLES FILE.
C
      OPEN (USCONV,STATUS='OLD',ACCESS='DIRECT',FORM='FORMATTED',
     *      RECL=2112,ERR=950,IOSTAT=IOS)
C
C     READ THE DESIGNATED SCALE CONVERSION TABLE.
C
      ISCT = MSR(49)
      READ (USCONV,99,REC=ISCT,ERR=960,IOSTAT=IOS) SCTHDR,CSCTVAL
   99 FORMAT(A64,A2048)
CCCCC PRINT 9510, ISCT, (ISCTVAL(N),N=1,1000)
C
C     NORMAL RETURN
      GO TO 990
C
C ***** ERROR HANDLING *****
C
C     SCALE CONVERSION DATASET OPEN ERROR
C     SET ERROR FLAG.
C
  950 STATUS = 95
      GO TO 990
C
C     SCALE CONVERSION DATASET READ ERROR
C     PRINT TABLE AND SET ERROR FLAG.
C
  960 STATUS = 96
      PRINT*, 'SCALE CONVERSION ERROR'
      PRINT 9610, ISCT, (ISCTVAL(N),N=1,200)
 9610 FORMAT (' ',I5/(' ',20I5/))
C
  990 RETURN
      END
