      SUBROUTINE SVCPSF (KPSF)
C***********************************************************************
C                                                                       
C   NAME- SVCPSF
C                                                                       
C   LANGUAGE- FORTRAN     TYPE- SUBROUTINE                              
C                                                                       
C   VERSION-  4.04  DATE- 02/02/12  PROGRAMMER- SCHREITZ, R.  EC2200
C                   RETRIEVAL AND DISPLAY OF STRAY LIGHT CORRECTION
C                   STATUS.
C                                                                       
C   FUNCTION-
C
C     SETS OR CLEARS THE 'PROCESS SCAN' FLAG.  THE DECISION TO SET
C     SET OR CLEAR IS BASED ON THE STRAY LIGHT CORRECTION STATUS WORD.
C     THE FLAG WILL BE CLEARED IF A SCAN CONTAINS A VALUE OBSERVED
C     WHEN THE ASSOCIATED ANGLE WITH RESPECT TO THE SUN IS LESS THAN
C     A SPECIFIED THRESHOLD.
C                                                                       
C   CALLING SEQUENCE PARAMETERS-                                        
C
C     KPSF              'PROCESS SCAN' FLAG
C                        0 = DO NOT PROCESS SCAN
C                        1 = PROCESS SCAN  
C
C   COMMON AREA PARAMETERS-
C
      INCLUDE 'ingest.i'
C
C   KEY LOCAL PARAMETERS-                                               
C
C     SLC_STATUS        STRAY LIGHT CORRECTION STATUS 
                        INTEGER*2 SLC_STATUS
C     SLC_STATUS4       STRAY LIGHT CORRECTION STATUS 
                        INTEGER*4 SLC_STATUS4
                        EQUIVALENCE (SLC_STATUS,BUF0(349:350))
C                       NOTE THAT THE BLOCK 0 RECORD IS PRECEDED BY
C                       A 30-BYTE BLOCK HEADER IN TRIPLICATE.
C                       3*30 + 260 = 350
                        LOGICAL*1 SLC_ENABLED
                        LOGICAL*1 SLC_PERFORMED     
                        LOGICAL*1 SUN_ON_EAST_SIDE  
                        LOGICAL*1 SUN_ON_WEST_SIDE  
                        LOGICAL*1 SUN_ON_NORTH_SIDE
                        LOGICAL*1 SUN_ON_SOUTH_SIDE
C     MIN_SUN_ANGLE     MINIMUM SUN ANGLE
                        INTEGER*2 MIN_SUN_ANGLE
C
      KPSF = 1
C
C     RETRIEVE AND DISPLAY THE STRAY LIGHT CORRECTION STATUS.     
      IF (SLC_STATUS.NE.0) PRINT 3500, SLC_STATUS

      SLC_STATUS4       = SLC_STATUS
      SLC_ENABLED       = IAND(SLC_STATUS4,1).GT.0
      SLC_PERFORMED     = IAND(SLC_STATUS4,2).GT.0
      SUN_ON_EAST_SIDE  = IAND(SLC_STATUS4,4).GT.0
      SUN_ON_NORTH_SIDE = IAND(SLC_STATUS4,8).GT.0
      SUN_ON_WEST_SIDE  = .NOT.SUN_ON_EAST_SIDE  
      SUN_ON_SOUTH_SIDE = .NOT.SUN_ON_NORTH_SIDE
      IF (SLC_ENABLED) THEN
         PRINT 3510
            IF (SLC_PERFORMED) THEN
               PRINT 3530
               IF (SUN_ON_NORTH_SIDE.AND.SUN_ON_WEST_SIDE) PRINT 3550    
               IF (SUN_ON_NORTH_SIDE.AND.SUN_ON_EAST_SIDE) PRINT 3560  
               IF (SUN_ON_SOUTH_SIDE.AND.SUN_ON_WEST_SIDE) PRINT 3570  
               IF (SUN_ON_SOUTH_SIDE.AND.SUN_ON_EAST_SIDE) PRINT 3580
               MIN_SUN_ANGLE = ISHFT(SLC_STATUS4,-4)
               PRINT 3590, MIN_SUN_ANGLE   
C              IF (MIN_SUN_ANGLE.LE.7) KPSF = 0
               KPSF = 1
            ELSE
CCCCC          PRINT 3540
               GO TO 990
            END IF  
      ELSE
CCCCC    PRINT 3520
      END IF
      PRINT 3600
 990  RETURN
C
 3500 FORMAT (' ','STRAY LIGHT CORRECTION STATUS',1X,Z4) 
 3510 FORMAT (' ','STRAY LIGHT CORRECTION ENABLED')
 3520 FORMAT (' ','STRAY LIGHT CORRECTION NOT ENABLED')
 3530 FORMAT (' ','STRAY LIGHT CORRECTION PERFORMED')
 3540 FORMAT (' ','STRAY LIGHT CORRECTION NOT PERFORMED')
 3550 FORMAT (' ','SUN IS IN THE NORTHWEST QUADRANT')
 3560 FORMAT (' ','SUN IS IN THE NORTHEAST QUADRANT')
 3570 FORMAT (' ','SUN IS IN THE SOUTHWEST QUADRANT')
 3580 FORMAT (' ','SUN IS IN THE SOUTHEAST QUADRANT')
 3590 FORMAT (' ','MINIMUM SUN ANGLE = ',I2,' DEGREES')
 3600 FORMAT (' ')
C
      END
