      PROGRAM VASDR
C Y2K MODIFIED - J. SELEKOF
C**********************************************************************
C
C   NAME- VASDR
C
C   LANGUAGE- VS FORTRAN  TYPE- MAIN PROGRAM    COMPUTER- IBM 3090
C
C   VERSION-  1.00  DATE- 12/10/86  PROGRAMMER- VAN AKKEREN, PAUL
C                                               GSC CORP.
C   VERSION-  1.01  DATE- 10/10/92  PROGRAMMER- STORAASLI, SUKDEE
C                                               GSC CORP.
C   VERSION-  1.02  DATE- 07/06/95  PROGRAMMER- T.ROEGNER     (HSTX)
C   VERSION-  1.03  DATE- 12/04/95  PROGRAMMER- T.ROEGNER     (HSTX)
C   VERSION-  1.04  DATE- 01/23/96  PROGRAMMER- R.SCHREITZ    EC1300
C                                               E.TABOR       (SMSRC)
C   VERSION-  1.05  DATE- 05/08/96  PROGRAMMER- T.ROEGNER     (HSTX)
C   VERSION-  1.06  DATE- 06/17/98  PROGRAMMER- R.SCHREITZ    EC1300
C   VERSION-  1.07  DATE- 11/13/98  PROGRAMMER- J.SELEKOF     (STC)
C   VERSION-  1.08  DATE- 12/04/98  PROGRAMMER- J.SELEKOF     (STC)
C   VERSION-  1.09  DATE- 03/26/03  PROGRAMMER- B.WHISTLER    (STC)
C   VERSION-  1.10  DATE- 05/19/03  PROGRAMMER- SCHREITZ, R.  EC1300
C   VERSION-  2.00  DATE- 08/19/03- PROGRAMMER- SCHREITZ, R.  EC1300-
C                         08/29/06                            EC2200   
C   VERSION-  2.01  DATE- 05/22/07  PROGRAMMER- SCHREITZ, R.  EC2200
C   VERSION-  2.02  DATE- 10/19/07  PROGRAMMER- SCHREITZ, R.  EC2200
C   VERSION-  3.00  DATE- 01/24/08  PROGRAMMER- SCHREITZ, R.  EC2200
C   VERSION-  3.01  DATE- 11/25/08  PROGRAMMER- SCHREITZ, R.  EC2200
C   VERSION-  4.00  DATE- 12/29/09  PROGRAMMER- SCHREITZ, R.  EC2200
C   VERSION-  4.01  DATE- 04/06/10  PROGRAMMER- SCHREITZ, R.  EC2200
C   VERSION-  4.02  DATE- 05/21/10  PROGRAMMER- SCHREITZ, R.  EC2200
C   VERSION-  4.03  DATE- 04/27/11  PROGRAMMER- SCHREITZ, R.  EC2200
C   VERSION-  4.04  DATE- 02/02/12  PROGRAMMER- SCHREITZ, R.  EC2200
C
C   VERSION NUMBERING CONVENTION FOR THIS PROGRAM-
C
C     FOR VERSIONS 1.00 THROUGH 1.09,
C
C     - THE VERSION ID IS LOCAL.
C
C     FOR VERSION 1.10 AND BEYOND,
C
C     - THE VERSION ID WILL BE GLOBAL.  EACH TIME A NEW VERSION OF
C       THE PROGRAM IS CREATED AS A RESULT OF A CHANGE OR CHANGES IN
C       ONE OR MORE OF ITS SOURCE MEMBERS, THE VERSION ID FOR
C       THE PROGRAM WILL BE INCREASED AND THE NEW VERSION ID AND
C       THE ASSOCIATED REVISION DATE WILL BE NOTED IN ALL MODIFIED
C       SOURCE MEMBERS AND IN THE MAIN PROGRAM, VASDR, WHETHER IT WAS
C       MODIFIED OR NOT. 
C
C     - THE FOLLOWING NUMBERING CONVENTION WILL BE USED:
C
C            xx.yy  WHERE  
C            xx     IS A TWO DIGIT ID (LEADING ZERO SUPPRESSED)
C                   SIGNIFYING A MAJOR VERSION
C            yy     IS A TWO DIGIT ID (LEADING ZERO RETAINED)
C                   SIGNIFYING A MINOR REVISION THAT DOES NOT INTRODUCE
C                   BACKWARD COMPATIBILITY ISSUES
C                   
C   FUNCTION-
C     VAS DATA REFORMATTER MAIN ROUTINE. READ VAS BLOCKS FROM THE DASD,
C     PERFORM ERROR AND QUALITY CHECKING, EXTRACT THE DESIRED RAW DATA,
C     PROCESS IT, AND PLACE IT IN THE REFORMATTED DATA PRODUCTS.
C
C   VERSION:  1.04
C     THE PRINCIPAL CHANGE MADE IN VERSION 1.04 WAS THE ELIMINATION OF
C     SEVERAL IF STATEMENTS TO PERFORM ASSIGNMENT FOR A FRAME FORMAT
C     POINTER.  TO ACCOMPLISH THIS THE TWO DIMENSIONAL ARRAY ISEN WAS
C     CHANGED TO THE ONE DIMENSIONAL ARRAY ISENRES.  CALLS TO THE
C     FUNCTIONS KFRAME AND SP WERE ADDED.  KFRAME COMPUTES A FRAME
C     FORMAT POINTER GIVEN THE SATELLITE POSITION AND INGEST TYPE.
C     SP DETERMINES THE SATELLITE POSITION GIVEN THE TWO CHARACTER
C     SATELLITE IDENTIFIER (G8, G9, ...)
C     R.SCHREITZ (EC1300), E.TABOR (SMSRC)
C
C   VERSION:  1.05
C     PREPARATION FOR HDS REMOVAL.  NETWARE FTP CHANGED TO TCP/IP FTP.
C     THE MODULE GENTRN WAS CHANGED TO FTPTRN.  ITS FUNCTION IS
C     SIMILAR EXCEPT THAT A FILE OF FTP COMMANDS IS BUILT AND
C     SUBMITTED TO THE INTERNAL READER.  ECP 6030402,
C     TOM ROEGNER (HSTX)
C
C   VERSION:  1.06
C     OUTPUT OPTIMIZATION.  NEW VERSION PERFORMS KEY DATABASE WRITER/
C     LOCATOR/READER INITIALIZATION AND TERMINATION FUNCTIONS
C     PREVIOUSLY PERFORMED IN SUBROUTINE WLINE.  SUBROUTINE WRITEC
C     WRITES THE FINAL PRODUCT BUFFER.
C     RICHARD SCHREITZ  EC1300
C
C   VERSION:  1.07
C     MODIFIED FOR YEAR 2000.
C     JOEL SELEKOF (STC)
C
C   VERSION:  1.08
C     IF INGEST IS TYPE 'IR4', STOP WITH 1, OTHERWISE STOP WITH 0.
C     THE JCL WILL RECOGNIZE THE RETURN CODE AND ONLY SUBMIT THE FTP
C     TO CRAY IF IT'S AN IR4 INGEST.
C     JOEL SELEKOF (STC)
C
C   VERSION:  1.09
C     MODIFIED FOR GOES-12.
C     BRUCE WHISTLER (STC)
C
C   VERSION:  1.10
C
C     EVOLUTIONARY NAME CHANGES MADE NECESSARY BY GVAR.
C     FRAME REPLACED SEN, KF REPLACED KSEN, ETC.
C
C     REVISION TO ACCOMMODATE THE FOLLOWING IMAGERY:
C          4 KM X 4 KM CHANNEL 3 DATA FROM GOES-M AND BEYOND
C          4 KM X 4 KM CHANNEL 6 DATA FROM GOES-O AND BEYOND.
C
C     RICHARD SCHREITZ  EC1300
C
C   VERSION:  2.00
C
C     REMOVAL OF FAX/WEFAX PROCESSING, CONVERSION TO AIX, 
C     MODERNIZATION AND/OR SIMPLIFICATION OF LOGIC.
C
C     EVOLUTIONARY NAME CHANGES MADE NECESSARY BY IMPROVED TECHNOLOGY.
C     AT ONE TIME, SCAN AND IR LINE WERE ESSENTIALLY SYNONYMOUS.
C     HOWEVER, AS INSTRUMENT TECHNOLOGY ADVANCED, IT BECAME POSSIBLE
C     FOR ONE SCAN TO PRODUCE TWO IR LINES, AND THE TERMS WERE NO
C     LONGER INTERCHANGEABLE.  ONE INSTANCE WAS FOUND IN WHICH, GIVEN
C     TODAY'S TECHNOLOGY, THE IMPROPER TERM WAS USED.  THE PROBLEM
C     WAS CORRECTED, BUT, SINCE THE FIRST VERSION OF THIS PROGRAM WAS
C     WRITTEN MANY YEARS AGO, THERE MAY BE OTHER INSTANCES, OUTSIDE
C     THE SCOPE OF THIS REVISION, IN WHICH THE CHOICE OF TERMS IS
C     NO LONGER VALID.
C
C     INTRODUCTION OF SUBROUTINE PRDB TO REPLACE THE FOLLOWING
C     SUBROUTINES: PRVSDB, PRVSDB2N, PRVSSM, PRIRSM, VISWPRD, IRWPRD.
C     AS A RESULT OF THIS CHANGE, THE SAME SCAN POSITIONING LOGIC
C     IS USED FOR VISIBLE AND INFRARED DATA IN THE CONSTRUCTION OF
C     THE MULTISPECTRAL GEOSTATIONARY IMAGER DATABASE.  THIS
C     PARALLELISM IS FACILITATES MULTISPECTRAL PROCESSING.
C
C     INTRODUCTION OF SUBROUTINE WLINEI TO PERFORM INITIALIZATION
C     PREVIOUSLY PERFORMED BY PROGRAM VASDR AND SUBROUTINE WLINE.
C
C     CONTRIBUTIONS TO VERSION 2.00 SPAN A PERIOD OF MORE THAN TWO
C     YEARS.  IT BEGAN AS A LOW PRIORITY OFF-LINE PROJECT AND WAS
C     QUICKLY ELEVATED TO A HIGH PRIORITY PROJECT WHEN IT BECAME
C     NECESSARY TO PORT A REFORMATTER TO THE IBM AIX ENVIRONMENT.
C
C     RICHARD SCHREITZ  EC2200
C
C   VERSION:  2.01
C
C     RETRIEVAL OF FRAME END TIME.
C     RICHARD SCHREITZ  EC2200
C
C   VERSION:  2.02
C
C     INTRODUCTION OF GENERIC READ SUBROUTINE RFEPO FOR BOTH 
C     DOCUMENTATION AND DATA FILES.
C     RICHARD SCHREITZ  EC2200
C
C   VERSION:  3.00
C
C     INTRODUCTION OF RESYNCHRONIZATION CAPABILITY.
C     RICHARD SCHREITZ  EC2200
C
C   VERSION:  3.01
C
C     RETRIEVAL AND DISPLAY OF IMAGING MODE.
C     RICHARD SCHREITZ  EC2200
C
C   VERSION:  4.00
C
C     MODIFICATION FOR USE WITH VERSION 18.03 OF THE LOCATOR/READER.
C     RICHARD SCHREITZ  EC2200
C
C   VERSION:  4.01
C
C     REVISION TO ACCOMMODATE PARTIAL FRAMES.
C     RICHARD SCHREITZ  EC2200
C
C   VERSION:  4.02
C
C     RECOGNITION OF 'V4K' AS A VALID INGEST DESCRIPTOR AND RE-
C     DEFINITION OF WAVELENGTH CODES IN FUNCTION KFRAME TO 'V' AND 'I'
C     TO ALLOW PROCESSING OF SUBSAMPLED 4 KM VISIBLE DATA GENERATED FOR
C     METEOFRANCE.  (CODING FOR THIS OPTION HAS NOT BEEN COMPLETED.)
C     RICHARD SCHREITZ  EC2200
C
C   VERSION:  4.03
C
C     REVISION TO PROCESS CHANNELS 2,3,5,6 WITHOUT ENHANCEMENT.
C     RICHARD SCHREITZ  EC2200
C
C   VERSION:  4.04
C
C     INTRODUCTION OF A SECONDARY PARAMETER FOR SATELLITE POSITION,
C     SPOS_BASIC, THAT HAS THE VALUE 'EAST' OR 'WEST' IF THE PRIMARY
C     PARAMETER FOR SATELLITE POSITION, SPOS, CONTAINS THE VALUE
C     'EAST' OR 'WEST'.
C     REVISION TO RETRIEVE AND DISPLAY THE STRAY LIGHT CORRECTION
C     STATUS AND TO SKIP PRECESSING OF A SCAN IF IT CONTAINS A VALUE
C     OBSERVED WHEN THE ASSOCIATED ANGLE WITH RESPECT TO THE SUN
C     IS LESS THAN A SPECIFIED THRESHOLD.
C     RICHARD SCHREITZ  EC2200
C
C   FILES-
C
C   CALLING SEQUENCE PARAMETERS- NONE
C
C   COMMON AREA PARAMETERS-
C
      INCLUDE 'ingest.i' 
      INCLUDE 'control.i'
      INCLUDE 'unpacked.i'
      INCLUDE 'rconst.i'
      INCLUDE 'statushb.i'
C
C   LOCAL PARAMETERS-
C
                        INTEGER*4 STAT
                        INTEGER*4 IRDFLGV
                        INTEGER*4 IRDFLGI
                        CHARACTER*1 CDET
C
C     FIRST             STARTING LINE OF IMAGE FOR PROCESSING
C                       INTEGER*4 FIRST
C
C     LAST              ENDING LINE OF IMAGE FOR PROCESSING
C                       INTEGER*4 LAST
C
C     DATE     C*       CHARACTER INFORMATION RETURNED FROM
C                       UTILITY SUBROUTINE DATE_AND_TIME:
C                       CCYYMMDD
                        CHARACTER*8 DATE
C     TIME     C*       CHARACTER INFORMATION RETURNED FROM
C                       UTILITY SUBROUTINE DATE_AND_TIME:
C                       HHMMSS.SSS
                        CHARACTER*10 TIME
C     ZONE     C*5      CHARACTER INFORMATION RETURNED FROM
C                       UTILITY SUBROUTINE DATE_AND_TIME
                        CHARACTER*5 ZONE
C     IVALUES  I*4      INTEGER INFORMATION RETURNED FROM
C                       UTILITY SUBROUTINE DATE_AND_TIME
C                       (1) YEAR (FOUR DIGITS)
C                       (2) MONTH OF THE YEAR
C                       (3) DAY OF THE MONTH
C                       (4) TIME DIFFERENCE WITH RESPECT TO UTC
C                           IN MINUTES
C                       (5) HOUR OF THE DAY
C                       (6) MINUTES OF THE HOUR
C                       (7) SECONDS OF THE MINUTE
                        INTEGER*4 IVALUES(8)
C     FNAME    C*44     FRAME NAME AS READ FROM THE FEP DATA FILE    
C                       HEADER
                        CHARACTER*44 FNAME
C     FTYPE    C*4      FRAME TYPE     (VISF,VISN,VISS,...) (FROM FNAME)
                        CHARACTER*4 FTYPE
C     CHAN     C*3      CHANNEL        (VIS,IR2,IR3,...)    (FROM FNAME)
                        CHARACTER*3 CHAN
C     SPACECRAFT_ID     SPACECRAFT ID  (GK,GL,GM,...)       (FROM FNAME)
                        CHARACTER*2 SPACECRAFT_ID
C     RKEY     C*3      READ KEY (LOCALLY DEFINED CONTROL PARAMETER)
                        CHARACTER*3 RKEY  
C     INFLN8   I*4      NUMBER OF THE NORTHERNMOST VISIBLE DETECTOR LINE
C                       IN THE FRAME IN 8 KM COORDINATES
C                       (NOMINALLY 1 THROUGH 1973)
C     ISFLN8   I*4      NUMBER OF THE SOUTHERNMOST VISIBLE DETECTOR LINE
C                       IN THE FRAME IN 8 KM COORDINATES
C                       (NOMINALLY 2 THROUGH 1974)
C   BLOCK DATA-
C
C      SUBPROGRAMS CALLED-
c
C***********************************************************************
 
      CHARACTER*8 FM0,FMX
      IRDFLGV=0
      IRDFLGI=0
      STAT=0
 
      IOS = 0
      WRITE(UMPAR1,'(I3)') IOS
      WRITE(UMPAR2,'(I3)') IOS
 
C  THE LENGTH OF THE DOCUMENTATION RECORDS IS CONSTANT.
      LR0 = 8132

C  THE LENGTH OF THE (SENSOR) DATA RECORDS VARIES ACCORDING TO
C  THE SCAN WIDTH.  SUBROUTINE RINIT, IN ADDITION TO PERFORMING OTHER 
C  FUNCTIONS, READS THIS PARAMETER, LRX, FROM THE (SENSOR) DATA FILE
C  HEADER BLOCK.

      CALL RINIT (FNAME,IR0_FGS,IR0_LGS,
     |                  IRX_FGS,IRX_LGS,LRX,IOFFSET,STAT,IOS)
      IF (STAT.EQ.91) GO TO 910 ! DOCUMENTATION FILE CANNOT BE OPENED
      IF (STAT.EQ.92) GO TO 920 ! DOCUMENTATION FILE CANNOT BE READ
      IF (STAT.EQ.93) GO TO 930 ! DATA FILE CANNOT BE OPENED
      IF (STAT.EQ.94) GO TO 940 ! DATA FILE CANNOT BE READ

      FTYPE = FNAME(5:8)
      CHAN  = FNAME(5:7)
CCCCC IF (CHAN.NE.'IR4') CALL exit_(90)
C
      SPACECRAFT_ID = FNAME(10:11)

C  SUBROUTINE RINIT OPENED FILE0 AND FILEX AS UNFORMATTED FILES.
C  REOPEN BOTH FILES AS FORMATTED FILES.

      OPEN(UFILE0,ACCESS='DIRECT',FORM='FORMATTED',RECL=8132,
     |   ACTION='READ',IOSTAT=IOS,ERR=910)

      OPEN(UFILEX,ACCESS='DIRECT',FORM='FORMATTED',RECL=LRX,     
     |   ACTION='READ',IOSTAT=IOS,ERR=930)

      CALL BSTHB (IR0_FGS,IR0_LGS,STAT,IOS)
      IF (STAT.EQ.92) GO TO 920 ! DOCUMENTATION FILE CANNOT BE READ

C  DEFINE THE FILE FORMATS.

      FM0(1:8)='(A08132)'

C  ENCODE THE RECORD LENGTH INTO A FORMAT STRING SO THAT IT CAN BE
C  USED IN A DYNAMIC FORMAT STATEMENT FOR READING THE INGEST DATA.

      FMX(1:8)='(ANNNNN)'
      WRITE(FMX(3:7),'(I5.5)') LRX    
      WRITE(6,*) 'DATA RECORD FORMAT IS ',FMX
C
C  RETRIEVE THE SCALE CONVERSION TABLE.
C
      CALL RSCT (STAT,IOS)
      IF (STAT.EQ.95) GO TO 950 ! TABLE CANNOT BE OPENED.
      IF (STAT.EQ.96) GO TO 960 ! TABLE CANNOT BE READ.
C
C  INITIALIZE THE WRITER PORTION OF THE WRITER/LOCATOR/READER MODULE.
C
      CALL WLINEI (UDPROD,FTYPE,SPACECRAFT_ID,MPIX,STAT,IOS)
 
      IF (STAT.EQ.70) THEN                                       
      CALL CLOSERFM (700)
      CLOSE (UMPAR1) 
      WRITE (UMPAR1,'(A1)') SPACECRAFT_ID(2:2)
      CALL exit_(70)
      ENDIF
 
      IF (STAT.EQ.97) GO TO 970 ! PRODUCT FILE CANNOT BE OPENED.
      IF (STAT.EQ.98) GO TO 980 ! PRODUCT FILE CANNOT BE WRITTEN.
 
      IF (FTYPE(3:3).EQ. 'S') THEN
         CDET = 'V'
      ELSE
         CDET = 'I'
      ENDIF
C
C  GET CURRENT TIME (UTC).
C
      CALL DATE_AND_TIME(DATE,TIME,ZONE,IVALUES)
      NYEAROC = MOD(IVALUES(1),100)
      CALL DOY(IVALUES(1),IVALUES(2),IVALUES(3),NDAYOY)
C     WRITE(6,3330, IVALUES
C3330 FORMAT (' ', 8I5)

      PRINT 3010, IOFFSET 

      INFLN8 = STHB(225)
      ISFLN8 = STHB(226)
      K8MIN = 1
      K8MAX = (ISFLN8-INFLN8+1)

      DO 100 K8 = K8MIN,K8MAX
      IR = 1 + K8

C***********************************************************************
C  READ A DOCUMENTATION RECORD.

      IR0 = IR
      IF (IR0.LT.IR0_FGS.OR.IR0.GT.IR0_LGS) GO TO 100
      IF (IOFFSET.GT.0) IR0 = IR + IOFFSET

C     EXAMPLE: IOFFSET > 0
C               IS0   ISX
C         =>     2     9
C                9     2
 
      IF (IR0.LT.2) GO TO 100 
      RKEY = 'DOC'
      LR0 = 8132
      CALL RFEPO (RKEY,UFILE0,IR0,LR0,FM0,BUF0,IS0,IOS,KST)
      IF (KST.NE.0) PRINT 3030, IR,IR0,IS0,IOS,KST
 3030 FORMAT (         ' VASDR: IR,IR0,IS0,IOS,KST:',5I5/)

C***********************************************************************
C     SET OR CLEAR 'PROCESS SCAN' FLAG.
      CALL SVCPSF (KPSF)
      IF (KPSF.NE.1) GO TO 100

C***********************************************************************
C  READ A DATA RECORD.

      IRX = IR
      IF (IRX.LT.IRX_FGS.OR.IRX.GT.IRX_LGS) GO TO 100
      IF (IOFFSET.LT.0) IRX = IR - IOFFSET

C     EXAMPLE: IOFFSET < 0 
C               IS0   ISX
C                2     9
C         =>     9     2
 
      IF (IRX.LT.2) GO TO 100
      RKEY = CHAN           
C     LRX WAS DEFINED BY SUBROUTINE RINIT.
      CALL RFEPO (RKEY,UFILEX,IRX,LRX,FMX,BUFX,ISX,IOS,KST)
      IF (KST.NE.0) PRINT 3040, IR,IRX,ISX,IOS,KST
 3040 FORMAT (         ' VASDR: IR,IRX,ISX,IOS,KST:',5I5/)

C***********************************************************************
      IF (ISX.NE.IS0) THEN                      
      PRINT 3810, IS0,ISX
      GO TO 100
      ENDIF

C        MAKE SURE LINE IS NEEDED.
C        INIT LINE AND BLOCKS TO 'GOOD'.
         DO 10 J=1,8
   10    CONTINUE
         IF (CDET.EQ.'V') THEN
CCCCC          CALL RDATAV (FTYPE,STAT)
CCCCC          IF (IRDFLGV.NE.0) FILLN=1
         ELSE
CCCCC          CALL RDATAI (FNAME,STAT)
CCCCC          IF (IRDFLGI.NE.0) FILLN=1
               CALL EXLINES(FNAME,STAT)
         ENDIF
         CALL PRDB(FTYPE,K8,NLINEE,IOE)
  100  CONTINUE
C
C  WRITE THE STATUS HEADER BLOCK.
C
      INQUIRE(UNIT=UDPROD,RECL=IPRODRECL)
      PRINT '('' IPRODRECL:'',I12)', IPRODRECL
      WRITE(UDPROD,REC=1,IOSTAT=IOS,ERR=880)STHB
      PRINT 3780, IOS
      GO TO 900

  880 PRINT 3880, IOS
      GO TO 990
C
 3010 FORMAT (/
     |        ' ','VASDR: DOCUMENTATION RECORD / DATA RECORD OFFSET ',
     |             I3/)
 3780 FORMAT (' ','VASDR: WRITE COMPLETED   IOSTAT =',I5)
 3810 FORMAT (' ','VASDR: DOCUMENTATION AND DATA RECORDS ',
     |            'DO NOT MATCH'/
     |        ' ','       RELATIVE SCAN COUNT IN ',
     |            'DOCUMENTATION RECORD ',I5/
     |        ' ','       RELATIVE SCAN COUNT IN ',
     |            'DATA RECORD          ',I5/)
 3880 FORMAT (' ','VASDR: WRITE FAILED      IOSTAT =',I5)
C
  900 CALL CLOSERFM (0)
      CALL exit_(0)
C
C  ERROR HANDLING
C
  910 CALL CLOSERFM (910)
      CLOSE (UMPAR2)
      WRITE (UMPAR2,'(I3)') IOS
      CALL exit_(91)
C
  920 CALL CLOSERFM (920)
      CLOSE (UMPAR2)
      WRITE (UMPAR2,'(I3)') IOS
      CALL exit_(92)
C
  930 CALL CLOSERFM (930)
      CLOSE (UMPAR2)
      WRITE (UMPAR2,'(I3)') IOS
      CALL exit_(93)
C
  940 CALL CLOSERFM (940)
      CLOSE (UMPAR2)
      WRITE (UMPAR2,'(I3)') IOS
      CALL exit_(94)
C
  950 CALL CLOSERFM (950)
      CLOSE (UMPAR2)
      WRITE (UMPAR2,'(I3)') IOS
      CALL exit_(95)
C
  960 CALL CLOSERFM (960)
      CLOSE (UMPAR2)
      WRITE (UMPAR2,'(I3)') IOS
      CALL exit_(96)
C
  970 CALL CLOSERFM (970)
      CLOSE (UMPAR2)
      WRITE (UMPAR2,'(I3)') IOS
      CALL exit_(97)
C
  980 CALL CLOSERFM (980)
      CLOSE (UMPAR2)
      WRITE (UMPAR2,'(I3)') IOS
      CALL exit_(98)
C
  990 CALL CLOSERFM (990)
      CLOSE (UMPAR2)
      WRITE (UMPAR2,'(I3)') IOS
      CALL exit_(99)
C
      END
