      PROGRAM VIS4KM
                                                                                
      CHARACTER*26292 IBUF
      CHARACTER*1 IBUF_C1(26292)
      EQUIVALENCE (IBUF_C1(1),IBUF)

      CHARACTER*12950 OBUF
      CHARACTER*1 OBUF_C1(12950) ! (5/4)*2590*4 = 12950
      EQUIVALENCE (OBUF_C1(1),OBUF)

      INTEGER*4 MBUF(5326)
      INTEGER IRECL,ORECL,NEXTREC,LASTREC,NPIX4KM,CRCLOC,IWORK,MASK             
      INTEGER IREC, OREC
      INTEGER*2 BEGSCAN,ENDSCAN,BEGOREC,ENDOREC,RISCT,LPIXLS,LWORDS
      INTEGER*2 BEG_REL_SCAN,END_REL_SCAN
      INTEGER UAN,UINGEST,UVIS4KM,UFILEN
      INTEGER UMPAR2
      CHARACTER*30 FILEN
      CHARACTER*80 PATHN

      CHARACTER*100 INGREC_C
      INTEGER*2 INGREC(50)
      EQUIVALENCE (INGREC(1),INGREC_C(1:1))
      EQUIVALENCE (INGREC_C(1:1),IBUF)

      DATA UAN     /10/
      DATA UINGEST /11/
      DATA UVIS4KM /12/
      DATA UFILEN  /20/
      DATA MASK /Z000FFFFF/
                                                                                
                                                                                
C OPEN INPUT FILE                                                               

      OPEN(UINGEST,STATUS='OLD',ACTION='READ')
      INQUIRE(UINGEST,RECL=IRECL)
      CLOSE(UINGEST)
      OPEN(UINGEST,STATUS='OLD',ACCESS='DIRECT',FORM='UNFORMATTED',
     +     RECL=IRECL,ACTION='READ')
      PRINT '('' UNIT ='',I3,3x,'' RECL ='',I11)', UINGEST,IRECL
                                                                                
C READ HEADER RECORD TO DETERMINE THE RECORD LENGTH

      READ(UINGEST,REC=1,ERR=940,IOSTAT=IOS)INGREC
      PRINT 3010, INGREC_C(01:44)
 3010 FORMAT (' ',A44)
      IRECL = INGREC(44)
      PRINT '('' UNIT ='',I3,3x,'' RECL ='',I11)', UINGEST,IRECL
      CLOSE(UINGEST)

C REOPEN INPUT FILE

      OPEN(UINGEST,STATUS='OLD',ACCESS='DIRECT',FORM='UNFORMATTED',
     +     RECL=IRECL,ACTION='READ')

C READ HEADER RECORD TO DETERMINE THE RECORD NUMBER OF THE FIRST AND
C LAST SCANS IN THE DATASET                                                     

      READ(UINGEST,REC=1) IBUF(1:IRECL)
      READ(IBUF(67:68),'(A2)') BEGSCAN                                          
      READ(IBUF(83:84),'(A2)') ENDSCAN                                          
      BEGSCAN = IABS(BEGSCAN)
      PRINT 3020, BEGSCAN,ENDSCAN
 3020 FORMAT   (' BEGSCAN,ENDSCAN ',3I7)

      READ(IBUF(65:66),'(A2)') BEG_REL_SCAN                                          
      READ(IBUF(81:82),'(A2)') END_REL_SCAN                                          
      PRINT 3025, BEG_REL_SCAN,END_REL_SCAN
 3025 FORMAT   (' BEG REL SCAN,END REL SCAN ',3I7)
                                                                                
C COPY HEADER RECORD FOR OUTPUT FILE (DON'T KNOW ACTUAL RECORD LENGTH           
C OF OUTPUT FILE YET)                                                           
                                                                                
      OBUF(1:6657)=IBUF(1:6657)                                                 
      OBUF(5:7)='V4K'
      WRITE (UFILEN,3030) OBUF(1:30)
      PRINT         3035, OBUF(1:30)
 3030 FORMAT ($,A30)
 3035 FORMAT (' ',A30)     
      FILEN=OBUF(1:30)
      CALL BPATHN(UAN,FILEN,PATHN)
                                                                                
C THE FIRST SCAN IS A PARTIAL SCAN, SO SKIP OVER IT                             
                                                                                
      NEXTREC=2                                                              
                                                                                
C THE LAST SCAN IS ALSO A PARTIAL SCAN, SO DO NOT PROCESS IT     
                              
      LASTREC=ENDSCAN+7                                                         

      PRINT 3040, NEXTREC,LASTREC
 3040 FORMAT (' NEXTREC,LASTREC ',2I7)

C READ FIRST RECORD TO DETERMINE NUMBER OF PIXELS IN THE DETECTOR               
C RECORDS OF THIS DATASET                                                       
                                                                                
      READ(UINGEST,REC=NEXTREC) IBUF(1:IRECL)                                        
      READ(IBUF(97:100),'(A4)') IWORK                                           
      RISCT=IAND(ISHFT(IWORK,-10),MASK)                                         
      READ(IBUF(102:105),'(A4)') IWORK                                          
      LPIXLS=IAND(ISHFT(IWORK,-10),MASK)                                        
      READ(IBUF(104:107),'(A4)') IWORK                                          
      LWORDS=IAND(ISHFT(IWORK,-6),MASK)                                         
      NPIX4KM=(LPIXLS+3)/4                                                      
      CRCLOC=(LWORDS*10)/8+91                                                   
      ORECL=(NPIX4KM*10.0)/8+112.75                                             
                                                                                
      PRINT 3050, RISCT              
      PRINT 3060, LPIXLS,LWORDS      
      PRINT 3070, NPIX4KM,CRCLOC     
      PRINT 3080, ORECL

 3050 FORMAT (' RISCT           ',7x,I7)
 3060 FORMAT (' LPIXLS,LWORDS   ',2I7)
 3070 FORMAT (' NPIX4KM,CRCLOC  ',2I7)
 3080 FORMAT (' ORECL           ',7X,I7)

C UPDATE HEADER RECORD FOR OUTPUT FILE                                          
                                                                                
CCCCC WRITE(OBUF(65:66),'(A2)') RISCT                                           
      BEGOREC=2                                                                 
CCCCC
CCCCC WRITE(OBUF(67:68),'(A2)') BEGOREC                                         
CCCCC WRITE(OBUF(85:88),'(A4)') ORECL                                           
                                                                                
C OPEN OUTPUT FILE AND WRITE HEADER RECORD                                      
                                                                                
CCCCC OPEN(UVIS4KM,FILE=PATHN,STATUS='UNKNOWN',
CCCCC
CCCCC OREC=1
CCCCC WRITE(UVIS4KM,REC=OREC) (OBUF_C1(I),I=1,ORECL)
CCCCC                                              
      ENDOREC=1                                                                 
                                                                                
   10 OBUF(1:12950)=IBUF(1:12950)

      OREC=OREC+1
      OBUF(ORECL-1:ORECL)=IBUF(CRCLOC:CRCLOC+1)                                 
CCCCC WRITE(UVIS4KM,REC=OREC) (OBUF_C1(I),I=1,ORECL)
      CALL GBYTES (OBUF(1:1),MBUF,00,08,0,90)
      LD1 = MBUF(01)
      LD2 = MBUF(31)
      LD3 = MBUF(61)
      CALL GBYTES (OBUF(1:1),MBUF,00,10,0,2590)
      LIDET  = MBUF(76)
      IDATA1 = MBUF(2588)
      IDATA2 = MBUF(2589)
      IDATA3 = MBUF(2590)
      CALL GBYTES (OBUF(1:1),MBUF,10,20,0,43)
      RISCT  = MBUF(39)  
      LPIXLS = MBUF(41)
      PRINT 3090,
     +   NEXTREC,OREC,LD1,LD2,LD3,LIDET,RISCT,IDATA1,IDATA2,IDATA3
 3090 FORMAT (' ',
     +  'REC,DATAREC,LD1,LD2,LD3,LIDET,RISCT,IDATA1,IDATA2,IDATA3',
     +   2I6,1X,4I3,4I6)
      ENDOREC=ENDOREC+1                                                         
                                                                                
C SAMPLE NEXT RECORD                                                            

CCCCC PRINT 3110, NEXTREC
C3110 FORMAT (' RECORD ',I7)
      NEXTREC=NEXTREC+1                                                         
      IF(NEXTREC .GT. LASTREC) GO TO 30
      READ(UINGEST,REC=NEXTREC) IBUF(1:IRECL)
      READ(IBUF(97:100),'(A4)') IWORK                                           
      RISCT=IAND(ISHFT(IWORK,-10),MASK)                                         
      GO TO 10                                                                  
                                                                                
C UPDATE INFO IN HEADER RECORD                                                  
                                                                                
   30 CLOSE(UVIS4KM)                                                                 
      OPEN(UVIS4KM,FILE=PATHN,ACCESS='DIRECT',
     +     FORM='UNFORMATTED',RECL=ORECL,ACTION='READWRITE')

CCCCC READ(UVIS4KM,REC=OREC) (OBUF_C1(I),I=1,ORECL)                           
CCCCC WRITE(OBUF(81:82),'(A2)') RISCT                                           
CCCCC WRITE(OBUF(83:84),'(A2)') ENDOREC-1                                       
CCCCC WRITE(UVIS4KM,REC=OREC) (OBUF_C1(I),I=1,ORECL)                           
                                                                                
      CLOSE(UINGEST)                                                                 
CCCCC CLOSE(UVIS4KM)
      GO TO 990

  930 CALL CLOSEV4 (930)
      CLOSE (UMPAR2)
      WRITE (UMPAR2,'(I3)') IOS
      CALL exit_(93)

  940 CALL CLOSEV4 (940)
      CLOSE (UMPAR2)
      WRITE (UMPAR2,'(I3)') IOS
      CALL exit_(94)

  990 STOP
      END
      SUBROUTINE CLOSEV4 (N)
      RETURN
      END
