      SUBROUTINE WLINE (KREQ,ABUF,KBUFDC,KBUF,M,IX,NLINE,NLINEE,IOE)
C***********************************************************************
C
C   NAME- WLINE     PDS MEMBER NAME- B3WLINE
C
C   LANGUAGE- VS FORTRAN  TYPE- SUBROUTINE
C
C   VERSION-  0.00  DATE- 09/19/88  PROGRAMMER- SCHREITZ, R.  SF1300
C   VERSION-  0.00  DATE- 04/15/94  PROGRAMMER- SCHREITZ, R.  EC1300
C   VERSION-  0.00  DATE- 12/19/95  PROGRAMMER- SCHREITZ, R.  EC1300
C   VERSION-  1.10  DATE- 05/19/03  PROGRAMMER- SCHREITZ, R.  EC1300
C                   EVOLUTIONARY NAME CHANGES.
C                   REVISION TO ACCOMMODATE THE FOLLOWING IMAGERY:
C                   4 KM X 4 KM CHANNEL 3 DATA FROM GOES-M AND BEYOND
C                   4 KM X 4 KM CHANNEL 6 DATA FROM GOES-O AND BEYOND.
C   VERSION:  2.00  DATE- 08/19/03  PROGRAMMER- SCHREITZ, R.  EC1300
C                   TRANSFER OF INITIALIZATION LOGIC TO A NEW
C                   SUBROUTINE, SUBROUTINE WLINEI.
C   VERSION-  2.00  DATE- 08/29/06  PROGRAMMER- SCHREITZ, R.  EC2200
C                   REMOVAL OF FAX/WEFAX PROCESSING, CONVERSION TO AIX,
C                   MODERNIZATION AND/OR SIMPLIFICATION OF LOGIC.
C
C   FUNCTION-
C
C     WRITES A LINE IN THE MULTISPECTRAL GEOSTATIONARY IMAGER
C     DATABASE.
C
C     UP TO EIGHT FRAMES CAN BE CONSTRUCTED SIMULTANEOUSLY.
C     A SEPARATE BUFFER MUST BE PROVIDED FOR EACH FRAME.
C     THE RESPECTIVE SPACE REQUIREMENTS FOR THESE BUFFERS ARE
C     AS FOLLOWS-
C
C                 DATA TYPE           BUFFER SIZE
C
C            GOES-8 4 KM VISIBLE     211275 BYTES
C            GOES-8 4 KM INFRARED    211275 BYTES
C
C     SPACE REQUIREMENTS FOR DATA TYPES NOT LISTED CAN BE FOUND IN
C     IN COMMON AREA FRAME IN BLOCK DATA ZBLOCK.
C
C   CALLING SEQUENCE PARAMETERS-
C
C     KREQ    I*4       POINTER - INDICATES REQUEST   (1 - 8)
C                       ALSO USED AS AN OFFSET FROM KUN TO INDICATE
C                       THE UNIT NUMBER TO BE ASSOCIATED WITH THE DATA
C                       SET RESERVED FOR THE DATABASE PRODUCT
C                       (SET TO PERMANENTLY TO 1 FOR THIS PROGRAM)
C     ABUF    C*1       BUFFER FOR FRAME (KFR,KREQ)
C                       (SPACE FOR NBZBUF PHYSICAL MACROBLOCKS)
                        CHARACTER*1 ABUF(211275)
C     KBUFDC  L*1       SCAN DOCUMENTATION (PROVIDED BY USER)
C                       (150 1-BYTE WORDS)
                        LOGICAL*1 KBUFDC(1)
C     KBUF    L*1       LINE (PROVIDED BY USER)
C                       (M IX-BYTE WORDS)
                        LOGICAL*1 KBUF(1)
C     M       I*4       NUMBER OF DATA WORDS IN KBUF
C     IX      I*4       WORD SIZE IN BYTES OF DATA WORDS IN KBUF
C                       (1, 2, OR 4)
C     NLINE   I*4       NUMBER OF THE LINE TO BE WRITTEN
C     NLINEE  I*4       ERROR CODE - A NEGATIVE VALUE INDICATES
C                       THAT THE NUMBER OF THE LINE TO BE WRITTEN
C                       IS OUT OF RANGE
C     IOE     I*4       ERROR CODE - A NEGATIVE NUMBER INDICATES
C                       THAT AN ATTEMPTED READ OR WRITE WAS NOT
C                       SUCCESSFULLY COMPLETED
                                                                  EJECT
C   COMMON AREA PARAMETERS-
C
C   LOCAL PARAMETERS-
C
C     KFR     I*4       POINTER - INDICATES FRAME     (1 - 2)
C                       IN THIS APPLICATION, KFR WILL BE SET TO 1.
C     KBUFDC0 L*1       SCAN DOCUMENTATION (PROVIDED BY USER)
C                       (150 1-BYTE WORDS)
                        LOGICAL*1 KBUFDC0(150)
C     KBUF0   I*2       LINE (PROVIDED BY USER)
C                       (M IX-BYTE WORDS)
                        INTEGER*2 KBUF0(11000)
C     IOPT    I*4       OPTIONS (TO BE DEFINED)
                        DIMENSION IOPT(4)
C     KF      I*4       REQUESTED FRAME ATTRIBUTE SET
C     NB      I*4       NUMBER OF BLOCKS / FRAME
C     NR      I*4       NUMBER OF RECORDS / BLOCK
C     NL      I*4       NUMBER OF LINES / RECORD
C     N1      I*4       INTEGER CONSTANT '1'
C     IDC     I*4       HORIZONTAL COORDINATE, IN THE DISK IMAGE,
C                       OF THE CENTER OF THE LINE
C                       (I = 1 REFERS TO THE LEFTMOST COLUMN)
C     JDC     I*4       VERTICAL COORDINATE, IN THE DISK IMAGE,
C                       OF THE LINE
C                       (J = 1 REFERS TO THE UPPERMOST ROW)
C
C   SUBPROGRAMS CALLED- ZRWA
C
C   EXIT STATES- SEE CALLING SEQUENCE PARAMETERS NLINE, NLINEE
C
C   RESTRICTIONS- SEE FUNCTION
C
C***********************************************************************
                                                                  EJECT
      DATA KFR/1/
      DATA IOPT/4*0/
      DATA N1/1/
C
C
C     COMPUTE CENTER OF LINE AND POSITION OF LINE IN DATA BASE.
      IDC = (M/2) + 1
      JDC = NLINE
C
CCCCC PRINT 3710,  NLINE
C3710 FORMAT ('    NLINE'/' ',I8/)
C
C     WRITE LINE.
      CALL ZRWA (KREQ,KFR,ABUF,KBUFDC,KBUF,M,N1,IX,IDC,JDC,IOPT,
     1           NLINEE,IOE)
      RETURN
C
      END
