      SUBROUTINE WLINEI (KUNDP,INGTYP,SID0,LL,STAT,IOS)
C***********************************************************************
C
C   NAME- WLINEI
C
C   LANGUAGE- VS FORT     TYPE- SUBROUTINE
C
C   VERSION-  2.00  DATE- 08/19/03  PROGRAMMER- SCHREITZ, R.  EC1300
C   VERSION-  2.00  DATE- 08/29/06  PROGRAMMER- SCHREITZ, R.  EC2200
C                   REMOVAL OF FAX/WEFAX PROCESSING, CONVERSION TO AIX,
C                   MODERNIZATION AND/OR SIMPLIFICATION OF LOGIC.
C   VERSION-  4.04  DATE- 01/30/12  PROGRAMMER- SCHREITZ, R.  EC2200
C                   INTRODUCTION OF A SECOND PARAMETER FOR SATELLITE
C                   POSITION, SPOS_BASIC, THAT HAS THE VALUE 
C                   'EAST' OR 'WEST' IF THE PRIMARY PARAMETER FOR 
C                   SATELLITE POSITION, SPOS, CONTAINS THE VALUE 
C                   'EAST' OR 'WEST'. 
C   FUNCTION-
C
C     PERFORMS INITIALIZATION FOR SUBROUTINE WLINE.
C
C     SUBROUTINE WLINE USES AN EXTERNAL DATABASE WRITER/LOCATOR/READER
C     TO CONSTRUCT THE DESIRED DATABASE PRODUCT.
C
C   FILES-
C
C     KUN          I--  SATELLITE ASSIGNMENT TABLE
C
C   CALLING SEQUENCE PARAMETERS-
C
C     KUNDP   I*4  I--  UNIT NUMBER FOR THE DATABASE PRODUCT TO BE
C                       PRODUCED
C     INGTYP  C*4  I--  INGEST TYPE
C
C                          ('IR4F','IR4N',...)
C
                        CHARACTER*4 INGTYP
C     SID0    C*2  I--  SATELLITE ID (PRE-LAUNCH)
C
C                          ('GI','GJ','GK',...)
C
                        CHARACTER*2 SID0
C     LL      I*4  -O-  LINE LENGTH
C     STAT    I*4  -O-  LAST VALUE OF STATUS: 0 OR 97 OR 98
                        INTEGER*4 STAT
C     IOS     I*4  -O-  LAST VALUE OF IOSTAT, THE IO STATUS AFTER
C                       OPENING OR ATTEMPTING TO OPEN OR
C                       WRITING OR ATTEMPTING TO WRITE
C                       THE PRODUCT FILE
C
C   COMMON AREA PARAMETERS-
C
      INCLUDE 'rconst.i'
      INCLUDE 'statushb.i'
      INCLUDE 'pos.i'
      INCLUDE 'sat.i'
      INCLUDE 'vhres.i'
      INCLUDE 'req.i'
      INCLUDE 'reqfr.i'
      INCLUDE 'lform.i'
      INCLUDE 'pform.i'
      INCLUDE 'kfstar.i'
      INCLUDE 'lb.i'
      INCLUDE 'iomode.i'
      INCLUDE 'vsfio.i'
      INCLUDE 'iostat.i'
      INCLUDE 'idoc.i'
      INCLUDE 'kdocij.i'
      INCLUDE 'db.i'
      INCLUDE 'ab211275.i'
      INCLUDE 'dsnbuf.i'
      INCLUDE 'dsn.i'
C   KEY LOCAL PARAMETERS-
C
C     SID     C*2  -O-  SATELLITE ID (POST-LAUNCH)
C
C                          ('G08','G09','G10',...)
C
                        CHARACTER*3 SID
C     NSID    I*4       NUMERICAL SATELLITE ID
C
C                          (   8,    9,   10 ,...)
C
                        INTEGER*4 NSID
C     SPOS    C*12      POSITION
C
C                          ('EAST','WEST','NEW ','S AM',...)
C
                        CHARACTER*4 SPOS
C     KREQ    I*4       POINTER - INDICATES DATABASE PRODUCT     (1 - 8)
C                       ALSO USED AS AN OFFSET FROM KUN TO INDICATE
C                       THE UNIT NUMBER TO BE ASSOCIATED WITH THE DATA
C                       SET RESERVED FOR THE DATABASE PRODUCT
C                       (SET TO PERMANENTLY TO 1 FOR THIS PROGRAM)
C     KREQUN  I*4       UNIT NUMBER TO BE ASSOCIATED WITH THE DATA
C                       SET RESERVED FOR THE DATABASE PRODUCT
C     KFR     I*4       POINTER - INDICATES FRAME     (1 - 2)
C                       IN THIS APPLICATION, KFR WILL BE SET TO 1.
C     KOFFSET           SATELLITE-SPECIFIC START TIME OFFSET,
C                       IN MINUTES
C     REQUEST C*9       NOMINAL START TIME IN LOCATOR/READER REQUEST
C                       FORMAT
                        CHARACTER*9 REQUEST
C     SD      L*1       SCAN DOCUMENTATION (PROVIDED BY USER)
C                       (150 1-BYTE WORDS)
                        BYTE SD(150)
C     ZFF     C*1       EIGHT-BIT BYTE CONTAINING ALL 1'S
                        BYTE ZFF
C     KF      I*4       REQUESTED FRAME ATTRIBUTE SET
C     NB      I*4       NUMBER OF BLOCKS / FRAME
C     NR      I*4       NUMBER OF RECORDS / BLOCK
C     NL      I*4       NUMBER OF LINES / RECORD
C     GEOFILE C*80      FRAME NAME
                        CHARACTER*80 GEOFILE
C     SPOS_FIELD    SATELLITE POSITION FIELD 
                    CHARACTER*12 SPOS_FIELD 
C     SPOS_BASIC    BASIC SATELLITE POSITION
C                   'EAST' IF SATELLITE POSITION FIELD CONTAINS 'EAST'
C                   'WEST' IF SATELLITE POSITION FIELD CONTAINS 'WEST'   
                    CHARACTER*4  SPOS_BASIC
C
C***********************************************************************
      DATA KREQ/1/
      DATA KFR/1/
      DATA KSER/7/
      DATA ZFF/255/
      DATA KPOS/0/,KSAT/0/
      DATA GEOFILE/
     X'                                                                 
     X               '/
CCC   DATA IZ41,IZ5A/Z41,Z5A/
CCC   DATA IZ20     /Z20/
C
      STAT = 0
C
C     SET THE PRIMARY UNIT NUMBER AND THE UNIT NUMBER FOR THE LOGICAL
C     AND PHYSICAL FORMATS.
C
C        THE DEFAULT SETTINGS FOR KUN, THE PRIMARY UNIT NUMBER, AND
C        KUNLPF, THE UNIT NUMBER FOR THE LOGICAL AND PHYSICAL FORMATS,
C        ARE 80 AND 90, RESPECTIVELY, AND IN THIS APPLICATION THEY ARE
C        NOT RESET.
C
C     PRINT '('' KUN, KUNLPF : '',2I5)', KUN, KUNLPF
      KUN    = 80
      KUNLPF = 90
C
C     READ THE SATELLITE ASSIGNMENT TABLE.
      CALL ZRSCT
C
C     DETERMINE THE 'POSITION' AND 'SATELLITE' INDICES KPOS AND KSAT
C     FOR WRITER/LOCATOR/READER ARRAYS POS AND SAT.
C
C     DETERMINE THE POSITION INDEX USING THE PRE-LAUNCH SATELLITE ID.
   10 DO K = 1,KPOSMX
         IF (SID0.EQ.POS(K)(35:36)) THEN
            KPOS = K
            GO TO 20
         END IF
      END DO
      KPOS = 0
      STAT = 70
      GO TO 990
C
C     RETRIEVE THE POST-LAUNCH SATELLITE ID.
   20 SID = POS(KPOS)(39:41)
C
C     DETERMINE THE NUMERICAL SATELLITE ID.
      READ (SID(2:3),'(I2)') NSID
      PRINT 9010, SID,NSID
 9010 FORMAT (' SID    ',1X,A3,5X,' NSID   ',I4)
C
C     DETERMINE THE SATELLITE INDEX.
      DO K = 1,KSATMX
         IF (SID.EQ.SAT(K)(1:3)) THEN
            KSAT = K
            GO TO 100
         END IF
      END DO
      KSAT = 0
      STAT = 70
      GO TO 990
C
  100 PRINT 9020, KPOS,KSAT
 9020 FORMAT (' KPOS   ',I4,5X,' KSAT   ',I4)
C
C     READ THE TABLE OF VERTICAL (N-S) AND HORIZONTAL (E-W) RESOLUTIONS
C     AND THE TABLE OF LOGICAL AND PHYSICAL FRAME FORMAT DESCRIPTORS
C     (BOTH REQUIRED BY THE WRITER/LOCATOR/READER).
      CALL ZRRLPF
C
      SPOS       = POS(KPOS)(05:08)
      SPOS_FIELD = POS(KPOS)(05:16)

C     IF THE SATELLITE POSITION 'EAST' OR 'WEST' IS EMBEDDED ANYWHERE 
C     IN THE SATELLITE POSITION FIELD SPOS, EXTRACT IT AND STORE IT IN 
C     SPOS_BASIC.  THIS WILL ALLOW THE USER TO SPECIFY, FOR EXAMPLE, 
C     'EAST' AND 'NEW EAST' AS SEPARATE ENTRIES IN THE SATELLITE 
C     CONSTELLATION TABLE WHEN THE CURRENT EAST SATELLITE IS BEING 
C     REPLACED BY A NEW EAST SATELLITE.  IN SUCH CIRCUMSTANCES, 
C     THE FIRST LETTER OF SPOS CAN BE USED WHEN IT IS NECESSARY TO 
C     DISTINGUISH BETWEEN THE TWO SATELLITES AND THE FIRST LETTER OF 
C     SPOS_BASIC CAN BE USED WHEN IT IS NOT.  
      SPOS_BASIC = SPOS
      IXE = INDEX(SPOS_FIELD,'EAST')
      IF (IXE.NE.0) SPOS_BASIC = 'EAST' 
      IXW = INDEX(SPOS_FIELD,'WEST')
      IF (IXW.NE.0) SPOS_BASIC = 'WEST'

C     SET THE FRAME FORMAT POINTER (KF) TO INDICATE THE FRAME FORMAT
C     TO BE USED FOR THE DATABASE PRODUCT TO BE BUILT.
      KF = KFRAME (NSID,SPOS_BASIC,INGTYP)
      PRINT 9030, SPOS_BASIC,INGTYP,KF
 9030 FORMAT (' SPOS   ',A4,5X,' INGTYP ',A4,5X,' KF   ',I2/)
C
C     SEND THE POSITION, SATELLITE, SERIES, AND FRAME FORMAT INDEX
C     TO THE WRITER/LOCATOR/READER.
      IPOS(KREQ) = KPOS
      ISAT(KREQ) = KSAT
      ISER(KREQ) = KSER
      IFRAME(KFR,KREQ) = KF
      KFS(KFR,KREQ)    = KF
C
C     SEND THE NUMBER OF FRAMES PER CYCLE TO THE WRITER/LOCATOR/READER.
C     THE WRITER/LOCATOR/READER.
      IFRZCYC(KREQ) = 1
C
C     RETRIEVE THE NUMBER OF SAMPLES TO BE PLACED ON EACH LINE AND
C     SEND TO THE CALLING PROGRAM.
      LL = LLILW(KF)
C
C     SEND THE PHYSICAL BLOCK SIZE TO THE WRITER/LOCATOR/READER.
      ILEN(KFR,KREQ) = NBYZPB(KF)
C
      IYYYY = STHB(213)
      IDDD  = STHB(214)
      IHH   = STHB(215)
      IMM   = STHB(216)
C
C     COMPUTE THE NOMINAL START TIME.
      READ (POS(KPOS)(43:46),'(I4)') KOFFSET
      KESA = -2
      CALL CNOMST (IHH,IMM,KOFFSET,KESA,REQUEST)
C
C     READ THE TABLE OF SKELETAL FRAME NAMES.
      CALL ZRDSND
C
C     BUILD THE FRAME NAME.
      KGXOX = 1
      DSN1 = DSNBUF(KGXOX)
      KFIRST = 1
      CALL ZBFNAME (KFIRST,KSAT,KF,REQUEST,IYYYY,IDDD,IHH,IMM,IE)
C
C     COPY THE FRAME NAME INTO THE FRAME NAME BUFFER.
      CALL XMOVEX (GEOFILE(1:80),DSN1,80)
C
      PRINT 9310, GEOFILE
 9310 FORMAT (' FRAME NAME - ',A80)
C
C     PASS THE HOUR AND MINUTE TO THE SCRIPT.
      IXT = INDEX(GEOFILE,'.T')
      WRITE (UDPHM, '(A)') GEOFILE(IXT+2:IXT+5)

C     PASS THE PATH NAME TO THE SCRIPT.
      IXE = INDEX(GEOFILE,' ')
C     IXE = IXE - 1
 
      WRITE (UDPPNI,'(A)') GEOFILE(1:IXE)
 
C     PASS THE FILE NAME TO THE SCRIPT.
      IXD = INDEX(GEOFILE,'.S')
      IXD = IXD - 6
      IXE = INDEX(GEOFILE,' ')
C     IXE = IXE - 1
      WRITE (UDPFNI,'(A)') GEOFILE(IXD:IXE)
 
C     OPEN THE UNIT TO BE USED FOR THE PRODUCT.
      KREQUN = KREQ + KUN
      OPEN (UNIT=KREQUN,FILE=GEOFILE,ERR=970,STATUS='REPLACE',
     1ACCESS='DIRECT',IOSTAT=IFRIOS(KFR,KREQ),RECL=ILEN(KFR,KREQ))
      IF (IFRIOS(KFR,KREQ).NE.0) PRINT 3970, KREQUN,IFRIOS(KFR,KREQ)
C
C     SET THE I/O MODE PARAMETERS FOR DIRECT ACCESS WRITE WITH
C     MONOTONIC RECORD NUMBERS.
      KRWA = 2
      KRES = 0
      KWES = 1
C
C     RE-DEFINE THE UPPER LIMIT OF THE DATABASE FRAME.
      KFGDBL(KFR,KREQ) = 1
      PRINT 9710, KFGDBL(1,1)
C
C     RE-DEFINE THE LOWER LIMIT OF THE DATABASE FRAME.
      NL = NLIZSC(KF)
      NR = NLRZLB(KF)
      NB = NPMZF(KF)
      KVC = NL * NR * NB
      VRAZVR = VRESA(KSER)/VRES(KF)
      KLGDBL(KFR,KREQ) = KVC + (KJADJ(KFR,KREQ) * VRAZVR)
      PRINT 9720, KLGDBL(1,1)
C
C     RE-DEFINE THE LEFT LIMIT OF THE DATABASE FRAME.
      KFDBE(KFR,KREQ) = 1
      PRINT 9730, KFDBE(1,1)
C
C     RE-DEFINE THE RIGHT LIMIT OF THE DATABASE FRAME.
      KHC = LLILW(KF)
      HRAZHR = HRESA(KSER)/HRES(KF)
      KLDBE(KFR,KREQ) = KHC + (KIADJ(KFR,KREQ) * HRAZHR)
      PRINT 9740, KLDBE(1,1)
C
      PRINT 9750, KJADJ(1,1)
      PRINT 9760, KIADJ(1,1)
C
C     ENGAGE THE DEDICATED BUFFER OPTION TO ALLOW USE OF SEPARATE
C     BUFFERS FOR EACH PICTURE.
      KD = 1
C
C     PREFORMAT THE IMAGE DATA SET.
      DO I = 1,150
         SD(I) = ZFF
      END DO
CCCCC PRINT 9190, (SD(I),I=1,150)
C9190 FORMAT (' ',50Z2)
      DO I = 1,22000
         LINEBUF(I) = 1023
      END DO
      LINELEN = LL
      IX = 2
      NLINEMX = NLIZSC(KF)*NLRZLB(KF)*NPMZF(KF)
      DO NLINE = 1,NLINEMX
         CALL WLINE (KREQ,ABUF,SD,LINEBUF,LINELEN,IX,NLINE,
     *               NLINEE,IOE)
         IF (NLINEE.LT.0) GO TO 810
         IF (IOE.LT.0) GO TO 980
      END DO
C
C     RESET THE I/O MODE PARAMETERS FOR DIRECT ACCESS WRITE WITH
C     NON-MONOTONIC RECORD NUMBERS.
      KRES = 1
C
      GO TO 990
C
  810 PRINT 3810, NLINE,NLINEE
      GO TO 990

  970 PRINT 3970, KREQUN,IFRIOS(KFR,KREQ)
      STAT = 97
      IOS = IFRIOS(KFR,KREQ)
      GO TO 990
  980 PRINT 3980, KREQUN,NLINE,IOE
      STAT = 98
      IOS = IOE
C
  990 RETURN
C
 9710 FORMAT ('   KFGDBL(1,1)   ',I6)
 9720 FORMAT ('   KLGDBL(1,1)   ',I6)
 9730 FORMAT ('   KLDBE(1,1)    ',I6)
 9740 FORMAT ('   KLDBE(1,1)    ',I6)
 9750 FORMAT ('   KJADJ(1,1)    ',I6)
 9760 FORMAT ('   KIADJ(1,1)    ',I6)
 3810 FORMAT (' WLINEI: NLINE =',I5,3X,'NLINEE =',I4)
 3970 FORMAT (' WLINEI: UNIT',I3,' COULD NOT BE OPENED',
     *        '   IOS =',I4)
 3980 FORMAT (' WLINEI: UNIT',I3,': LINE',I5,' COULD NOT BE WRITTEN',
     *        '   IOS =',I4)
      END
